#!/usr/bin/python
# -*-coding:utf-8-*-
# coding: iso-8859-15

import json
import os
from xml.dom.minidom import getDOMImplementation
from common_utils import manager, update


def alarm_get():

    re_alarm_info = {}
    alarm_info = manager.xml_nodes["cib"].getElementsByTagName("alarmd")[0]
    if alarm_info is None or alarm_info == []:
        re_alarm_info = {}
        re_alarm_info["flag"] = False
        re_alarm_info["smtp"] = ""
        re_alarm_info["port"] = ""
        re_alarm_info["sender"] = ""
        re_alarm_info["password"] = ""
        re_alarm_info["receiver"] = []
        return json.dumps({'action': True, 'data': re_alarm_info})

    try:
        alarm_email = alarm_info.getElementsByTagName("mail")[0]
        re_alarm_info = {}
        if alarm_email.getAttribute("flag") == "on":
            re_alarm_info["flag"] = True
        else:
            re_alarm_info["flag"] = False
        re_alarm_info["smtp"] = alarm_email.getAttribute("smtp")
        re_alarm_info["port"] = alarm_email.getAttribute("port")
        re_alarm_info["sender"] = alarm_email.getAttribute("sender")
       
        password_str = alarm_email.getAttribute("password") 
        # 将密码明文加密
        mail_password = ""
        cmdstr = "/usr/bin/pwd_decode " + str(password_str)
        retfile = os.popen(cmdstr, 'r')
        mail_password = retfile.readline()
        if mail_password[-1] == '\n':
            mail_password = mail_password[0:-1]
        retfile.close()

        re_alarm_info["password"] = mail_password
        re_alarm_info["receiver"] = []
        for email in alarm_email.getAttribute("receiver").split(","):
            if email != "":
                re_alarm_info["receiver"].append(email)
    except:
        re_alarm_info = {}
        re_alarm_info["flag"] = False
        re_alarm_info["smtp"] = ""
        re_alarm_info["port"] = ""
        re_alarm_info["sender"] = ""
        re_alarm_info["password"] = ""
        re_alarm_info["receiver"] = []

    return json.dumps({'action': True, 'data': re_alarm_info})


def alarm_set(item):

    impl = getDOMImplementation()
    newdoc = impl.createDocument(None, "alarmd", None)
    xml_node = newdoc.documentElement

    alarm_email = item
    if 'flag' in alarm_email:
        impl = getDOMImplementation()
        newdoc = impl.createDocument(None, "mail", None)
        mail = newdoc.documentElement
        flag = str(item['flag'])
        # 防止传递bool类型数据出现问题
        if flag == "True" or flag == "true":
            mail.setAttribute("flag", "on")
        else:
            mail.setAttribute("flag", "off")

        mail.setAttribute("smtp", item['smtp'])
        mail.setAttribute("port", str(item['port']))
        mail.setAttribute("sender", item['sender'])

        # 将密码明文加密
	mail_password = ""
        cmdstr = "/usr/bin/pwd_encode " + item['password']
        retfile = os.popen(cmdstr, 'r')
        mail_password = retfile.readline()
        if mail_password[-1] == '\n':
            mail_password = mail_password[0:-1]
        retfile.close()

        mail.setAttribute("password", mail_password)
        email_receive = item['receiver']
        alarm_email_receive = ""
        for receiver in email_receive:
            if len(alarm_email_receive) == 0:
                alarm_email_receive = receiver
            else:
                alarm_email_receive = alarm_email_receive + "," + receiver

        mail.setAttribute("receiver", str(alarm_email_receive))
        xml_node.appendChild(mail)

    xml_str = xml_node.toxml().replace("\n", "")
    manager.cib_do_cmd("cib_replace\n%s\n%s" % (str("alarmd"), str(xml_str)))

    if manager.failed_reason != "":
        return {'action': False, 'error': _(manager.failed_reason)}

    failed_reason = manager.failed_reason
    update()
    if failed_reason != "":
        return {'action': False, 'error': _(failed_reason)}
    else:
        return {'action': True, 'info': _('Set alarm success')}


def alarm_delete():

    impl = getDOMImplementation()
    newdoc = impl.createDocument(None, "alarmd", None)
    xml_node = newdoc.documentElement
    xml_str = xml_node.toxml().replace("\n", "")
    manager.cib_do_cmd("cib_replace\n%s\n%s" % (str("alarmd"), str(xml_str)))

    if manager.failed_reason != "":
        return {'action': False, 'error': _(manager.failed_reason)}

    failed_reason = manager.failed_reason
    update()

    if failed_reason != "":
        return {'action': False, 'error': _(failed_reason)}
    else:
        return {'action': True, 'info': _('Delete alarm success')}
