# -*-coding:utf-8-*-

import commands
import paramiko
import sys
import ssl
import json
from fabric.api import *
import os
from bottle import ServerAdapter
from cherrypy import wsgiserver
from cherrypy.wsgiserver.ssl_pyopenssl import pyOpenSSLAdapter
import urllib2, base64
import urllib   
from base64 import encodestring
import httplib   



sys.path.append("/usr/share/heartbeat-gui")
sys.path.append("/usr/lib64/heartbeat-gui")

from Manager import Manager

manager = Manager()

PK_PATH = "/usr/share/heartbeat-gui/ha-api/.privkey.pem"
S_PATH = "/usr/share/heartbeat-gui/ha-api/.server.pem"
S_PASS = ""

AUTH_USER = 'hacluster'
AUTH_PASSWORD = 'qwer1234QWER!@#$'

BASESTR = encodestring('%s:%s' % (AUTH_USER, AUTH_PASSWORD))[:-1]
HEADERS = {'content-type': 'application/json',
           "User-Agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/54.0.2840.99 Safari/537.36",
           "Authorization": "Basic " + BASESTR}


class Remote:
    def __init__(self, host, password):
        self.host = str(host)
        fullpath = 'root@' + self.host + ":22"
        env.passwords[fullpath] = "password"

    @staticmethod
    def __get_license_info():
        return run("python /usr/share/heartbeat-gui/ha-api/ha_license.py")

    @staticmethod
    def __service_start():
        run('systemctl start neokylinha')

    @staticmethod
    def __service_restart():
        run('systemctl restart neokylinha')

    @staticmethod
    def __service_stop():
        run('systemctl stop neokylinha')

    def service_start(self):
        execute(self.__service_start, host=self.host)

    def service_stop(self):
        execute(self.__service_stop, host=self.host)

    def service_restart(self):
        execute(self.__service_restart, host=self.host)

    def get_license_info(self):
        results = execute(self.__get_license_info, host=self.host)
        return results


class HAPublic:
    def level_init(self):
        self.level_score = []  # list(self.level_score)
        max = len(manager.get_all_nodes()) - 1
        for i in range(max):
            self.level_score.append(str(16000 - 1000 * i))

        return

    def turn_score_to_level(self, score):
        self.level_init()
        if score in ["20000"]:  # ["INFINITY", "+INFINITY", "infinity", "+infinity"]:
            return "Master Node"

        if score in ["-INFINITY", "-infinity"]:
            return ("No Run Node")

        if score not in self.level_score:
            return score
        level = 1
        for s in self.level_score:
            if s == score:
                return ("Slave %d") % (level)
            level = level + 1

        return score

    def turn_level_to_score(self, level):
        self.level_init()
        if level == "Master Node":
            return "20000"  # "INFINITY"

        if level == ("No Run Node"):
            return "-INFINITY"

        if ("Slave ") not in level:
            return level
        else:
            index = int(level[len(str("Slave ")):])
            return self.level_score[index - 1]

    def add_score(self, score1, score2):
        if score1 in ["-INFINITY", "-infinity"] or score2 in ["-INFINITY", "-infinity"]:
            return str("-INFINITY")
        if score1 in ["INFINITY", "+INFINITY", "infinity", "+infinity"] or score2 in ["INFINITY", "+INFINITY",
                                                                                      "infinity", "+infinity"]:
            return str("INFINITY")
        return str(int(score1) + int(score2))


web_manager = HAPublic()

'''
# Identify resource is login
def is_ha_login():
    if not manager.connected:
        if manager.login('127.0.0.1', "hacluster", 'qwer1234'):
            manager.update()
            return True
        else:
            return False
    else:
        # manager.process_event("evt:cib_changed")
        update()
        return True
'''

# Identify resource is login
def is_ha_login(hostip, username, password):
    # corosync 会同时启动和关闭pacemkaer, pacemaker-mgmt服务，以该进程来标识服务是否启动
    status, output = commands.getstatusoutput("systemctl status corosync")
    if status != 0:
        return False

    if not manager.connected:
        if manager.login(hostip, username, password):
            manager.update()
            return True
        else:
	    return "Busy"
    else:
        # manager.process_event("evt:cib_changed")
	# 不需要update
        update()
        return True


# Check username and password
def check_auth(username, password):
    '''if pam.authenticate(username, password):
	S_PASS = password
        return True
    else:
        return False'''

    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    try:
        ssh.connect("localhost", username=username, password=password, allow_agent=True)
        ssh.close()
        return True
    except:
        ssh.close()
        return False


def update():
    try:
        manager.process_event(None)
        # manager.process_event("evt:cib_changed")
        manager.update()
        return json.dumps({'action': True, 'info': "cib_update success"})
    except:
	manager.process_event(None)
        # manager.process_event("evt:cib_changed")
        manager.update()
        return json.dumps({'action': True, 'info': "cib_update success"})


# Set  rsc json while post a rsc
def add_rsc_json_format(data):
    newdata = {}
    id = data['id']
    newdata['primitive'] = {}

    if 'actions' in data:
        # 重新组合一下数据，满足从{actions: ["name": "start", "interval": "10"] }到{"operations": {"op": ["name": "start", "interval": "10"]}}格式转化
	operations = {}
        operations['op'] = data['actions']
        operations['id'] = id + "_operations"
        if 'op' in operations:
            ops = operations['op']
            for op in ops:
                name = op['name']
                interval = op['interval']
                op['id'] = operations['id'] + "_" + name + "_" + interval
        newdata["primitive"]["operations"] = operations

    if 'meta_attributes' in data:
        meta_attributes = data['meta_attributes']
        new_meta_attributes = {}
        new_meta_attributes['id'] = id + "_meta"
        if meta_attributes != {}:
            nvpairs = meta_attributes
            nvpair_list = []
            nvpair = {}
            for name in nvpairs.keys():
                nvpair['name'] = name
                nvpair['value'] = nvpairs[name]
                nvpair['id'] = new_meta_attributes['id'] + "_" + name
                nvpair_list.append(nvpair)
                nvpair = {}
            new_meta_attributes['nvpair'] = nvpair_list

        newdata["primitive"]["meta_attributes"] = new_meta_attributes

    if 'instance_attributes' in data:
        instance_attributes = data['instance_attributes']
        new_instance_attributes = {}
        new_instance_attributes['id'] = id + "_instance"
        if instance_attributes != {}:
            nvpairs = instance_attributes
            nvpair_list = []
            nvpair = {}
            for name in nvpairs.keys():
                nvpair['name'] = name
                nvpair['value'] = nvpairs[name]
                nvpair['id'] = new_instance_attributes['id'] + "_" + name
                nvpair_list.append(nvpair)
                nvpair = {}
            new_instance_attributes['nvpair'] = nvpair_list
        newdata["primitive"]["instance_attributes"] = new_instance_attributes

    newdata["primitive"]["class"] = data["class"]
    if data['class'] == 'ocf':
        newdata["primitive"]["provider"] = data["provider"]
    newdata["primitive"]["id"] = data["id"]
    newdata["primitive"]["type"] = data["type"]
    return newdata


# Set group rsc json while post a group rsc
'''
      {
        "category": "group",    
        "id":"tomcat_group",
        "rscs":[
            "tomcat6",
            "tomcat7"
         ],
    "meta_attributes":{
        "target-role":"Stopped"
     }
    }

    To:
    {
    "id":"tomcat_group",
    "rscs":[
        {
            "rsc_id":"tomcat6",
            "order":1
        },
        {
            "rsc_id":"tomcat7",
            "order":2
        }
      ],
     "meta_attributes":[
        {
            "name":"target-role",
            "value":"Stopped"
        }
      ]
    } 

'''


def add_group_rsc_json_format(data):
    if 'rscs' in data:
        rscs_new = []
        rsc_new = {}
        rscs = data['rscs']
        order = 1
        for rsc in rscs:
            rsc_new['rsc_id'] = rsc
            rsc_new['order'] = order
            order = order + 1
            rscs_new.append(rsc_new)
            rsc_new = {}
        data['rscs'] = rscs_new
    # 添加默认值
    if 'meta_attributes' in data:
        meta_attributes = data['meta_attributes']
        # 在添加资源时，发现没有target-role，就添加一个stopped
        if 'target-role' not in meta_attributes:
            data['meta_attributes']['target-role'] = 'Stopped'
    else:
	data['meta_attributes'] = {}
	data['meta_attributes']['target-role'] = 'Stopped'

    meta_attributes = data['meta_attributes']

    meta_list = []
    meta = {}
    for name in meta_attributes.keys():
        meta['name'] = name
        meta['value'] = meta_attributes[name]
        meta_list.append(meta)
        meta = {}
    data['meta_attributes'] = meta_list
    return data


# Set clone rsc json while post a clone rsc
def clone_rsc_json_format(data):
    # 添加默认值
    if 'meta_attributes' in data:
        meta_attributes = data['meta_attributes']
        # 在添加资源时，发现没有target-role，就添加一个stopped
        if 'target-role' not in meta_attributes:
            data['meta_attributes']['target-role'] = 'Stopped'
    else:
	data['meta_attributes'] = {}
        data['meta_attributes']['target-role'] = 'Stopped'

    meta_attributes = data['meta_attributes']   

    meta_list = []
    meta = {}
    for name in meta_attributes.keys():
        meta['name'] = name
        meta['value'] = meta_attributes[name]
        meta_list.append(meta)
        meta = {}
    data['meta_attributes'] = meta_list

    return data


# Set colocation json while post colocation
def set_colocation_format(data, rsc_id):
    same_nodes = data['same_node']
    diff_nodes = data['diff_node']
    if same_nodes != []:
        new_same_nodes = []
        for same_node in same_nodes:
            part_node = {}
            part_node["rsc"] = rsc_id
            part_node["with_rsc"] = same_node
            new_same_nodes.append(part_node)
        data['same_node'] = new_same_nodes

    if diff_nodes != []:
        new_diff_nodes = []
        for diff_node in diff_nodes:
            part_node = {}
            part_node["rsc"] = rsc_id
            part_node["with_rsc"] = diff_node
            new_diff_nodes.append(part_node)
        data['diff_node'] = new_diff_nodes

    return data


# Set order json while post order
def set_order_format(data, rsc_id):
    before_nodes = data['before_rscs']
    after_nodes = data['after_rscs']

    if before_nodes != []:
        new_before_nodes = []
        for before_node in before_nodes:
            part_node = {}
            part_node["rsc_id"] = before_node
            new_before_nodes.append(part_node)
        data['before_rscs'] = new_before_nodes

    if after_nodes != []:
        new_after_nodes = []
        for after_node in after_nodes:
            part_node = {}
            part_node["rsc_id"] = after_node
            new_after_nodes.append(part_node)
        data['after_rscs'] = new_after_nodes

    return data


# Set colocation json while get colocation
def get_colocation_format(data):
    rsc_id = data['rsc_id']
    same_nodes = data['same_node']
    diff_nodes = data['diff_node']
    if same_nodes != []:
        new_same_nodes = []
        for same_node in same_nodes:
            if same_node['rsc'] == rsc_id:
                new_same_nodes.append(same_node["with_rsc"])
            else:
                new_same_nodes.append(same_node["rsc"])
        data['same_node'] = new_same_nodes

    if diff_nodes != []:
        new_diff_nodes = []
        for diff_node in diff_nodes:
            if diff_node['rsc'] == rsc_id:
                new_diff_nodes.append(diff_node["with_rsc"])
            else:
                new_diff_nodes.append(diff_node["rsc"])
        data['diff_node'] = new_diff_nodes
    return data


# Set order json while get order
def get_order_format(data):
    rsc_id = data['rsc_id']
    before_nodes = data['before_rscs']
    after_nodes = data['after_rscs']

    if before_nodes != []:
        new_before_nodes = []
        for before_node in before_nodes:
            new_before_nodes.append(before_node['rsc_id'])
        data['before_rscs'] = new_before_nodes

    if after_nodes != []:
        new_after_nodes = []
        for after_node in after_nodes:
            new_after_nodes.append(after_node['rsc_id'])
        data['after_rscs'] = new_after_nodes
    return data


# Get rsc class,type, provider
def get_rsc_info(rsc_id):
    ret = Manager().get_rsc_info(rsc_id)
    if ret is not None:
        ret = {"class": ret[0], "type": ret[1], "provider": ret[2]}
        return ret
    return None


# Old method not use
def set_rsc_json_format(data):
    res_info = {}
    res_info['rsc_info'] = {}
    newdata = {}
    type = 1

    if 'id' in data:
        id = data['id']
        type = 2

    elif 'id' in data:
        id = data['rsc_id']
        type = 3
    else:
        id = data['id']

    rscs = []
    if 'rscs' in data:
        rscs = data['rscs']

    newdata['primitive'] = {}

    if 'operations' in data:
        operations = data['operations']
        operations['id'] = id + "_operations"
        if 'op' in operations:
            ops = operations['op']
            for op in ops:
                name = op['name']
                interval = op['interval']
                op['id'] = operations['id'] + "_" + name + "_" + interval
        newdata["primitive"]["operations"] = data["operations"]

    if 'meta_attributes' in data:
        meta_attributes = data['meta_attributes']
        new_meta_attributes = {}
        if type == 3:
            new_meta_attributes['id'] = id + "_meta_attributes"
        if type == 2:
            new_meta_attributes['id'] = id + "_meta"
        if type == 1:
            new_meta_attributes['id'] = id + "_meta"

        if meta_attributes != {}:
            nvpairs = meta_attributes
            nvpair_list = []
            nvpair = {}
            for name in nvpairs.keys():
                nvpair['name'] = name
                nvpair['value'] = nvpairs[name]
                if type == 2:
                    nvpair['id'] = new_meta_attributes['id'] + "_" + str(nvpair['value'])
                else:
                    nvpair['id'] = new_meta_attributes['id'] + "_" + name
                nvpair_list.append(nvpair)
                nvpair = {}
            new_meta_attributes['nvpair'] = nvpair_list
            newdata["meta_attributes"] = new_meta_attributes
    else:
        meta_attributes = data['meta_attributes']
        new_meta_attributes = {}
        if type == 3:
            new_meta_attributes['id'] = id + "_meta_attributes"
        if type == 2:
            new_meta_attributes['id'] = id + "_meta"
        if type == 1:
            new_meta_attributes['id'] = id + "_meta"
        newdata["meta_attributes"] = new_meta_attributes

    if 'instance_attributes' in data:
        instance_attributes = data['instance_attributes']
        new_instance_attributes = {}
        new_instance_attributes['id'] = id + "_instance"
        if instance_attributes != {}:
            nvpairs = instance_attributes
            nvpair_list = []
            nvpair = {}
            for name in nvpairs.keys():
                nvpair['name'] = name
                nvpair['value'] = nvpairs[name]
                nvpair['id'] = new_instance_attributes['id'] + "_" + name
                nvpair_list.append(nvpair)
                nvpair = {}
            new_instance_attributes['nvpair'] = nvpair_list
        newdata["primitive"]["instance_attributes"] = new_instance_attributes

    newdata["primitive"]["id"] = id

    if type == 1:
        ret = get_rsc_info(id)
        if ret is not None:
            if 'class' in ret:
                newdata["primitive"]["class"] = ret["class"]
            if 'provider' in ret:
                newdata["primitive"]["provider"] = ret["provider"]
            if 'type' in ret:
                newdata["primitive"]["type"] = ret["type"]
        res_info['rsc_info'] = newdata

    if type == 2:
        newrscs = []
        newrsc = {}
        for rsc in rscs:
            newrsc['id'] = rsc['rsc_id']
            newrsc['order'] = str(rsc['order'])
            newrscs.append(newrsc)
            newrsc = {}
        newdata['primitive'] = newrscs
        newdata['id'] = id
        res_info['rsc_info']['group'] = newdata

    if type == 3:
        ret = get_rsc_info(id)
        if ret is not None:
            if 'class' in ret:
                newdata["primitive"]["class"] = ret["class"]
            if 'provider' in ret:
                newdata["primitive"]["provider"] = ret["provider"]
            if 'type' in ret:
                newdata["primitive"]["type"] = ret["type"]
        res_info['rsc_info']['clone'] = newdata
        res_info['rsc_info']['clone']['id'] = data['id']
    return res_info


# Change rsc data format while update rsc
def set_rsc_json_format1(type, data, olddata):
    newdata = {}
    if type == "clone":
        olddata = olddata['data']
        id = data['id']
        if 'meta_attributes' in data:
            meta_attributes = data['meta_attributes']
            new_meta_attributes = {}
            new_meta_attributes['id'] = id + "_meta"
            if meta_attributes != {}:
                nvpairs = meta_attributes
                nvpair_list = []
                nvpair = {}
                for name in nvpairs.keys():
                    nvpair['name'] = name
                    nvpair['value'] = nvpairs[name]
                    nvpair['id'] = new_meta_attributes['id'] + "_" + name
                    nvpair_list.append(nvpair)
                    nvpair = {}
                new_meta_attributes['nvpair'] = nvpair_list
                olddata['clone']['meta_attributes'] = new_meta_attributes
        newdata['rsc_info'] = olddata
        newdata['rsc_info']['clone']['id'] = id
        return newdata

    if type == "group":
        id = data['id']

        rscs = []
        if 'rscs' in data:
            rscs = data['rscs']

        newdata = {}
        newdata['rsc_info'] = {}
        newdata['rsc_info']['group'] = {}

        if 'meta_attributes' in data:
            meta_attributes = data['meta_attributes']
            new_meta_attributes = {}
            new_meta_attributes['id'] = id + "_meta"
            if meta_attributes != {}:
                nvpairs = meta_attributes
                nvpair_list = []
                nvpair = {}
                for name in nvpairs.keys():
                    nvpair['name'] = name
                    nvpair['value'] = nvpairs[name]
                    nvpair['id'] = new_meta_attributes['id'] + "_" + str(nvpair['value'])
                    nvpair_list.append(nvpair)
                    nvpair = {}
                new_meta_attributes['nvpair'] = nvpair_list
                newdata['rsc_info']['group']['meta_attributes'] = new_meta_attributes

        newrscs = []
        order = 1
        newrsc = {}
        for rsc in rscs:
            newrsc['id'] = rsc
            newrsc['order'] = str(order)
            order = order + 1
            newrscs.append(newrsc)
            newrsc = {}

        newdata['rsc_info']['group']['primitive'] = newrscs
        newdata['rsc_info']['group']['id'] = id

        return newdata

    if type == "primitive":
        olddata = olddata['data']
        id = data['id']
        olddata['primitive']['id'] = id

        operations = {}
        id = data['id']
        operations['id'] = id
        if 'actions' in data:
            operations['operations'] = {}
            operations['operations']['id'] = id + "_operations"
            ops = []
            actions = data['actions']
            for action in actions:
                name = action['name']
                interval = action['interval']
                action['id'] = operations['operations']['id'] + "_" + name + "_" + interval
                ops.append(action)
                operations['operations']['op'] = ops

            operations = operations['operations']
            olddata['primitive']['operations'] = operations

        if 'meta_attributes' in data:
            meta_attributes = data['meta_attributes']
            new_meta_attributes = {}
            new_meta_attributes['id'] = id + "_meta"
            if meta_attributes != {}:
                nvpairs = meta_attributes
                nvpair_list = []
                nvpair = {}
                for name in nvpairs.keys():
                    nvpair['name'] = name
                    nvpair['value'] = nvpairs[name]
                    nvpair['id'] = new_meta_attributes['id'] + "_" + name
                    nvpair_list.append(nvpair)
                    nvpair = {}
                new_meta_attributes['nvpair'] = nvpair_list

            olddata['primitive']['meta_attributes'] = new_meta_attributes

        if 'instance_attributes' in data:
            instance_attributes = data['instance_attributes']
            new_instance_attributes = {}
            new_instance_attributes['id'] = id + "_instance"
            if instance_attributes != {}:
                nvpairs = instance_attributes
                nvpair_list = []
                nvpair = {}
                for name in nvpairs.keys():
                    nvpair['name'] = name
                    nvpair['value'] = nvpairs[name]
                    nvpair['id'] = new_instance_attributes['id'] + "_" + name
                    nvpair_list.append(nvpair)
                    nvpair = {}
                new_instance_attributes['nvpair'] = nvpair_list
            olddata['primitive']["instance_attributes"] = new_instance_attributes

        newdata['rsc_info'] = olddata
        return newdata


def get_neokylinha_status():
    # corosync 能表达整个集群的状态
    status, output = commands.getstatusoutput("systemctl status corosync")
    if status != 0:
        return {'action': False, 'error': output}
    return {'action': True}

ssl_cherry_server = None


class SSLCherryPyServer(ServerAdapter):

    def __init__(self, host, port, **options):
        super(SSLCherryPyServer, self).__init__(host, port, **options)
        self.server = None

    def run(self, handler):
        private_key = PK_PATH
        cert = S_PATH
        self.server = wsgiserver.CherryPyWSGIServer(
            (self.host, self.port), handler,
            shutdown_timeout=3)
        self.server.ssl_adapter = pyOpenSSLAdapter(cert, private_key)
        try:
            self.server.start()
        finally:
            self.server.stop()

    def shutdown(self):
        self.server.stop()


def init_ssl_cherry_server(ip, port):
    global ssl_cherry_server
    ssl_cherry_server = SSLCherryPyServer(ip, port)
    return ssl_cherry_server


def shutdown_cherry_server():
    global ssl_cherry_server
    ssl_cherry_server.shutdown()


def check_remote_root_pass(hostip, username, password):
    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    try:
        ssh.connect(hostname=hostip, username=username, password=password, allow_agent=True)
	ssh.close()
        return True
    except:
	ssh.close()
        return False


def scp_by_key(host_ip, host_port, local_path, remote_path, username, pkey_path):
    key=paramiko.RSAKey.from_private_key_file(pkey_path)
    t = paramiko.Transport((host_ip, host_port))
    try:
        t.connect(username=username, pkey=key)
        sftp = paramiko.SFTPClient.from_transport(t)
        src = local_path
        des = remote_path
        sftp.put(src,des)
        t.close()
        return True
    except Exception as e:
	t.close()
        return False

def run_remote_commands(host_ip, host_port, commands, username, pkey_path):
    key = paramiko.RSAKey.from_private_key_file(pkey_path)
    s = paramiko.SSHClient()
    try:
	s.set_missing_host_key_policy(paramiko.AutoAddPolicy())
	s.connect(host_ip, host_port, username, pkey=key)
	stdin,stdout,stderr=s.exec_command(commands)
	result = str(stdout.read()).strip()
	s.close()
	return {'action': True, 'data': result}
    except Exception as e:
	s.close()
        return {'action': False, 'error': str(e)}

def test_api_alive(hostip):
    try:
        context = ssl._create_unverified_context()
        url = "https://" + str(hostip) + ":8088/api/v1/haclusters/1/apistatus"
        request = urllib2.Request(url, headers=HEADERS)
        response = urllib2.urlopen(request, context=context)
        return json.loads(response.read())

    except urllib2.URLError, e:
        return {"action": False}

def send_remote_config_request(data, hostip):
    try:
        data_str = json.dumps(data)
	# 匿名ssl证书信任
        context = ssl._create_unverified_context()
        url = "https://" + str(hostip) + ":8088/api/v1/haclusters/1/remoteconfigs"
        request = urllib2.Request(url, data_str, headers=HEADERS)
        response = urllib2.urlopen(request, context=context)
        return json.loads(response.read())
    except urllib2.URLError, e:
        return {"action": False, "error": e.reason}

def send_remote_nodeaction_request(hostip, action):
    try:
	# 匿名ssl证书信任
        context = ssl._create_unverified_context()
        url = "https://" + str(hostip) + ":8088/api/v1/haclusters/1/localnodes/" + str(action)
        request = urllib2.Request(url, headers=HEADERS)
	# 设置方法类型
	request.get_method = lambda: 'POST'
        response = urllib2.urlopen(request, context=context)
        return response.read()
    except urllib2.URLError, e:
        return {"action": False, "error": e.reason}

def send_remote_scripts_request(data, hostip):
    try:
        data_str = json.dumps(data)
	# 匿名ssl证书信任
        context = ssl._create_unverified_context()
        url = "https://" + str(hostip) + ":8088/api/v1/haclusters/1/remotescripts"
        request = urllib2.Request(url, data_str, headers=HEADERS)
        response = urllib2.urlopen(request, context=context)
        return json.loads(response.read())
    except urllib2.URLError, e:
        return {"action": False, "error": e.reason}

def send_remote_drbd_request(data, hostip):
    try:
        data_str = json.dumps(data)
        # 匿名ssl证书信任
        context = ssl._create_unverified_context()
        url = "https://" + str(hostip) + ":8088/api/v1/haclusters/1/remotedrbd"
        request = urllib2.Request(url, data_str, headers=HEADERS)
        response = urllib2.urlopen(request, context=context)
        return json.loads(response.read())
    except urllib2.URLError, e:
        return {"action": False, "error": e.reason}


if __name__ == '__main__':
    #print sync_corosync_file_to_remote("10.1.110.171", "root", "qwer1234")
    #scp_by_key('10.1.110.171', 22, '/etc/corosync/corosync.conf.sync', '/etc/corosync/corosync.conf', 'root', '/root/.ssh/id_rsa')	
    #print run_remote_commands('10.1.110.171', 22, 'hostname', 'root', '/root/.ssh/id_rsa')
    #print get_neokylinha_status()
    rest_api("houjian", "qwer1234")
