# -*-coding:utf-8-*-
# !/usr/bin/python
# coding: iso-8859-15


import json
import os
import re
import commands
from common_utils import manager, scp_by_key, test_api_alive, send_remote_config_request 

corosync_conf = "/etc/corosync/corosync.conf"


def get_hb_config_org(get_diskhb):
    if not os.path.exists(corosync_conf):
        return json.dumps({'action': True, 'data': {}})

    ret_data = get_hb_config(corosync_conf, get_diskhb)

    if not ret_data['action']:
        return ret_data
    return {'action': True, 'data': ret_data['data']['interface']}


def get_hb_config(filename, get_diskhb=True):
    ret = get_file_context(filename)
    if not ret['action']:
        return ret

    f = ret["data"]
    interface_list = []
    nodelist = []
    file_corosync_org = []
    index = 0
    rrp_mode = None
    hbinterval = 1

    while index < len(f):
        file_corosync_org.append(f[index].rstrip())
        if "#" in f[index]:
            strline = f[index].split("#")[0]
        else:
            strline = f[index]

        strline = strline.strip()
        m = re.match('^rrp_mode:(.+)$', strline)
        if m is not None:
            rrp_mode = m.groups()[0].strip()
            file_corosync_org.pop()

        top = 0

        m = re.match('^(interface).*$', strline)
        if m is not None:
            interface = {}
            index = index + 1
            if "#" in f[index]:
                strline = f[index].split("#")[0]
            else:
                strline = f[index]
            strline = strline.strip()
            ncount = 0
            while top != -1:
                if '{' in strline:
                    top += 1
                if '}' in strline:
                    top -= 1
                m = re.match('^ringnumber:(.+)$', strline)
                if m is not None:
                    interface["ringnumber"] = int(m.groups()[0].strip())
                m = re.match('^bindnetaddr:(.+)$', strline)
                if m is not None:
                    interface["bindnetaddr"] = m.groups()[0].strip()
                m = re.match('^mcastaddr:(.+)$', strline)
                if m is not None:
                    interface["mcastaddr"] = m.groups()[0].strip()
                m = re.match('^broadcast:(.+)$', strline)
                if m is not None and m.groups()[0].strip() == "yes":
                    interface["mcastaddr"] = str("broadcast")
                m = re.match('^mcastport:(.+)$', strline)
                if m is not None:
                    interface["mcastport"] = int(m.groups()[0].strip())
                m = re.match('^memberaddr:(.+)$', strline)
                if m is not None:
                    ncount += 1
                    if ncount > 1:
                        interface["mcastaddr"] += ","
                        interface["mcastaddr"] += m.groups()[0].strip()
                    else:
                        interface["mcastaddr"] = m.groups()[0].strip()
                m = re.match('^disk:(.+)$', strline)
                if m is not None:
                    interface["disk"] = m.groups()[0].strip()
                m = re.match('^label:(.+)$', strline)
                if m is not None:
                    interface["label"] = m.groups()[0].strip()
                m = re.match('^serial:(.+)$', strline)
                if m is not None:
                    interface["serial"] = m.groups()[0].strip()
                m = re.match('^speed:(.+)$', strline)
                if m is not None:
                    interface["speed"] = m.groups()[0].strip()
                if top != -1:
                    index = index + 1
                if "#" in f[index]:
                    strline = f[index].split("#")[0]
                else:
                    strline = f[index]
                strline = strline.strip()
            if len(interface) > 0:
                if 'disk' in interface.keys():
                    if get_diskhb:
                        interface_list.append(interface)
                else:
                    interface_list.append(interface)
        m = re.match('^token:(.+)$', strline)
        if m is not None:
            interval = {}
            interval["token"] = m.groups()[0].strip()
            hbinterval = int(interval["token"]) / 1000
            file_corosync_org.pop()
        m = re.match('^token_retransmit:(.+)$', strline)
        if m is not None:
            interval["token_retransmit"] = m.groups()[0].strip()
            file_corosync_org.pop()
        m = re.match('^hold:(.+)$', strline)
        if m is not None:
            interval["hold"] = m.groups()[0].strip()
            file_corosync_org.pop()
        m = re.match('^join:(.+)$', strline)
        if m is not None:
            interval["join"] = m.groups()[0].strip()
            file_corosync_org.pop()
        m = re.match('^consensus:(.+)$', strline)
        if m is not None:
            interval["consensus"] = m.groups()[0].strip()
            file_corosync_org.pop()
        m = re.match('^merge:(.+)$', strline)
        if m is not None:
            interval["merge"] = m.groups()[0].strip()
            file_corosync_org.pop()

        # match 匹配nodelist
        m = re.match('^(node {).*$', strline)
        m1 = re.match('^(node{).*$', strline)
        if m is not None or m1 is not None:
            node = {}
            index = index + 1
            if "#" in f[index]:
                strline = f[index].split("#")[0]
            else:
                strline = f[index]
            strline = strline.strip()
            ncount = 0
            while top != -1:
                if '{' in strline:
                    top += 1
                if '}' in strline:
                    top -= 1

                # 根据ringnumber 的值组成字段进行查询
                for interface in interface_list:
                    ringnumber = interface['ringnumber']
                    ring_addr = "ring" + str(ringnumber) + "_addr"

                    m = re.match('^' + ring_addr + ':(.+)$', strline)
                    if m is not None:
                        node[ring_addr] = m.groups()[0].strip()

                if top != -1:
                    index = index + 1
                if "#" in f[index]:
                    strline = f[index].split("#")[0]
                else:
                    strline = f[index]
                strline = strline.strip()

            nodelist.append(node)
            node = {}

        index = index + 1
    if get_diskhb:
        dhbinterval = str(hbinterval)
        disk = ""
        label = ""
        dhbconfigured = False
        msg = ""
        cmd = "/usr/share/heartbeat-gui/device.sh"
        # device_list = manager.do_cmd("system\n"+str(cmd))
        device_list = os.popen(cmd).read().strip()
        if len(device_list) == 0:
            device_list = []
        else:
            device_list = device_list.split('\n')

    for interface in interface_list:
        if get_diskhb and 'disk' and 'label' in interface:
            # if 'disk' and 'label'  in interface:
            dhbconfigured = True
            disk = interface["disk"]
            label = interface["label"]
            check_msg = check_locate_disk_label(disk, device_list, label)
            if not check_msg['action']:
                msg = check_msg['error']
            else:
                msg = ""

    # 为网络心跳，添加获取nodelist信息
    for interface in interface_list:
        if not ('disk' and 'label' in interface):
            hbaddrs = []
            ringnumber = interface['ringnumber']
            ring_addr = "ring" + str(ringnumber) + "_addr"
            for node in nodelist:
                if ring_addr in node:
                    hbaddr = {}
                    hbip = node[ring_addr]
                    # nodeid = str(node['nodeid']).strip()
                    nodeid = get_nodeid_relation(hbip)
                    hbaddr['ip'] = hbip
                    hbaddr['nodeid'] = nodeid
                    hbaddrs.append(hbaddr)
            interface['hbaddrs'] = hbaddrs
        else:
            # 获取磁盘心跳的间隔时间
            interface['interval'] = hbinterval

    if get_diskhb:
        return {'action': True, 'data': {'interface': interface_list, 'interval': interval, 'rrp_mode': rrp_mode,
                                         'file_org': file_corosync_org,
                                         'diskhb': {'disk': disk, 'label': label, 'dhbinterval': dhbinterval,
                                                    'configured': dhbconfigured, 'device_list': device_list,
                                                    'error_msg': msg}}}
    else:
        return {'action': True, 'data': {'interface': interface_list, 'interval': interval, 'rrp_mode': rrp_mode,
                                         'file_org': file_corosync_org}}


def check_locate_disk_label(disk, device_list, label):
    cmd = "partprobe" + " " + "&&" + "test ! -e" + " " + disk + " " + "&&" + " " + "echo 1"
    # ret = manager.do_cmd_twice("system\n%s"%(str(cmd)))
    ret = os.popen(cmd).read().strip().split('\n')

    if '1' in ret:
        label_bond = ""
        label_list_search = device_list[::-1]
        label_bond = manager.diskhb_labelbond(label_list_search, label)
        if label_bond != False:
            ret1 = _(
                "The \"%s\" you used has changed into \"%s\",so the configuration of current disk heartbeat in the file is wrong.Replace it?") % (
                       disk, label_bond)
            '''if ret1 == gtk.RESPONSE_OK:
                self.widget_disk.child.set_text(label_bond)
                self.renamedev = label_bond
                self.label_device_renamed = True
                return True
            else:'''
            return {'action': False, 'error': ret1}
        else:
            ret2 = _(
                "The \"%s\" you used has lost,so the configuration of current disk heartbeat in the file is wrong.") % disk + "\n" + _(
                "Delete the configuration and choose the disk device again?")
            '''if ret2 == gtk.RESPONSE_OK :
                self.widget_disk.child.set_text("")
                self.widget_label.set_text("")
                self.widget_not_use_diskhb.set_active(True)
                return True
            else:'''
            return {'action': False, 'error': ret2}
    else:
        return {'action': True, 'info': _('Check locate disk label success')}


def get_file_context(filename):
    data = manager.do_cmd("get_file_context\n" + str(filename))
    if manager.failed_reason != "":
        try:
            read = open(filename)
        except:
            return {'action': False, 'error': _("File %s not exist!") % (filename)}

        data = []
        line = read.readline()
        while line:
            data.append(line)
            line = read.readline()
        read.close
        return {'action': True, 'data': data}
    else:
        return {'action': True, 'data': data}


def bindnetaddr_first(list):
    if 'bindnetaddr' and 'mcastaddr' and 'mcastport' not in list[0]:
        interface_backup = list[0]
        for interface in list:
            if 'bindnetaddr' and 'mcastaddr' and 'mcastport' in interface:
                list[0] = interface
                list.remove(interface)
                list.append(interface_backup)
                break
    return list


def sync_file_org(nodelist, file):
    all_result = []
    remote_nodelist = []

    # 获取本地主机id
    status, output = commands.getstatusoutput("hostname")
    if status != 0:
        return {'action': False, 'error': output}
    localnodeid = str(output).strip()

    # 获取远程主机列表
    for node in nodelist:
        nodeid = node['nodeid']
        if localnodeid != nodeid:
            remote_nodelist.append(node)

    # 判断远程主机是否active
    for remote_node in remote_nodelist:
        remote_nodeip = remote_node['ip']
        ret = test_api_alive(remote_nodeip)
        if 'action' not in remote_nodeip or not remote_nodeip['action']:
            return {'action': False, 'error': 'Connect to remote server failed'}

    for node in nodelist:
        one_result = {}
        nodeid = node['nodeid']
        # 若是本机，则执行本机操作
        if localnodeid == nodeid:
            status, output = commands.getstatusoutput("cp /etc/corosync/corosync.conf.sync /etc/corosync/corosync.conf")
            if status != 0:
                one_result['nodeid'] = nodeid
                one_result['status'] = False
                all_result.append(one_result)
            else:
                one_result['nodeid'] = nodeid
                one_result['status'] = True
                all_result.append(one_result)

        else:
            nodeip = node['ip']
            result = scp_by_key(nodeip, 22, '/etc/corosync/corosync.conf.sync', '/etc/corosync/corosync.conf', 'root',
                                '/root/.ssh/id_rsa')
            one_result['nodeid'] = nodeid
            one_result['status'] = result
            all_result.append(one_result)

    return all_result


def hb_json_to_conf(data):
    conf_str = ""
    totem_str = "totem {\n"
    totem_str = totem_str + "version: " + str(data['totem']['version']) + "\n"
    totem_str = totem_str + "secauth: " + str(data['totem']['secauth']) + "\n"
    totem_str = totem_str + "cluster_name: " + str(data['totem']['cluster_name']) + "\n"
    if len(data['totem']['interfaces']) > 1:
        totem_str = totem_str + "\t\trrp_mode: " + str(data['totem']['rrp_mode']) + "\n"
    for interface in data['totem']['interfaces']:
        interface_str = "\t\tinterface {\n"
        interface_str = interface_str + "\t\t\tringnumber:" + str(interface['ringnumber']) + "\n"
        # 广播
        if 'broadcast' in interface and 'bindnetaddr' in interface and 'mcastport' in interface:
            interface_str = interface_str + "\t\t\tbroadcast: " + interface['broadcast'] + "\n"
            interface_str = interface_str + "\t\t\tbindnetaddr: " + interface['bindnetaddr'] + "\n"
            interface_str = interface_str + "\t\t\tmcastport: " + str(interface['mcastport']) + "\n"
        # 多播
        if 'mcastaddr' in interface and 'bindnetaddr' in interface and 'mcastport' in interface:
            interface_str = interface_str + "\t\t\tmcastaddr: " + interface['mcastaddr'] + "\n"
            interface_str = interface_str + "\t\t\tbindnetaddr: " + interface['bindnetaddr'] + "\n"
            interface_str = interface_str + "\t\t\tmcastport: " + str(interface['mcastport']) + "\n"
        # 单播
        if 'bindnetaddr' in interface and 'mcastport' in interface and 'broadcast' not in interface and 'mcastaddr' not in interface:
            interface_str = interface_str + "\t\t\tbindnetaddr: " + interface['bindnetaddr'] + "\n"
            interface_str = interface_str + "\t\t\tmcastport: " + str(interface['mcastport']) + "\n"
        # 磁盘心跳
        if 'disk' in interface and 'label' in interface:
            interface_str = interface_str + "\t\t\tdisk: " + interface['disk'] + "\n"
            interface_str = interface_str + "\t\t\tlabel: " + interface['label'] + "\n"

        interface_str = interface_str + "\t\t}\n"
        totem_str = totem_str + interface_str

    if 'transport' in data['totem']:
        totem_str = totem_str + "\t\ttransport: " + str(data['totem']['transport']) + "\n"

    totem_str = totem_str + "\t\ttoken: " + str(data['totem']['token']) + "\n"
    totem_str = totem_str + "\t\ttoken_retransmit: " + str(data['totem']['token_retransmit']) + "\n"
    totem_str = totem_str + "\t\thold: " + str(data['totem']['hold']) + "\n"
    totem_str = totem_str + "\t\tjoin: " + str(data['totem']['join']) + "\n"
    totem_str = totem_str + "\t\tconsensus: " + str(data['totem']['consensus']) + "\n"
    totem_str = totem_str + "\t\tmerge: " + str(data['totem']['merge']) + "\n"
    totem_str = totem_str + "}\n"

    logging_str = "logging {\n"
    logging_str = logging_str + "\t\tto_logfile: " + str(data['logging']['to_logfile']) + "\n"
    logging_str = logging_str + "\t\tlogfile: " + str(data['logging']['logfile']) + "\n"
    logging_str = logging_str + "\t\tlogfile_for_ocf: " + str(data['logging']['logfile_for_ocf']) + "\n"
    logging_str = logging_str + "\t\tto_syslog: " + str(data['logging']['to_syslog']) + "\n"
    logging_str = logging_str + "\t\tdebug: " + str(data['logging']['debug']) + "\n"
    logging_str = logging_str + "\t\ttimestamp: " + str(data['logging']['timestamp']) + "\n"
    logging_str = logging_str + "\t\tfileline: " + str(data['logging']['fileline']) + "\n"
    logging_str = logging_str + "\t\tfunction_name: " + str(data['logging']['function_name']) + "\n"
    logging_str = logging_str + "}\n"

    nodelist_str = "nodelist {\n"
    for node in data['nodelist']:
        node_str = "\t\tnode {\n"
        for interface in data['totem']['interfaces']:
            if not 'disk' in interface:
                ringnumber = interface['ringnumber']
                ringnumber_str = "ring" + str(ringnumber) + "_addr"
                node_str = node_str + "\t\t\t" + ringnumber_str + ": " + node[ringnumber_str] + "\n"

        node_str = node_str + "\t\t\tnodeid: " + node['nodeid'] + "\n"
        node_str = node_str + "\t\t}\n"
        nodelist_str = nodelist_str + node_str + "\n"

    nodelist_str = nodelist_str + "}\n"

    quorum_str = "quorum {\n"
    quorum_str = quorum_str + "\t\texpected_votes: " + str(data['quorum']['expected_votes']) + "\n"
    quorum_str = quorum_str + "\t\tprovider: " + str(data['quorum']['provider']) + "\n"
    quorum_str = quorum_str + "}\n"

    config_str = totem_str + logging_str + nodelist_str + quorum_str

    try:
        read = file("/etc/corosync/corosync.conf", 'w')
        read.write(config_str)
        read.close
        return {'action': True, 'info': _('Save file context success')}
    except:
        return {'action': False, 'error': _('Save file %s error!') % (filename)}


def hb_data_to_json(item, nodehbs):
    data = {}
    totem = {}
    totem["version"] = "2"
    totem["secauth"] = "off"
    totem["cluster_name"] = "cs2c"
    totem["rrp_mode"] = "passive"
    totem["token"] = "1000"
    totem["token_retransmit"] = "238"
    totem["hold"] = "180"
    totem["join"] = "50"
    totem["consensus"] = "1200"
    totem["merge"] = "200"

    hbinfo = item["hbinfo"]

    interfaces = []

    for hb in hbinfo:
        interface = {}
        interface["ringnumber"] = hb["ringnumber"]
        # 广播
        if 'broadcast' in hb and 'bindnetaddr' in hb and 'mcastport' in hb:
            interface["broadcast"] = hb["broadcast"]
            interface["bindnetaddr"] = hb["bindnetaddr"]
            interface["mcastport"] = hb["mcastport"]
        # 多播
        elif 'mcastaddr' in hb and 'bindnetaddr' in hb and 'mcastport' in hb:
            interface["mcastaddr"] = hb["mcastaddr"]
            interface["bindnetaddr"] = hb["bindnetaddr"]
            interface["mcastport"] = hb["mcastport"]
        # 单播
        elif 'bindnetaddr' in hb and 'mcastport' in hb and 'broadcast' not in hb and 'mcastaddr' not in hb:
            interface["bindnetaddr"] = hb["bindnetaddr"]
            interface["mcastport"] = hb["mcastport"]
            totem['transport'] = 'udpu'
        # 磁盘心跳
        elif 'disk' in hb and 'label' in hb:
            interface["disk"] = hb["disk"]
            interface["label"] = hb["label"]
            interval = int(hb['interval'])
            totem['token'] = str(interval * 1000)
            totem["token_retransmit"] = str(interval * 238)
            totem["hold"] = str(interval * 180)
            totem["join"] = str(interval * 50)
            totem["consensus"] = str(interval * 1200)
            totem["merge"] = str(interval * 200)

        interfaces.append(interface)
    logging = {}
    logging["to_logfile"] = "yes"
    logging["logfile"] = "/var/log/neokylinha.log"
    logging["logfile_for_ocf"] = "/var/log/neokylinha_ocf.log"
    logging["to_syslog"] = "no"
    logging["debug"] = "off"
    logging["timestamp"] = "on"
    logging["fileline"] = "off"
    logging["function_name"] = "on"

    node_map = {}
    nodes = []

    for hb in hbinfo:
        if not 'disk' in hb:
            ringnumber = hb["ringnumber"]
            ringnumber_str = "ring" + str(ringnumber) + "_addr"
            hbaddrs = hb['hbaddrs']
            if not 'disk' in hb:
                for hbaddr in hbaddrs:
                    nodeid = hbaddr['nodeid']
                    if not nodeid in node_map:
                        node_map[nodeid] = {}
                    node_map[nodeid][ringnumber_str] = hbaddr['ip']

    nodecount = 0
    count = 1
    for nodehb in nodehbs:
        nodecount = nodecount + 1
        node = {}
        nodeid = nodehb['nodeid']
        node["nodeid"] = str(count)
        nodeinfo = node_map[nodeid]
        for key, values in nodeinfo.items():
            node[key] = values
        nodes.append(node)
        count = count + 1

    quorum = {}

    expected_votes = (nodecount + 1) / 2
    remainder = (nodecount + 1) % 2
    if remainder != 0:
        expected_votes = (nodecount + 1) / 2 + 1

    quorum["expected_votes"] = expected_votes

    quorum["provider"] = "corosync_votequorum"

    totem["interfaces"] = interfaces
    data["totem"] = totem
    data["logging"] = logging
    data["nodelist"] = nodes
    data["quorum"] = quorum

    return data


def get_sync_ip_list(hbs):
    nodelist = []
    for hb in hbs:
        if 'ringnumber' in hb and hb['ringnumber'] == 0 and 'hbaddrs' in hb:
            nodelist = hb['hbaddrs']

    return nodelist


def save_local_config(data):
    result = init_hb_disk(data)

    if not result['action']:
        return result

    interface_len = 0
    interface_len = len(data['hbinfo'])
    if interface_len <= 0 or interface_len > 3:
        return {'action': False, 'error': _('The number of heartbeats must not exceed 3')}

    hbs = data['hbinfo']

    nodelist = []
    nodelist = get_sync_ip_list(hbs)

    item = hb_data_to_json(data, nodelist)
    result = hb_json_to_conf(item)
    if not result['action']:
        return result

    return {'action': True, 'info': _('Cluster config success')}


def save_hb_conf(data):

    hbs = data['hbinfo']
    nodelist = []
    nodelist = get_sync_ip_list(hbs)
    remote_nodelist = []

    # 获取本地主机id
    status, output = commands.getstatusoutput("hostname")
    if status != 0:
        return {'action': False, 'error': output}
    localnodeid = str(output).strip()

    # 获取远程主机列表
    for node in nodelist:
        nodeid = node['nodeid']
        if localnodeid != nodeid:
            remote_nodelist.append(node)

    # 判断远程主机是否active
    for remote_node in remote_nodelist:
        remote_nodeip = remote_node['ip']
	print remote_nodeip
        ret = test_api_alive(remote_nodeip)
        if 'action' not in ret or not ret['action']:
            return {'action': False, 'error': _('Cluster configuration failed, please checkout network and ha service')}

    # 对本地和远程执行不同的操作
    for node in nodelist:
        nodeid = node['nodeid']
        if nodeid == localnodeid:
            retlocal = save_local_config(data)
	    if not retlocal['action']:
	        return  {'action': False, 'error': _('Cluster configuration save failed')}
        else:
            nodeip = node['ip']
	    print nodeip
            retremote = send_remote_config_request(data, nodeip)
	    if not retremote['action']:
                return  {'action': False, 'error': _('Cluster configuration save failed')}

    return  {'action': True, 'info': _('Cluster config success')}

def get_nodeid_relation(ip):
    host_file = "/etc/hosts"
    ret = get_file_context(host_file)
    f = ret["data"]
    index = 0
    file_corosync_org = []

    while index < len(f):
        file_corosync_org.append(f[index].rstrip())
        if "#" in f[index]:
            strline = f[index].split("#")[0]
        else:
            strline = f[index]

        strline = strline.strip()
        m = re.match("^(" + ip + ").*", strline)
        if m is not None:
            hostname = strline.replace(ip, "").strip()
            file_corosync_org.pop()
            return hostname
        index = index + 1
    return None


def get_diskhb_device():
    cmd = "/usr/share/heartbeat-gui/device.sh"
    # device_list = manager.do_cmd("system\n"+str(cmd))
    device_list = os.popen(cmd).read().strip()
    if len(device_list) == 0:
        device_list = []
    else:
        device_list = device_list.split('\n')

    return {'action': True, 'data': device_list}


def init_hb_disk(data):
    # 从配置文件中获取磁盘心跳信息
    hbconfig = get_hb_config_org(True)
    if not hbconfig['action']:
        return {'action': False, 'error': _("Get hb info failed")}

    diskhb1 = None
    interfaces = hbconfig['data']
    for interface in interfaces:
        if 'disk' in interface:
            diskhb1 = interface

    # 修改后的磁盘心跳信息
    diskhb2 = None
    hbinfo = data['hbinfo']
    for hb in hbinfo:
        if 'disk' in hb:
            diskhb2 = hb

    if diskhb2 is not None:
        disk2 = str(diskhb2['disk']).strip()
        label2 = str(diskhb2['label']).strip()
        interval2 = str(diskhb2['interval']).strip()

        if diskhb1 is not None:
            disk1 = str(diskhb1['disk']).strip()
            label1 = str(diskhb1['label']).strip()
            if not (disk1 == disk2 and label1 == label2):
                if disk2 == "":
                    return {'action': False, 'error': _("Please choose the disk device, for example: /dev/sdb")}

                if not manager.check_device(disk2):
                    return {'action': False,
                            'error': _("The device is wrong,please input the device you want again!\n")}

                if len(disk2) > 128:
                    return {'action': False, 'error': _("The length of Disk Name must be less than 128.\n") + _(
                        "Please input it again!\n")}

                if disk2.startswith("/dev/mapper/"):
                    m = re.match('^/dev/mapper/(.+)$', disk2)
                    if m is None:
                        return {'action': False,
                                'error': _("The device is wrong,please input the device you want again!\n")}
                else:
                    m = re.match('^/dev/(\w+((\-|_)*\w*)*(/\w+((\-|_)*\w*)*)*)$', disk2)
                    if m is None:
                        return {'action': False, 'error': _("Special characters can not appear in Disk Name!\n") + _(
                            "Please input it again!\n")}

                if label2 == "":
                    return {'action': False, 'error': _("Please input the disk Label, for example: abcd")}
                m = re.match('^[\w\d]+$', label2)
                if m is None or len(label2) > 16:
                    return {'action': False, 'error': _("Special characters can not appear in Disk Label!\n") + _(
                        "And the length must be less than 16.\n") + _("Please input it again!\n")}

                # 分开执行命令partprobe命令，防止出现无法写入的现象
                cmd_partprobe = "partprobe"
                os.popen(str(cmd_partprobe))
                cmd = "test -e" + " " + disk2 + " " + "&&" + " " + "echo" + " " + str(
                    label2) + " " + ">" + " " + disk2 + " " + "||" + " " + "echo 1"
                ret = os.popen(cmd).read().strip().split('\n')
                if '1' in ret:
                    return {'action': False, 'error': _("The initialization of \"%s\" failed!\n") % disk2 + _(
                        "Please choose another device.")}

    return {'action': True, 'error': _("Init disk hb success")}


def get_hb_status():
    status, output = commands.getstatusoutput("corosync-cfgtool -s|grep FAULTY|wc -l")
    if status == 0:
        return {'action': True, 'data': int(output)}
    else:
        return {'action': False, 'error': _("Get hb status failed")}



if __name__ == '__main__':
    data1 = {
        "hbinfo": [
            {
                "bindnetaddr": "10.1.110.0",
                "broadcast": "yes",
                "hbaddrs": [
                    {
                        "ip": "10.1.110.127",
                        "nodeid": "ns127"
                    },
                    {
                        "ip": "10.1.110.128",
                        "nodeid": "ns128"
                    }
                ],
                "mcastport": 1235,
                "ringnumber": 0
            },
            {
                "bindnetaddr": "10.1.110.0",
                "broadcast": "yes",
                "hbaddrs": [
                    {
                        "ip": "10.1.110.127",
                        "nodeid": "ns127"
                    },
                    {
                        "ip": "10.1.110.128",
                        "nodeid": "ns128"
                    }
                ],
                "mcastport": 2399,
                "ringnumber": 1
            },
            {
                "ringnumber": 2,
                "disk": " /dev/vdb",
                "interval": 5,
                "label": "dfgsd111"
            },

            {
                "bindnetaddr": "10.1.110.0",
                "hbaddrs": [
                    {
                        "ip": "10.1.110.127",
                        "nodeid": "ns127"
                    },
                    {
                        "ip": "10.1.110.128",
                        "nodeid": "ns128"
                    }
                ],
                "mcastport": 2300,
                "ringnumber": 3
            }

        ],
        "nodeauth": [
            {
                "nodeid": "ns127",
                "nodeip": "10.1.110.127",
                "password": "qwer1234"
            },
            {
                "nodeid": "ns128",
                "nodeip": "10.1.110.128",
                "password": "qwer1234"
            }
        ]
    }

    data2 = {
        "hbinfo": [
            {
                "bindnetaddr": "10.1.110.0",
                "broadcast": "yes",
                "hbaddrs": [
                    {
                        "ip": "10.1.110.175",
                        "nodeid": "ns175"
                    },
                    {
                        "ip": "10.1.110.176",
                        "nodeid": "ns176"
                    }
                ],
                "mcastport": 7799,
                "ringnumber": 0
            },
            {
                "bindnetaddr": "10.1.110.0",
                "hbaddrs": [
                    {
                        "ip": "10.1.110.175",
                        "nodeid": "ns175"
                    },
                    {
                        "ip": "10.1.110.176",
                        "nodeid": "ns176"
                    }
                ],
                "mcastport": 2300,
                "ringnumber": 1
            }

        ]
    }

    #print save_hb_conf(data2)
    print get_hb_config_org(True)
