#!/usr/bin/python
# -*-coding:utf-8-*-
# coding: iso-8859-15

import sys, os, string

sys.path.append("/usr/share/heartbeat-gui")
sys.path.append("/usr/lib64/heartbeat-gui")
import re
from Manager import Manager
from pymgmt import *

manager = Manager()


def del_node_constraints(del_node_id):
    location_ids = []
    for rsc in manager.get_top_rsc():
        constraints = os.popen("crm_resource -a -r %s" % (rsc)).read().split("\n")
        for cons in constraints:
            m = re.match('^\s*:\sNode\s(.*)\s*\(score=(.*)\,\sid=(.*)\)', cons)
            if m is None:
                continue
            if m.groups()[0].strip() == del_node_id:  # location
                location_ids.append(m.groups()[2].strip())

    rsc_location_rule = []
    xml_constraints = manager.xml_nodes["cib"].getElementsByTagName("constraints")[0]
    for rsc_location in manager.xml_nodes["cib"].getElementsByTagName("rsc_location"):
        id = str(rsc_location.getAttribute("id"))
        if id in location_ids:
            xml_constraints.removeChild(rsc_location)
        else:
            for rule in rsc_location.getElementsByTagName("rule"):
                id = str(rule.getAttribute("id"))
                if id in location_ids:
                    rsc_location.removeChild(rule)

                if len(rsc_location.getElementsByTagName("rule")) == 0:
                    xml_constraints.removeChild(rsc_location)
    xml_str = xml_constraints.toxml().replace("\n", "")
    manager.cib_do_cmd("cib_replace\n%s\n%s" % (str("constraints"), str(xml_str)))

    if manager.failed_reason != "":
        log(manager.failed_reason)

    constes_nodes = []
    for node in manager.xml_nodes["cib"].getElementsByTagName("conste_nodes"):
        if node.getAttribute('rscid') == del_node_id:
            constes_nodes.append(node)

    for conste in constes_nodes:
        xml_str = conste.toxml().replace("\n", "")
        manager.cib_do_cmd("cib_delete\nconstes\n%s" % (str(xml_str)))


def is_ha_login():
    if not manager.connected:
        if manager.login('127.0.0.1', "hacluster", 'qwer1234'):
            manager.update()
            return True
        else:
            return False
    else:
        manager.process_event(None)
        manager.update()
        return True


if __name__ == '__main__':
    if len(sys.argv) < 2:
        print "param error"
        sys.exit(1)
    node = sys.argv[1]
    if not is_ha_login():
        print 'Please ensure that the HA service has already been started!'
        sys.exit(1)

    del_node_constraints(node)
    if manager.failed_reason != "":
        print manager.failed_reason
        sys.exit(1)
    else:
        print "success"
        sys.exit(0)
