#!/usr/bin/python
# -*-coding:utf-8-*-
# coding: iso-8859-15

from common_utils import is_ha_login, test_api_alive, send_remote_drbd_request
from gfs import gfs_create
import json
import commands
import re
import os
from xml.dom.minidom import parseString
from xml.dom.minidom import getDOMImplementation
from common_utils import manager, update
import xml


class HAPublic:
        def level_init(self):
                self.level_score = []  #list(self.level_score)
                max = len(manager.get_all_nodes())-1
                for i in range(max):
                        self.level_score.append(str(16000-1000*i))

                return

        def turn_score_to_level(self, score):
                self.level_init()
                if score in ["20000"]: #["INFINITY", "+INFINITY", "infinity", "+infinity"]:
                        return "Master Node"

                if score in ["-INFINITY", "-infinity"]:
                        return ("No Run Node")

                if score not in self.level_score:
                        return score
                level = 1
                for s in self.level_score:
                        if s == score:
                                return ("Slave %d")%(level)
                        level = level+1

                return score

        def turn_level_to_score(self, level):
                self.level_init()
                if level == "Master Node":
                        return "20000"#"INFINITY"

                if level == ("No Run Node"):
                        return "-INFINITY"

                if ("Slave ") not in level :
                        return level
                else:
                        index = int(level[len(str("Slave ")):])
                        return self.level_score[index-1]

        def add_score(self, score1, score2):
                if score1 in ["-INFINITY", "-infinity"] or score2 in ["-INFINITY", "-infinity"] :
                        return str("-INFINITY")
                if score1 in ["INFINITY","+INFINITY", "infinity", "+infinity"] or score2 in ["INFINITY", "+INFINITY", "infinity", "+infinity"] :
                        return str("INFINITY")
                return str(int(score1)+int(score2))


web_manager = HAPublic()

class DRBD:
        drbd_filename = "/etc/drbd.d/drbd0.res"
        drbd_global_conf = "/etc/drbd.d/global_common.conf"
        corosync_filename = "/etc/corosync/corosync.conf"
        corosync_filename_tmp = "/tmp/corosync.conf"
        ms_drbd_name = ""
        drbd_name = ""
        group_fs_name = ""
        fs_name = ""
        dlm_name = ""
        gfs_name = ""
        group_gfs_name = ""
        clone_group_name = ""
        sync_update_name = ""

	def edit_location(self, rsc, del_flag):
		if rsc not in self.rsc_location_id.keys():
			self.get_rsc_location(rsc)
		location_id = self.rsc_location_id[rsc]
		location_score = self.rsc_location_score[rsc]
		for node in location_score.keys():
			if del_flag:
				for rsc_location in manager.xml_nodes["cib"].getElementsByTagName("rsc_location"):
					id = str(rsc_location.getAttribute("id"))
					if node in location_id.keys() and id in location_id[node]:
						self.xml_constraints.removeChild(rsc_location)
			else:
				if location_score[node] == self.new_location_score[node]:
					continue
				for rsc_location in manager.xml_nodes["cib"].getElementsByTagName("rsc_location"):
					id = str(rsc_location.getAttribute("id"))
					if node in location_id.keys() and id in location_id[node]:
						self.xml_constraints.removeChild(rsc_location)
				impl = getDOMImplementation()
				newdoc = impl.createDocument(None, "rsc_location", None)
				loc = newdoc.documentElement
				loc.setAttribute("id", str("%s-location-on-%s"%(rsc, node)))
				loc.setAttribute("node", str(node))
				loc.setAttribute("rsc", str(rsc))
				loc.setAttribute("score", str(self.new_location_score[node]))
				self.xml_constraints.appendChild(loc)
		return {'action':0}

	#删除原有的实时镜像资源
	def mirror_del_org(self):
		rsc_deled = []
		gfs_had_deled = False
		for type in self.mirror_rsc_list_org.keys():
			if type in ["clone_fs",  "clone_dlm", "clone_gfs"]:
				if not gfs_had_deled:
					gfs_had_deled = True
					for xml_clone in manager.xml_nodes["cib"].getElementsByTagName("clone"):
						id = str(xml_clone.getAttribute("id"))
						if id == self.clone_group_name:
							rsc = xml_clone
							rsc_deled.append(rsc)
							break
				continue
			
			for rsc in self.mirror_rsc_list_org[type]:
				if type in ["ms_drbd"]:
					rsc = rsc.parentNode
				parent = rsc.parentNode.getAttribute('id')
				if len(manager.get_sub_rsc(str(parent))) == 1:
					rsc = rsc.parentNode
				rsc_deled.append(rsc)

		if len(rsc_deled) == 0 :
			return {'action':0}

		rsc_id = ""
		for rsc in rsc_deled:
			rsc_id += rsc.getAttribute('id') + "      "
		for rsc in rsc_deled:
			ret = self.del_res(rsc, True)
			if ret['action']==1:
				return ret

		return {'action':0, 'msg':_("Note: The following former resources has been deleted:\n")+str(rsc_id)}


        def del_res(self, selected_node, del_group=True):
                        parent = selected_node.parentNode.getAttribute('id')
                        if len(manager.get_sub_rsc(str(parent))) == 1 :
                                if del_group:
                                        selected_node = get_top_parent_rsc(selected_node)
                                else:
                                        ret = (_("Group must retain at least a resource!"))
                                        return {'action':1, 'msg':ret}

                        del_drbd = False
                        if selected_node.getAttribute('type') == "drbd":
                                selected_node = get_top_parent_rsc(selected_node)
                                del_drbd = True
                        elif manager.get_rsc_type(selected_node.getAttribute('id')) in ["master"]:
                                for primitive in selected_node.getElementsByTagName("primitive"):
                                        if primitive.getAttribute('type') == "drbd":
                                                del_drbd = True
                                                break

                        if del_drbd:
                                manager.cib_do_cmd("cib_replace\ndrbd_split\n%s"%(str("<drbd_split/>")))
                                if manager.failed_reason != "" :
                                        ret = (manager.failed_reason)
                                        return {'action':1, 'msg':ret}

                        rsc_locations = []
                        for rsc_location in manager.xml_nodes["cib"].getElementsByTagName("rsc_location") :
                                if rsc_location.getAttribute('rsc') == selected_node.getAttribute("id"):
                                        rsc_locations.append(rsc_location)

                        rsc_colocations = []
                        for rsc_colocation in manager.xml_nodes["cib"].getElementsByTagName("rsc_colocation") :
                                if rsc_colocation.getAttribute('rsc') == selected_node.getAttribute("id") or rsc_colocation.getAttribute('with-rsc') == selected_node.getAttribute("id"):
                                        rsc_colocations.append(rsc_colocation)

                        rsc_orders = []
                        for rsc_order in manager.xml_nodes["cib"].getElementsByTagName("rsc_order") :
                                if rsc_order.getAttribute('first') == selected_node.getAttribute("id") or rsc_order.getAttribute('then') == selected_node.getAttribute("id"):
                                        rsc_orders.append(rsc_order)

                        for location in rsc_locations :
                                xml_str = location.toxml().replace("\n", "")
                                manager.cib_do_cmd("cib_delete\nconstraints\n%s"%(str(xml_str)))

                        for colocation in rsc_colocations :
                                xml_str = colocation.toxml().replace("\n", "")
                                manager.cib_do_cmd("cib_delete\nconstraints\n%s"%(str(xml_str)))

                        for order in rsc_orders :
                                xml_str = order.toxml().replace("\n", "")
                                manager.cib_do_cmd("cib_delete\nconstraints\n%s"%(str(xml_str)))

                        rsc_constes = []
                        for rsc_conste in manager.xml_nodes["cib"].getElementsByTagName("conste_resources") :
                                if rsc_conste.getAttribute('rscid') == selected_node.getAttribute("id"):
                                        rsc_constes.append(rsc_conste)

                        if len(manager.xml_nodes["cib"].getElementsByTagName("conste_resources")) == 2 and \
                                len(rsc_constes) == 1 :
                                for conste in manager.xml_nodes["cib"].getElementsByTagName("conste_resources") :
                                        xml_str = conste.toxml().replace("\n", "")
                                        manager.cib_do_cmd("cib_delete\nconstes\n%s"%(str(xml_str)))
                        else:
                                for conste in rsc_constes :
                                        xml_str = conste.toxml().replace("\n", "")
                                        manager.cib_do_cmd("cib_delete\nconstes\n%s"%(str(xml_str)))

                        #selected_node.parentNode.removeChild(selected_node)
			if manager.validate_cib() :
                                xml_str = selected_node.toxml().replace("\n", "")
                                manager.cib_do_cmd("cib_delete\n%s\n%s"%(str("resources"), str(xml_str))) #change selected_node.tagName to resources added by jian.hou
                                if manager.failed_reason != "" :
                                        ret = selected_node.getAttribute("id")+":"+manager.failed_reason
                                        if manager.active_cib != "" :
                                                manager.set_update()
                                        return {'action':1, 'msg':ret}
                                manager.set_update()
                        return {'action':0}


	def check_dir_exist(self, dirs, type, main_node_active=None):
		if dirs == "" :
			label=_("Please input the backup directories!")
			if type != "drbd" and (type!="mirror" or main_node_active != None):
				label=label+_("And different directories should be separated by a semicolon!")
			ret = label
			return {'action':1, 'msg':ret}

		all_dir = dirs.split(";")
		if type == "drbd" and len(all_dir)>1:
			ret = (_("Please check the mount directory!"))
			return {'action':1, 'msg':ret}

		if type == "mirror" and main_node_active == None and len(all_dir)>1:
			ret = (_("Please check the mount directory!"))
			return {'action':1, 'msg':ret}

		check_local_host = True
		'''if main_node_active != None:
			if type == "mirror":
		                main_node_mode = self.mirror_glade.get_widget('main_node').get_model()
			else:
		                main_node_mode = self.widget_backup_main_node.get_model()
        	        main_node = main_node_mode[main_node_active][0]

			if main_node in manager.get_local_node():
				check_local_host = True
			else:
				check_local_host = False
	                        ip = manager.get_one_node_ip(main_node)
        	                if ip == None:
                	                ret = (_("Can not get the ipaddress of main node!") + _("Or can not be connected!") + "\n" + _("Please make sure that the environment is configured correctly!"))
                        	        return {'action':1, 'msg':ret}'''

		for dir in all_dir:
			if dir == "":
                                continue

			if all_dir.count(dir)>1:
				ret = (_("Please check the directory %s, and do not repeat input!")%(dir))
				return {'action':1, 'msg':ret}

			cmd = "test -d "+dir+" && echo 'true' || echo 'false'"
			if not check_local_host:
                	        if "false" in manager.query("ssh_node\n%s\n%s\n%s\n%s"%(str(ip), str("HASql"), str("qwert12345"), str(cmd))):
                	        	if "false" in manager.do_cmd("ssh_node\n%s\n%s\n%s\n%s"%(str(ip), str("HASql"), str("qwert12345"), str(cmd))):
						label=_("Please confirm the directory %s is exist on the main node!")%(dir)
						if type != "drbd"  and (type!="mirror" or main_node_active != None) :
							label=label+_("And different directories should be separated by a semicolon!")
						ret = label
						return {'action':1, 'msg':ret}
			else:
				#ret = manager.query("system\n%s"%(str(cmd)))
                                ret = os.popen(cmd).read().split('\n')
				if ret == None or ret == [] or "false" in ret:
					#if "false" in manager.do_cmd("system\n%s"%(str(cmd))):
                                        if "false" in os.popen(cmd).read().split('\n'):
						label=_("Please confirm the directory %s is exist!")%(dir)
						if type != "drbd" and (type!="mirror" or main_node_active != None) :
							label=label+_("And different directories should be separated by a semicolon!")
						ret = label
						return {'action':1, 'msg':ret}

			if type == "backup":
				if dir in self.mirror_dir_org.split(";"):
					ret = (_("Please confirm the directory %s is not in the mirror backup directories!")%(dir))
					return {'action':1, 'msg':ret}
			elif type == "mirror":
				if dir in self.backup_dir_org.split(";"):
					ret = (_("Please confirm the directory %s is not in the scheduled backup directories!")%(dir))
					return {'action':1, 'msg':ret}

		return {'action':0}

	def is_larger(self, first, last):
		if first in ['infinity', 'INFINITY', '+infinity', '+INFINITY']:
			return True
		elif first in ['-infinity', '-INFINITY']:
			return False
		elif last in ['infinity', 'INFINITY', '+infinity', '+INFINITY']:
			return False
		elif last in ['-infinity', '-INFINITY']:
			return True
		elif int(first) > int(last):
			return True
		else:
			return False

	def mirror_save_drbd(self, ms_drbd_name, type, nodes, dir):
		main_node_name = nodes["main_node_name"]
		main_node_ip = nodes["main_node_ip"]
		main_node_disk = nodes["main_node_device"]

		slave_node_name = nodes["slave_node_name"]
		slave_node_ip = nodes["slave_node_ip"]
		slave_node_disk = nodes["slave_node_device"]

		#get location
		if ms_drbd_name not in self.rsc_location_score.keys():
			self.get_rsc_location(ms_drbd_name)
		location_score = self.rsc_location_score[ms_drbd_name]
		self.new_location_score = {}
		for node in self.nodes:
			self.new_location_score[node] = str('-INFINITY')
		if self.is_larger(location_score[main_node_name], location_score[slave_node_name]):
			self.new_location_score[main_node_name] = location_score[main_node_name]
			self.new_location_score[slave_node_name] = location_score[slave_node_name]
		elif self.is_larger(location_score[main_node_name], 20000):
			self.new_location_score[slave_node_name] = str('16000')
		else:
			self.new_location_score[main_node_name] = str('20000')
			self.new_location_score[slave_node_name] = str('16000')

		#将信息保存至drbdx.res配置文件，将DRBD配置文件同步到其他节点，同步完成后提示用户运行脚本初始化DRBD设备
		if self.mirror_main_node_org==main_node_name and self.mirror_main_ip_org==main_node_ip and self.mirror_main_disk_org==main_node_disk \
			and self.mirror_slave_node_org==slave_node_name and self.mirror_slave_ip_org==slave_node_ip and self.mirror_slave_disk_org==slave_node_disk \
			and self.mirror_type_org==type and self.mirror_dir_org==dir:
			return {'action':0}

		msg = ""
		ret = self.check_drbd(main_node_name, main_node_ip, main_node_disk, slave_node_name, slave_node_ip, slave_node_disk, dir)
		if 'msg' in ret.keys():
			msg = msg + ret['msg']
		if ret['action'] == 1:
			return ret

		ret = self.save_drbd_file(main_node_name, main_node_ip, main_node_disk, slave_node_name, slave_node_ip, slave_node_disk, type)
		if 'msg' in ret.keys():
		    msg = msg+ret['msg']
		if ret['action'] == 1:
		    return {'action':1, 'msg':msg}
		
		if type == "active":
			msg = msg + "<br>" + _("Please run command on both nodes:\n")+"/usr/sbin/drbd_init gfs2\n"+"<br>"
                        msg = msg + _("And then start the resources %s\n")%("ms-drbd gfs-group")+"<br>"
		else:
			msg = msg + "<br>" + _("Please run command on both nodes:\n")+"/usr/sbin/drbd_init\n"+"<br>"
                        msg = msg + _("And then start the resources %s\n")%("ms-drbd group-fs-ps")+"<br>"
		return {'action':0, 'msg':msg}

	def create_drbd_resource(self, ms_drbd_name, drbd_name, type):
		#添加drbd资源
		impl = getDOMImplementation()
		newdoc = impl.createDocument(None, "master", None)
		new_master = newdoc.documentElement
		new_master.setAttribute('id', ms_drbd_name)

		newdoc = impl.createDocument(None, "meta_attributes", None)
		new_meta = newdoc.documentElement
		new_meta.setAttribute('id', ms_drbd_name+"-meta_attributes")

		value = {}
		value["clone-max"] = "2"
		if type == "active":
			value["master-max"] = "2"
		else:
			value["master-max"] = "1"
		value["notify"] = "true"
		value["target-role"] = "Stopped"

		for name in value.keys():
			newdoc = impl.createDocument(None, "nvpair", None)
			new_nvpair = newdoc.documentElement
			new_nvpair.setAttribute('id', ms_drbd_name+"-meta_attributes-"+name)
			new_nvpair.setAttribute('name', name)
			new_nvpair.setAttribute('value', value[name])
			new_meta.appendChild(new_nvpair)

		newdoc = impl.createDocument(None, "primitive", None)
		new_primitive = newdoc.documentElement
		new_primitive.setAttribute('class', "ocf")
		new_primitive.setAttribute('id', drbd_name)
		new_primitive.setAttribute('provider', "linbit")  # added by jian.hou change drbd res from common to linbit 
		new_primitive.setAttribute('type', "drbd")

		newdoc = impl.createDocument(None, "operations", None)
		new_operation = newdoc.documentElement
		new_operation.setAttribute('id', drbd_name+"-operations")

		newdoc = impl.createDocument(None, "op", None)
		new_op = newdoc.documentElement
		new_op.setAttribute('id', drbd_name+"-op-monitor-Slave-20")
		new_op.setAttribute('interval', "20")
		new_op.setAttribute('name', "monitor")
		new_op.setAttribute('role', "Slave")
		new_op.setAttribute('timeout', "20")
		new_operation.appendChild(new_op)

		newdoc = impl.createDocument(None, "op", None)
		new_op = newdoc.documentElement
		new_op.setAttribute('id', drbd_name+"-op-monitor-Master-10")
		new_op.setAttribute('interval', "10")
		new_op.setAttribute('name', "monitor")
		new_op.setAttribute('role', "Master")
		new_op.setAttribute('timeout', "20")
		new_operation.appendChild(new_op)

		new_primitive.appendChild(new_operation)

		newdoc = impl.createDocument(None, "instance_attributes", None)
		new_ins = newdoc.documentElement
		new_ins.setAttribute('id', drbd_name+"-instance_attributes")

		newdoc = impl.createDocument(None, "nvpair", None)
		new_nvpair = newdoc.documentElement
		new_nvpair.setAttribute('id', drbd_name+"-instance_attributes-drbd_resource")
		new_nvpair.setAttribute('name', "drbd_resource")
		new_nvpair.setAttribute('value', "drbd0")
		new_ins.appendChild(new_nvpair)

		new_primitive.appendChild(new_ins)
		new_master.appendChild(new_meta)
		new_master.appendChild(new_primitive)

		xml_str = new_master.toxml().replace("\n", "")

		manager.cib_do_cmd("cib_create\n%s\n%s"%(str("resources"), str(xml_str)))
		if manager.failed_reason != "" :
			ret = manager.failed_reason
			return {'action':1, 'msg':ret}
		return {'action':0}

	def edit_drbd_resource(self, ms_id, id, master_max):
		for xml_node in self.mirror_rsc_list_org["ms_drbd"]:
			if xml_node.getAttribute('id') != id :
				continue
			ms_drbd_node = xml_node.parentNode
			for nvpair in ms_drbd_node.getElementsByTagName('nvpair'):
                        	if nvpair.nodeType != xml.dom.Node.ELEMENT_NODE :
                                	continue
	                        if nvpair.getAttribute("name") == "master-max":
					if nvpair.getAttribute("value") == master_max:
						return {'action':0}
					else:
	        	                        nvpair.setAttribute("value", master_max)

		xml_str = ms_drbd_node.toxml().replace("\n", "")

                manager.cib_do_cmd("cib_replace\n%s\n%s"%(str("master"), str(xml_str)))
                if manager.failed_reason != "" :
                        ret = manager.failed_reason
                        return {'action':1, 'msg':ret}
                return {'action':0}

	def create_group_fs_resource(self, group_name, fs_name, dir):
		#add group(fs)
		impl = getDOMImplementation()
		newdoc = impl.createDocument(None, "group", None)
		new_group = newdoc.documentElement
		new_group.setAttribute('id', group_name)

		newdoc = impl.createDocument(None, "meta_attributes", None)
		new_meta = newdoc.documentElement
		new_meta.setAttribute('id', group_name+"-meta_attributes")

		newdoc = impl.createDocument(None, "nvpair", None)
		new_nvpair = newdoc.documentElement
		new_nvpair.setAttribute('id', group_name+"-meta_attributes-target-role")
		new_nvpair.setAttribute('name', "target-role")
		new_nvpair.setAttribute('value', "Stopped")
		new_meta.appendChild(new_nvpair)
		new_group.appendChild(new_meta)

		newdoc = impl.createDocument(None, "primitive", None)
		new_primitive = newdoc.documentElement
		new_primitive.setAttribute('class', "ocf")
		new_primitive.setAttribute('id', fs_name)
		new_primitive.setAttribute('provider', "heartbeat") # From common to heartbeat added by jian.hou
		new_primitive.setAttribute('type', "Filesystem")

		newdoc = impl.createDocument(None, "operations", None)
		new_operations = newdoc.documentElement
		new_operations.setAttribute('id', fs_name+"-operations")

		newdoc = impl.createDocument(None, "op", None)
		new_op = newdoc.documentElement
		new_op.setAttribute('id', fs_name+"-op-monitor-20")
		new_op.setAttribute('interval', "20")
		new_op.setAttribute('name', "monitor")
		new_op.setAttribute('timeout', "40")
		new_operations.appendChild(new_op)
		new_primitive.appendChild(new_operations)

		newdoc = impl.createDocument(None, "instance_attributes", None)
		new_ins = newdoc.documentElement
		new_ins.setAttribute('id', fs_name+"-instance_attributes")

		newdoc = impl.createDocument(None, "nvpair", None)
		new_nvpair = newdoc.documentElement
		new_nvpair.setAttribute('id', fs_name+"-instance_attributes-device")
		new_nvpair.setAttribute('name', "device")
		new_nvpair.setAttribute('value', "/dev/drbd0")
		new_ins.appendChild(new_nvpair)

		newdoc = impl.createDocument(None, "nvpair", None)
		new_nvpair = newdoc.documentElement
		new_nvpair.setAttribute('id', fs_name+"-instance_attributes-directory")
		new_nvpair.setAttribute('name', "directory")
		new_nvpair.setAttribute('value', dir)
		new_ins.appendChild(new_nvpair)

		newdoc = impl.createDocument(None, "nvpair", None)
		new_nvpair = newdoc.documentElement
		new_nvpair.setAttribute('id', fs_name+"-instance_attributes-fstype")
		new_nvpair.setAttribute('name', "fstype")
		new_nvpair.setAttribute('value', "xfs") # added by jian.hou from ext4 to xfs
		new_ins.appendChild(new_nvpair)

		new_primitive.appendChild(new_ins)
		new_group.appendChild(new_primitive)

		xml_str = new_group.toxml().replace("\n", "")
		manager.cib_do_cmd("cib_create\n%s\n%s"%(str("resources"), str(xml_str)))
		if manager.failed_reason != "" :
			ret = manager.failed_reason
			return {'action':1, 'msg':ret}

		return {'action':0}

	def edit_fs_resource(self, rsc_type, id, device, dir):
		for xml_node in self.mirror_rsc_list_org[rsc_type]:
			if xml_node.getAttribute('id') != id :
				continue
			for nvpair in xml_node.getElementsByTagName('nvpair'):
                        	if nvpair.nodeType != xml.dom.Node.ELEMENT_NODE :
                                	continue
	                        if nvpair.getAttribute("name") == "directory":
        	                        nvpair.setAttribute("value", dir)
	                        elif nvpair.getAttribute("name") == "device":
        	                        nvpair.setAttribute("value", device)

		xml_str = xml_node.toxml().replace("\n", "")

                manager.cib_do_cmd("cib_replace\n%s\n%s"%(str("primitive"), str(xml_str)))
                if manager.failed_reason != "" :
                        ret = manager.failed_reason
                        return {'action':1, 'msg':ret}
                return {'action':0}

	#添加clone dlm+gfs+fs资源
	def create_gfs_resource(self, disk, dir):
		return gfs_create(disk, dir)

	#add NKSync_update resource
	def create_rsync_update_resource(self,value):
		group_id = self.sync_update_group_name
		rsc_id = self.sync_update_name

		impl = getDOMImplementation()
		newdoc = impl.createDocument(None, "group", None)
		new_group = newdoc.documentElement
		new_group.setAttribute('id', group_id)

                newdoc = impl.createDocument(None, "meta_attributes", None)
                new_meta = newdoc.documentElement
                new_meta.setAttribute('id', group_id+"-meta_attributes")

                newdoc = impl.createDocument(None, "nvpair", None)
                new_nvpair = newdoc.documentElement
                new_nvpair.setAttribute('id', group_id+"-meta_attributes-target-role")
                new_nvpair.setAttribute('name', "target-role")
                new_nvpair.setAttribute('value', "Stopped")
                new_meta.appendChild(new_nvpair)
		new_group.appendChild(new_meta)

		newdoc = impl.createDocument(None, "primitive", None)
		new_primitive = newdoc.documentElement
		new_primitive.setAttribute("class", "ocf")
		new_primitive.setAttribute("id", rsc_id)
		new_primitive.setAttribute("provider", "common")
		new_primitive.setAttribute("type", "NKSync_update")

                newdoc = impl.createDocument(None, "operations", None)
                new_operation = newdoc.documentElement
                new_operation.setAttribute('id', rsc_id+"-operations")

                newdoc = impl.createDocument(None, "op", None)
                new_op = newdoc.documentElement
                new_op.setAttribute('id', rsc_id+"-op-monitor-10")
                new_op.setAttribute('interval', "10")
                new_op.setAttribute('name', "monitor")
                new_op.setAttribute('timeout', "20")
                new_operation.appendChild(new_op)
		new_primitive.appendChild(new_operation)

                newdoc = impl.createDocument(None, "instance_attributes", None)
                new_ins = newdoc.documentElement
                new_ins.setAttribute('id', rsc_id+"-instance_attributes")

		for nv in ["node_list", "passwd_list", "data_dir"]:
			newdoc = impl.createDocument(None, "nvpair", None)
			new_nvpair = newdoc.documentElement
			new_nvpair.setAttribute('id', rsc_id+"-instance_attributes-"+nv)
			new_nvpair.setAttribute('name', nv)
			new_nvpair.setAttribute('value', value[nv])
			new_ins.appendChild(new_nvpair)

		new_primitive.appendChild(new_ins)
		new_group.appendChild(new_primitive)

		xml_str = new_group.toxml().replace("\n", "")
		manager.cib_do_cmd("cib_create\n%s\n%s"%(str("resources"), str(xml_str)))
		if manager.failed_reason != "" :
			ret = manager.failed_reason
			return {'action':1, 'msg':ret}

		return {'action':0}

	def edit_rsync_update_resource(self, id, value):
		for xml_node in self.mirror_rsc_list_org["group_update"]:
			if xml_node.getAttribute('id') == id :
				break
		for nvpair in xml_node.getElementsByTagName('nvpair'):
			if nvpair.nodeType != xml.dom.Node.ELEMENT_NODE :
				continue
			if nvpair.getAttribute("name") == "node_list":
				nvpair.setAttribute("value", value["node_list"])
			elif nvpair.getAttribute("name") == "passwd_list":
				nvpair.setAttribute("value", value["passwd_list"])
			elif nvpair.getAttribute("name") == "data_dir":
				nvpair.setAttribute("value", value["data_dir"])
		xml_str = xml_node.toxml().replace("\n", "")

		manager.cib_do_cmd("cib_replace\n%s\n%s"%(str("primitive"), str(xml_str)))
		if manager.failed_reason != "" :
			ret = manager.failed_reason
			return {'action':1, 'msg':ret}
		return {'action':0}


	#保存双机主备模式配置
	def mirror_save_drbd_ps(self,nodes, dir):
		if self.ms_drbd_name == "":
			self.ms_drbd_name = str("ms-drbd")
		if self.drbd_name == "":
			self.drbd_name = str("drbd-ps")
		if self.group_fs_name == "":
			self.group_fs_name = str("group-fs-ps")
		if self.fs_name == "":
			self.fs_name = str("fs-ps")

		#dir = self.mirror_glade.get_widget("dir").get_text()
		device = "/dev/drbd0"

		ret_msg = ""
		#将信息保存至drbdx.res配置文件同步
		ret = self.mirror_save_drbd(self.ms_drbd_name, "standby", nodes, dir)
		if 'msg' in ret.keys():
			ret_msg = ret_msg + ret['msg']
		if ret['action'] == 1:
			return ret

		#脚本运行完成后添加drbd+group(fs)资源；
		if self.mirror_node_type_org != "two" or self.mirror_type_org != "standby":
			ret = self.mirror_del_org()
			if 'msg' in ret.keys():
				ret_msg = ret_msg + ret['msg']
			if ret['action'] == 1:
				return {'action':1, 'msg':ret_msg}
			ret = self.create_drbd_resource(self.ms_drbd_name, self.drbd_name, "standby")
			if 'msg' in ret.keys():
				ret_msg = ret_msg + ret['msg']
			if ret['action'] == 1:
				return {'action':1, 'msg':ret_msg}
			ret = self.create_group_fs_resource(self.group_fs_name, self.fs_name, dir) 
			if 'msg' in ret.keys():
				ret_msg = ret_msg + ret['msg']
			if ret['action'] == 1:
				return {'action':1, 'msg':ret_msg}
		else:
			ret = self.edit_drbd_resource(self.ms_drbd_name, self.drbd_name, "1")
			if 'msg' in ret.keys():
				ret_msg = ret_msg + ret['msg']
			if ret['action'] == 1:
				return {'action':1, 'msg':ret_msg}
			ret = self.edit_fs_resource("group_fs", self.fs_name, device, dir)
			if 'msg' in ret.keys():
				ret_msg = ret_msg + ret['msg']
			if ret['action'] == 1:
				return {'action':1, 'msg':ret_msg}
		#add location
		self.xml_constraints = manager.xml_nodes["cib"].getElementsByTagName("constraints")[0]
		ret = self.edit_location(self.ms_drbd_name, False)
		if 'msg' in ret.keys():
			ret_msg = ret_msg + ret['msg']
		if ret['action'] == 1:
			return {'action':1, 'msg':ret_msg}
		ret = self.edit_location(self.group_fs_name, True)
		if 'msg' in ret.keys():
			ret_msg = ret_msg + ret['msg']
		if ret['action'] == 1:
			return {'action':1, 'msg':ret_msg}
		xml_str = self.xml_constraints.toxml().replace("\n", "")
		manager.cib_do_cmd("cib_replace\n%s\n%s"%(str("constraints"), str(xml_str)))
		if manager.failed_reason != "" :
			ret = manager.failed_reason
			return {'action':1, 'msg':ret}

		return {'action':0, 'msg':ret_msg}

	#保存双机主主模式配置
	def mirror_save_drbd_pp(self, nodes, dir):
		if self.ms_drbd_name == "":
			self.ms_drbd_name = str("ms-drbd")
		if self.drbd_name == "":
			self.drbd_name = str("drbd-pp")
		if self.dlm_name == "":
			self.dlm_name = str("dlm-drbd")
		if self.gfs_name == "":
			self.gfs_name = str("gfs-drbd")
		if self.fs_name == "":
			self.fs_name = str("fs-drbd")
		if self.group_gfs_name == "":
			self.group_gfs_name = str("group-gfs-drbd")
		if self.clone_group_name == "":
			self.clone_group_name = str("clone-gfs-drbd")

		#dir = self.mirror_glade.get_widget("dir").get_text()
		device = "/dev/drbd0"

		ret_msg = ""
		#将信息保存至drbdx.res配置文件同步
		ret = self.mirror_save_drbd(self.ms_drbd_name, "active", nodes, dir)
		if 'msg' in ret.keys():
			ret_msg = ret_msg + ret['msg']
		if ret['action'] == 1:
			return ret

		#脚本运行完成后添加drbd+dlm+gfs+fs+fencing资源
		if self.mirror_node_type_org != "two" or self.mirror_type_org != "active":
			ret = self.mirror_del_org()
			if 'msg' in ret.keys():
				ret_msg = ret_msg + ret['msg']
			if ret['action'] == 1:
				return ret
			ret = self.create_drbd_resource(self.ms_drbd_name, self.drbd_name, "active")
			if 'msg' in ret.keys():
				ret_msg = ret_msg + ret['msg']
			if ret['action'] == 1:
				return {'action':1, 'msg':ret_msg}
			ret = self.create_gfs_resource(device, dir)
			if 'error' in ret.keys():
				ret_msg = ret_msg + ret['error']
			if not ret['action']:
				return {'action':1, 'msg':ret_msg}
		else:
			ret = self.edit_fs_resource("clone_fs", self.fs_name, device, dir)
			if 'msg' in ret.keys():
				ret_msg = ret_msg + ret['msg']
			if ret['action'] == 1:
				return {'action':1, 'msg':ret_msg}
			ret = self.edit_drbd_resource(self.ms_drbd_name, self.drbd_name, "2")
			if 'msg' in ret.keys():
				ret_msg = ret_msg + ret['msg']
			if ret['action'] == 1:
				return {'action':1, 'msg':ret_msg}

		#add location
		self.xml_constraints = manager.xml_nodes["cib"].getElementsByTagName("constraints")[0]
		ret = self.edit_location(self.ms_drbd_name, True)
		if 'msg' in ret.keys():
			ret_msg = ret_msg + ret['msg']
		if ret['action'] == 1:
			return {'action':1, 'msg':ret_msg}
		ret = self.edit_location(self.clone_group_name, True)
		if 'msg' in ret.keys():
			ret_msg = ret_msg + ret['msg']
		if ret['action'] == 1:
			return {'action':1, 'msg':ret_msg}
		xml_str = self.xml_constraints.toxml().replace("\n", "")
		manager.cib_do_cmd("cib_replace\n%s\n%s"%(str("constraints"), str(xml_str)))
		if manager.failed_reason != "" :
			ret = manager.failed_reason
			return {'action':1, 'msg':ret}
		return {'action':0, 'msg':ret_msg}

	def get_mirror_node_passwd(self, model, path, iter, str_node_passwd):
		node = model.get_value(iter, 0)
		password = model.get_value(iter, 1)
		passwd = manager.query("pwd_encode\n%s"%(str(password)))[0]
		str_node_passwd[2] = str_node_passwd[2]+1

		if str_node_passwd[0] == "":
			str_node_passwd[0] = node
		else:
			str_node_passwd[0] = str_node_passwd[0] + " " + node
		if str_node_passwd[1] == "":
			str_node_passwd[1] = passwd
		else:
			str_node_passwd[1] = str_node_passwd[1] + " " + passwd

	#读取DRBD配置文件内容
        def get_drbd_file(self):
                f = manager.query("get_file_context\n"+self.drbd_filename)
                if f == None or f == []:
                	f = manager.do_cmd("get_file_context\n"+self.drbd_filename)
			if f == None or f == []:
                        	return

                drbd = {}
                index = 0
                while index < len(f):
                        #self.file_drbd_org.append(f[index])
                        if "#" in f[index]:
                                strline = f[index].split("#")[0]
                        else:
                                strline = f[index]

                        strline = strline.strip()
                        if drbd.has_key("name1") and drbd.has_key("ip1") and drbd.has_key("disk1"):
                                m = re.match('^on(.+){$', strline)
                                if m is not None:
                                        drbd["name2"] = m.groups()[0].strip()
                                m = re.match('^disk(.+);$', strline)
                                if m is not None:
                                        drbd["disk2"] = m.groups()[0].strip()

                                m = re.match('^address(.+):(.+);$', strline)
                                if m is not None:
                                        drbd["ip2"] = m.groups()[0].strip()
                        else:
                                m = re.match('^on(.+){$', strline)
                                if m is not None:
                                        drbd["name1"] = m.groups()[0].strip()
                                m = re.match('^disk(.+);$', strline)
                                if m is not None:
                                        drbd["disk1"] = m.groups()[0].strip()

                                m = re.match('^address(.+):(.+);$', strline)
                                if m is not None:
                                        drbd["ip1"] = m.groups()[0].strip()
                        index = index + 1

                if drbd.has_key("name1") and drbd.has_key("ip1") and drbd.has_key("disk1") and drbd.has_key("name2") and drbd.has_key("ip2") and drbd.has_key("disk2"):
                        return drbd
                return


	def check_drbd(self, name1, ip1, disk1, name2, ip2, disk2, dir):
		if name1 == name2 :
			ret = (_("Please confirm the two nodes, they must be different!\n"))
			return {'action':1, 'msg':ret}

		if name1 == "" or name2 =="":
			ret = (_("Please select nodes!\n"))
			return {'action':1, 'msg':ret}

		m = re.match('^(\d+)\.(\d+)\.(\d+)\.(\d+)$', ip1)
                if m is None or int(m.groups()[0])<=0 or int(m.groups()[0])>255 or int(m.groups()[1])<0 or int(m.groups()[1])>255 or int(m.groups()[2])<0 or int(m.groups()[2])>255 or int(m.groups()[3])<0 or int(m.groups()[3])>255 :
                        ret = (_("Please confirm the IP address of %s!\n")%(name1))
                        return {'action':1, 'msg':ret}

		m = re.match('^(\d+)\.(\d+)\.(\d+)\.(\d+)$', ip2)
                if m is None or int(m.groups()[0])<=0 or int(m.groups()[0])>255 or int(m.groups()[1])<0 or int(m.groups()[1])>255 or int(m.groups()[2])<0 or int(m.groups()[2])>255 or int(m.groups()[3])<0 or int(m.groups()[3])>255 :
                        ret = (_("Please confirm the IP address of %s!\n")%(name2))
                        return {'action':1, 'msg':ret}

		if str(ip1) == str(ip2):
                        ret = (_("Please confirm the IP addresses! They must be different!\n"))
                        return {'action':1, 'msg':ret}

		if not manager.check_device(disk1) or not manager.check_device(disk2):
			ret = (_("Please input the device you want!\n"))
			return {'action':1, 'msg':ret}

		ret = self.check_dir_exist(dir, "drbd")
		if ret['action'] == 1:
			return ret

		return {'action':0}

	def save_drbd_file(self, name1, ip1, disk1, name2, ip2, disk2, type):
		content_str = ""
		content_str = content_str + "resource drbd0 {" + "\n"
		content_str = content_str + "\ton " + name1 + " {\n"
		content_str = content_str + "\t\tdevice      /dev/drbd0;" + "\n"
		content_str = content_str + "\t\tdisk        " + disk1 + ";\n"
		content_str = content_str + "\t\taddress     " + ip1 + ":7789;\n"
		content_str = content_str + "\t\tmeta-disk   internal;" + "\n"
		content_str = content_str + "\t}" + "\n"
                content_str = content_str + "\ton " + name2 + " {\n"
                content_str = content_str + "\t\tdevice      /dev/drbd0;" + "\n"
                content_str = content_str + "\t\tdisk        " + disk2 + ";\n"
                content_str = content_str + "\t\taddress     " + ip2 + ":7789;\n"
                content_str = content_str + "\t\tmeta-disk   internal;" + "\n"
                content_str = content_str + "\t}" + "\n"
		content_str = content_str + "}"

	        manager.do_cmd("save_file_context\nfalse\nfalse\n%s\n%s"%(str(self.drbd_filename), str(content_str)))
        	if manager.failed_reason != "" :
                        ret = manager.failed_reason
			return {'action':1, 'msg':ret}
                #item = {'filename':['/atest'],'nodes':[{'node':'10.1.80.22','password':'liuming'},{'node':'10.1.80.21','password':'liuming'}]}

                ret_msg = _("The DRBD changes has saved.\n")
		return {'action':0, 'msg':str(ret_msg)}

	#get rsc's location score and id
	def get_rsc_location(self, rsc):
                location_score = {}
		for node in self.nodes:
			location_score[node] = 0

		location_id = {}

                constraints = manager.query("get_rsc_constraints\n%s"%(str(rsc)))
		if constraints != None:
	                for cons in constraints :
				m = re.match('^\s\s:\sNode\s(.*)\s*\(score=(.*)\,\sid=(.*)\)', cons)
                	        if m is None :
                        	        continue
	                        if m.groups()[0].strip() in self.nodes: #location
        	                        node = m.groups()[0].strip()
                	                score = m.groups()[1].strip()
					id = m.groups()[2].strip()
                                	if node in location_score.keys():
                                        	location_score[node] = web_manager.add_score(score, location_score[node])
	                                else:
        	                                location_score[node] = str(score)
					if node not in location_id.keys():
						location_id[node] = []
					location_id[node].append(id)

		self.rsc_location_score[rsc] = location_score
		self.rsc_location_id[rsc] = location_id

	#根据LOCATION取RSC的主节点
	def get_rsc_mainnode(self, rsc, type):
		if rsc not in self.rsc_location_id.keys():
			self.get_rsc_location(rsc)
		location_score = self.rsc_location_score[rsc]
		if type == "main":
			max = 0
			main_node = manager.get_dc()[0]
			for node in location_score.keys():
				if self.is_larger(location_score[node], max):
					max= location_score[node]
					main_node = node
			return main_node
		else:
			no_run_node = []
			for node in location_score.keys():
				if self.is_larger(0, location_score[node]) :
					no_run_node.append(node)
			return no_run_node

	def mirror_append_rsc(self, key, node):
		if key not in self.mirror_rsc_list_org.keys():
			self.mirror_rsc_list_org[key]=[]
		self.mirror_rsc_list_org[key].append(node)

	#实时镜像初始化
	def mirror_init(self):
		#根据已添加的资源类型及相关参数确定是否配置了实时镜像，根据配置节点的个数确定其为两点镜像还是多点镜像，确定其为单主模式还是多主模式，根据模式的不同获取不同的参数
		#获取资源列表rsc_list
		self.mirror_rsc_list_org={}  #原始镜像资源列表
		mirror_has_gfs = False              #是否存在GFS资源
		self.mirror_main_node_org = ""
		self.mirror_no_run_node_org = []
		self.rsc_location_id = {}
		self.rsc_location_score = {}
		self.mirror_is_use = False
		self.mirror_node_type_org = ""
		self.mirror_type_org=""
		self.mirror_two_active_init = True
		drbd_used = False

		for primitive_node in manager.xml_nodes["cib"].getElementsByTagName("primitive") :
			rsc_type = primitive_node.getAttribute("type")
			parent_node = primitive_node.parentNode
			parent_id = parent_node.getAttribute("id")
			parent_type = manager.get_rsc_type(str(parent_id))
			if rsc_type == "Filesystem":#如果类型为filesystem且device 属性值为/dev/drbd0则为镜像资源
                                for nvpair in primitive_node.getElementsByTagName('nvpair'):
                                        if nvpair.nodeType != xml.dom.Node.ELEMENT_NODE :
                                                continue
                                        if nvpair.getAttribute('name') == 'device' :
                                                if nvpair.getAttribute('value') == "/dev/drbd0" :
                                                        drbd_used = True
						break
							        
				if not drbd_used :
					continue	

				if parent_type in ['clone']:
					self.mirror_append_rsc("clone_fs", primitive_node)
				elif parent_type in ['group']:
					if manager.get_rsc_type(parent_node.parentNode.getAttribute('id')) in ["clone"]:
						self.mirror_append_rsc("clone_fs", primitive_node)
					else:
						self.mirror_append_rsc("group_fs", primitive_node)

			elif rsc_type == "controld":#如果类型为dlm，gfs，and rsc parent is clone则为镜像资源
				controld_attr = []
				for nvpair in primitive_node.getElementsByTagName('nvpair'):
					if nvpair.nodeType != xml.dom.Node.ELEMENT_NODE :
						continue
					if nvpair.getAttribute('name') == 'args' and nvpair.getAttribute('value') == "-g 0" :
						controld_attr.append('gfs_args') 
					elif nvpair.getAttribute('name') == 'daemon' and nvpair.getAttribute('value') == "gfs_controld.pcmk" :
						controld_attr.append('gfs_daemon')
			
				if parent_type in ["clone"]:
					if 'gfs_args' in controld_attr and 'gfs_daemon'in controld_attr:
						self.mirror_append_rsc("clone_gfs", primitive_node)
					else:
						self.mirror_append_rsc("clone_dlm", primitive_node)
					self.mirror_no_run_node_org = self.get_rsc_mainnode(str(parent_id), "no_run")
				elif parent_type in ['group']:
					grandparent_id = parent_node.parentNode.getAttribute('id')
					if manager.get_rsc_type(grandparent_id) in ["clone"]:
						if 'gfs_args' in controld_attr and 'gfs_daemon'in controld_attr:
							self.mirror_append_rsc("clone_gfs", primitive_node)
						else:
							self.mirror_append_rsc("clone_dlm", primitive_node)
					self.mirror_no_run_node_org = self.get_rsc_mainnode(str(grandparent_id), "no_run")

			elif rsc_type == "NKSync_update": #type is NKSync_update and parent is group
				if parent_type in ["group"]:
					self.mirror_append_rsc("group_update", primitive_node)
			elif rsc_type == "drbd" :#rsc tyep is drbd and rsc parent is 主从资源
				if parent_type in ["master"]:
					self.mirror_append_rsc("ms_drbd", primitive_node)

		if "clone_gfs" in self.mirror_rsc_list_org.keys() and "clone_dlm" in self.mirror_rsc_list_org.keys() and "clone_fs" in self.mirror_rsc_list_org.keys():
			mirror_has_gfs = True

		#if "group_update" in self.mirror_rsc_list_org.keys():
		#	self.mirror_is_use = True
		#	self.mirror_node_type_org = "multi"
		#	self.mirror_type_org="standby"#多机单主模式
		if "ms_drbd" in self.mirror_rsc_list_org.keys():
			if "group_fs" in self.mirror_rsc_list_org.keys():
				self.mirror_is_use = True
				self.mirror_node_type_org = "two"
				self.mirror_type_org="standby"#双机主备模式
			elif mirror_has_gfs:
				self.mirror_is_use = True
				self.mirror_node_type_org = "two"
				self.mirror_type_org="active"#双机主主模式
		#elif mirror_has_gfs:
		#	self.mirror_is_use = True
		#	self.mirror_node_type_org = "multi"
		#	self.mirror_type_org="active"#双机主主模式
		else:
			#未配置实时镜像
			self.mirror_is_use = False

		return


	def mirror_fs_init(self, gfs=True):
		self.mirror_main_device_org = ""
		self.mirror_dir_org = ""
		if gfs:
			#self.clone_fs_name = ""
			self.group_gfs_name = ""
			self.clone_group_name = ""
			self.fs_name = ""
			get_mirror_gfs = False
			self.mirror_no_run_node_org = self.nodes
			if "clone_fs" not in self.mirror_rsc_list_org.keys():
				return
			for primitive_node in self.mirror_rsc_list_org["clone_fs"]:
				if get_mirror_gfs:
					continue
				for nvpair in primitive_node.getElementsByTagName('nvpair'):
					if nvpair.nodeType != xml.dom.Node.ELEMENT_NODE :
						continue
					if nvpair.getAttribute('name') == 'device' :
						self.mirror_main_device_org = nvpair.getAttribute('value')
					elif nvpair.getAttribute('name') == 'directory':
						self.mirror_dir_org = nvpair.getAttribute('value')
					elif nvpair.getAttribute('name') == 'fstype' and nvpair.getAttribute('value') == 'gfs2':
						get_mirror_gfs = True
				if get_mirror_gfs:
					self.fs_name = str(primitive_node.getAttribute("id"))
					#self.clone_fs_name = str(primitive_node.parentNode.getAttribute("id"))
					self.group_gfs_name = str(primitive_node.parentNode.getAttribute("id"))
					self.clone_group_name = str(primitive_node.parentNode.parentNode.getAttribute("id"))
					self.mirror_no_run_node_org = self.get_rsc_mainnode(str(self.clone_group_name), "no_run")
		else:
			self.group_fs_name = ""
			self.fs_name = ""
			get_mirror_group = False
			if "group_fs" not in self.mirror_rsc_list_org.keys():
				return
			for primitive_node in self.mirror_rsc_list_org["group_fs"]:
				if get_mirror_group:
					continue
				for nvpair in primitive_node.getElementsByTagName('nvpair'):
					if nvpair.nodeType != xml.dom.Node.ELEMENT_NODE :
						continue
					if nvpair.getAttribute('name') == 'device' :
						self.mirror_main_device_org = nvpair.getAttribute('value')
						if self.mirror_main_device_org == "/dev/drbd0" :
							get_mirror_group = True
					elif nvpair.getAttribute('name') == 'directory':
						self.mirror_dir_org = nvpair.getAttribute('value')
				if get_mirror_group:
					self.fs_name = str(primitive_node.getAttribute("id"))
					self.group_fs_name = str(primitive_node.parentNode.getAttribute("id"))

	def mirror_drbd_init(self):
                self.mirror_main_ip_org = ""
                self.mirror_main_disk_org = ""
                self.mirror_slave_node_org = ""
                self.mirror_slave_ip_org = ""
                self.mirror_slave_disk_org = ""
		self.ms_drbd_name = ""
		self.drbd_name = ""
		get_drbd_rsc = False
		if "ms_drbd" not in self.mirror_rsc_list_org.keys():
			return {'action': True}
		for primitive_node in self.mirror_rsc_list_org["ms_drbd"]:
			if get_drbd_rsc:
				continue
			for nvpair in primitive_node.getElementsByTagName('nvpair'):
				if nvpair.nodeType != xml.dom.Node.ELEMENT_NODE :
					continue
				if nvpair.getAttribute('name') == 'drbd_resource' and nvpair.getAttribute('value')=="drbd0":
					get_drbd_rsc = True
			if get_drbd_rsc:
				parent_node= primitive_node.parentNode
				parent_id = parent_node.getAttribute("id")
                		self.ms_drbd_name= str(parent_id)
		                self.drbd_name = str(primitive_node.getAttribute("id"))
				self.mirror_main_node_org = self.get_rsc_mainnode(parent_id, "main")

		drbd = self.get_drbd_file()
                if drbd != None :
			if drbd["name1"] == self.mirror_main_node_org:
				self.mirror_main_ip_org = drbd["ip1"]
                                self.mirror_main_disk_org = drbd["disk1"]
                                self.mirror_slave_node_org = drbd["name2"]
                                self.mirror_slave_ip_org = drbd["ip2"]
                                self.mirror_slave_disk_org = drbd["disk2"]
			else:
                                self.mirror_main_ip_org = drbd["ip2"]
                                self.mirror_main_disk_org = drbd["disk2"]
                                self.mirror_slave_node_org = drbd["name1"]
                                self.mirror_slave_ip_org = drbd["ip1"]
                                self.mirror_slave_disk_org = drbd["disk1"]
		else:
			msg = "Please make sure you have configured the drbd file!"
			return {'action':False, 'msg':msg}
                return {'action': True}

        def judge_node_status(self, node):
                if manager.get_nodetype(node) == 'ping':
                        return -1

                started = manager.get_crm_nodes()
                if node not in started:
                        if manager.get_nodetype(node)=="normal":
                                return 3

                active_nodes = manager.get_active_nodes()
                if node not in active_nodes:
                        try:
                                if manager.get_node_config(node).get("standby") == "True":
                                        return 5
                                else:
                                        return 3
                        except:
                                return 3

                dc = manager.get_dc()
                if dc == None or dc == [] :
                        return 1
                if node in dc:
                        if manager.get_node_config(node).get("standby") == "True":
                                return 4
                        return 0
                if manager.get_node_config(node).get("standby") == "True":
                        return 2

                return 1

        def __init__(self):
                nodes = manager.get_normal_nodes()
                if nodes != None:
                        nodes.sort()

                self.nodes = []
                for node in nodes :
                        status = self.judge_node_status(node)
                        if status == -1:
                                continue
                        self.nodes.append(node)

                self.node_ip = {}
                self.mirror_init()
                ret = self.mirror_drbd_init()
 		# 判断是否是主从或者主主资源
                drbd_type = get_drbd_type() 
		if drbd_type == "1":
	                self.mirror_fs_init(True)
		else:
	                self.mirror_fs_init(False)


def get_drbd():
    mirror = {}
    drbd = DRBD()
    ret = drbd.mirror_drbd_init()
    try:
        if not ret['action']:
            return json.dumps({'action':False, 'error':ret['msg']})
    except:
        pass

    if drbd.mirror_dir_org == "" and drbd.mirror_main_node_org == "":
        return {'action': True, 'data': {}}

    drbd_type = get_drbd_type()
    mirror['dir'] = drbd.mirror_dir_org
    mirror['main_node_name'] = drbd.mirror_main_node_org
    mirror['main_node_ip'] = drbd.mirror_main_ip_org
    mirror['main_node_device'] = drbd.mirror_main_disk_org
    mirror['slave_node_name'] = drbd.mirror_slave_node_org
    mirror['slave_node_ip'] = drbd.mirror_slave_ip_org
    mirror['slave_node_device'] = drbd.mirror_slave_disk_org
    mirror['drbd_type'] = drbd_type

    return json.dumps({'action': True, 'data':mirror})

def get_normal_nodes_num():
    cmd = "crm_node -l|grep 'member' |wc -l"
    status, output = commands.getstatusoutput(cmd)
    if status != 0:
         return 0
    return output

def save_local_drbd(data):
    main_node_name = data['main_node_name']
    slave_node_name = data['slave_node_name']
    main_node_ip = data['main_node_ip']
    main_node_device = data['main_node_device']
    slave_node_device = data['slave_node_device']
    slave_node_ip = data['slave_node_ip']
    
    content_str = ""
    content_str = content_str + "resource drbd0 {" + "\n"
    content_str = content_str + "\ton " + main_node_name + " {\n"
    content_str = content_str + "\t\tdevice      /dev/drbd0;" + "\n"
    content_str = content_str + "\t\tdisk        " + main_node_device + ";\n"
    content_str = content_str + "\t\taddress     " + main_node_ip + ":7789;\n"
    content_str = content_str + "\t\tmeta-disk   internal;" + "\n"
    content_str = content_str + "\t}" + "\n"
    content_str = content_str + "\ton " + slave_node_name + " {\n"
    content_str = content_str + "\t\tdevice      /dev/drbd0;" + "\n"
    content_str = content_str + "\t\tdisk        " + slave_node_device + ";\n"
    content_str = content_str + "\t\taddress     " + slave_node_ip + ":7789;\n"
    content_str = content_str + "\t\tmeta-disk   internal;" + "\n"
    content_str = content_str + "\t}" + "\n"
    content_str = content_str + "}"

    filename = "/etc/drbd.d/drbd0.res"
    try:
        read = file(filename, 'w')
        read.write(content_str)
        read.close
        return {'action': True, 'info': _('Save file context success')}
    except:
        return {'action': False, 'error': _('Save file %s error!') % (filename)}


def set_drbd(item):
    ''' 
    item = {
            "main_node_name":"ns171",
    	    "dir":"/drbd",
    	    "main_node_device":"/dev/vdb",
    	    "slave_node_ip":"10.1.110.172",
    	    "slave_node_name":"ns172",
            "main_node_ip":"10.1.110.171",
            "slave_node_device":"/dev/vdb",
            "drbd_type": "0"
           } 
    '''

    drbd_type = item['drbd_type']
    main_node_ip = item['main_node_ip']
    slave_node_ip = item['slave_node_ip']

    ret = test_api_alive(main_node_ip)
    if 'action' not in ret or not ret['action']:
        return {'action': False, 'error': _('Please make sure the ha-api service for all nodes are running properly')}

    ret = test_api_alive(slave_node_ip)
    if 'action' not in ret or not ret['action']:
        return {'action': False, 'error': _('Please make sure the ha-api service for all nodes are running properly')}

    nodes_num = get_normal_nodes_num()

    if str(nodes_num) != "2":
        return json.dumps({'action':False, 'error':_("The resource drbd can only be run in two-node cluster!")})
    # 关闭原来的资源
    stop_res = "pcs resource disable ms-drbd  --force && pcs resource disable group-fs-ps  --force && pcs resource disable clone-gfs --force"
    commands.getstatusoutput(stop_res)

    del_res = "pcs resource delete ms-drbd  --force && pcs resource delete group-fs-ps  --force && pcs resource delete  clone-gfs --force"
    # 主备模式
    if drbd_type == "0": 
        # 删除原来的资源
        commands.getstatusoutput(del_res)
        drbd = DRBD()
        ret = drbd.mirror_save_drbd_ps(item, item['dir'])
    # 主主模式
    elif drbd_type == "1":
        commands.getstatusoutput(del_res)
        drbd = DRBD()
        ret = drbd.mirror_save_drbd_pp(item, item['dir'])
    else:
	return json.dumps({'action':False, 'error': 'The drbd type is not allowed'})
    
    update()

    # 同步文件
    if ret['action'] == 0:
	if drbd_type == "0":
	    os.popen("pcs constraint colocation add group-fs-ps with ms-drbd INFINITY with-rsc-role=Master --force ;pcs constraint order promote ms-drbd then start group-fs-ps --force")
        else:
	    os.popen("pcs constraint order promote ms-drbd then start clone-gfs --force")
	  
        ret1 = send_remote_drbd_request(item, main_node_ip)
        if 'action' not in ret1 or not ret1['action']:
            return {'action': False, 'error': _('Save drbd configuration failed')}
        ret1 = send_remote_drbd_request(item, slave_node_ip)
        if 'action' not in ret1 or not ret1['action']:
            return {'action': False, 'error': _('Save drbd configuration failed')}

        if 'msg' in ret.keys():
	    msg = ret['msg']
	    if msg == "":
	         msg = "Save drbd configuration success"
            return json.dumps({'action':True, 'info': _(msg)})
        else:
            return json.dumps({'action':True, 'info':"Save drbd configuration success"})
    else:
        if 'msg' in ret.keys():
            return json.dumps({'action':False, 'error':ret['msg']})
        else:
            return json.dumps({'action':False})


#添加删除drbd接口
def del_drbd():
    nodes_num = get_normal_nodes_num()
    if str(nodes_num) != "2":
        return json.dumps({'action':False, 'error':_("The resource drbd can only be run in two-node cluster!")})

    drbd = DRBD()
    ret = drbd.mirror_del_org()
    if ret['action'] == 0:
        if 'msg' in ret.keys():
            return json.dumps({'action':True, 'info':ret['msg']})
        else:
            return json.dumps({'action':True, 'info':"Delete drbd configuration success"})
    else:
        if 'msg' in ret.keys():
            return json.dumps({'action':False, 'error':ret['msg']})
        else:
            return json.dumps({'action':False})

# 获取drbd状态
def get_drbd_status():
    p_cstage = ['WFConnection', 'StandAlone']
    cmd = "drbdadm cstate drbd0"
    status, cstage = commands.getstatusoutput(cmd)
    if status == 0:
        cmd = "drbdadm role drbd0"
        status, role = commands.getstatusoutput(cmd)
        if status == 0:
            role_2 = str(role).split("/")[1]
            if cstage in p_cstage and role_2 == "Unknown":
                return {'action':True, 'data':{"code": "1", "message": _('DRBD is failed, please contact the relevant technical personnel for repair!')}}
    return {'action':True, 'data':{"code": "0", "message": "DRBD is healthy"}}

# 获取当前资源是主从资源还是主主资源
def get_drbd_type():
    status, output = commands.getstatusoutput("pcs resource show drbd-ps")
    if status == 0:
        return "0"
    else:
	return "1" 
