#!/usr/bin/python
# -*-coding:utf-8-*-
# coding: iso-8859-15

from common_utils import is_ha_login
import json
import commands
import re
import os
from xml.dom.minidom import parseString
from xml.dom.minidom import getDOMImplementation
from common_utils import manager, update
import xml


def get_gfs():
    re_gfs_info = {}
    #all_nodes = manager.get_all_nodes()

    for xml_clone in manager.xml_nodes["cib"].getElementsByTagName("nvpair"):
        id = str(xml_clone.getAttribute("id"))
        if id == "gfs_instance_device":
            re_gfs_info['device'] = str(xml_clone.getAttribute("value"))
        if id == "gfs_instance_directory":
            re_gfs_info['mount_dir'] = str(xml_clone.getAttribute("value"))
        if id == "clone-gfs-meta_attributes-clone-max":
            re_gfs_info['max_num'] =  int(xml_clone.getAttribute("value"))
    if manager.failed_reason != "" :
        return json.dumps({'action':False, 'error':_(manager.failed_reason)})
    else:
        return json.dumps({'action':True,'data':re_gfs_info})

def set_gfs(data):
    '''
        data = {"device": "/dev/vdb", "max_num": 2, "mount_dir": "/drbd"}
    '''

    if not manager.check_device(data['device']):
        return json.dumps({'action':False, 'error':_("please input right share diskpath")})
    if len(data['mount_dir'])==0:
        return json.dumps({'action':False, 'error':_("please input directory!")})
    if os.path.isdir(data['mount_dir'])==False:
        return json.dumps({'action':False, 'error':_("directory error!")})
    if int(data['max_num']) > int(len(manager.get_all_nodes())):
        return json.dumps({'action':False, 'error':_("gfs num must little than the number of cluster nodes")})

    if is_existed("clone","clone-gfs") :
        ret = edit_filesystem_clone( data['device'],data['mount_dir'],str(data['max_num']))
    else:
        ret = gfs_create(data['device'],data['mount_dir'],str(data['max_num']))    
    if ret['action']:
        update()
        return json.dumps({'action':True, 'info':_("Are you sure you have format the shared disk to gfs?,please execute gfs_init.sh in /usr/sbin first")+_("And then start the resources %s\n")%("clone-gfs")})

    update()
    return json.dumps(ret)

def del_gfs():

    if is_gfs_rsc_running():
        return json.dumps({'action':False,'error':_("resources is running,please stop it first")})
    ret = delete_resource("clone-gfs")

    update()
    return json.dumps(ret)

def is_existed(type,resourceid):
    xml_resource = {}
    for xml_clone in manager.xml_nodes["cib"].getElementsByTagName(type):
        id = str(xml_clone.getAttribute("id"))	
        if id == resourceid:
            return True
    return False

def is_gfs_rsc_running():
    status = manager.get_rsc_status("dlm_controld")
    if status == "running":
        return True
    status = manager.get_rsc_status("gfs")
    if status == "running":
        return True
    return False

def edit_filesystem_clone(diskpath,directory,gfs_num):
    xmlresources = manager.xml_nodes["cib"].getElementsByTagName("resources")[0]
    for xmlnode in xmlresources.getElementsByTagName("nvpair"):
        if xmlnode.getAttribute("id") == "gfs_instance_device":
            xmlnode.setAttribute("value",diskpath)
        if xmlnode.getAttribute("id") == "gfs_instance_directory":
            xmlnode.setAttribute("value",directory)
        if xmlnode.getAttribute("id") == "clone-gfs-meta_attributes-clone-max":
           xmlnode.setAttribute("value",gfs_num)
    cmdxml = xmlresources.toxml().replace("\n","")
    manager.cib_do_cmd("cib_replace\n%s\n%s"%(str("resources"),str(cmdxml)))
    if manager.failed_reason != "" :
        return {'action':False, 'error':_(manager.failed_reason)}
    return {'action':True, 'info': _("Modify gfs configuration success")}

def delete_resource(resource_name):
    xml_clone = {}
    for xml_clone in manager.xml_nodes["cib"].getElementsByTagName("clone"):
        id = str(xml_clone.getAttribute("id"))	
        if id == resource_name:
            cmdxml = xml_clone.toxml().replace("\n","")
            manager.cib_do_cmd("cib_delete\n%s\n%s"%(str("resources"),str(cmdxml)))
            if manager.failed_reason != "" :
                return {'action':False, 'error':_(manager.failed_reason)}
            else:
                return {'action':True, 'info': _("Delete resource success")}
    return {'action':True, 'info': _("Delete resource success")}


def gfs_create(diskpath,directory,gfs_num = '-1'):    

    if  is_existed("clone","clone-gfs2") == True:
        json.dumps({'action':False, 'error':'the gfs  existsed'})

    impl = getDOMImplementation()
    newdoc = impl.createDocument(None,"clone",None)
    clonegfs = newdoc.documentElement
    clonegfs.setAttribute("id","clone-gfs")
    newdoc = impl.createDocument(None, "meta_attributes", None)
    meta = newdoc.documentElement
    meta.setAttribute("id","clone-gfs-meta_attributes")
    newdoc = impl.createDocument(None, "nvpair", None)
    nvpair1 = newdoc.documentElement
    nvpair1.setAttribute("id","clone-gfs-meta_attributes-interleave")
    nvpair1.setAttribute("name","interleave")
    nvpair1.setAttribute("value","true")
    meta.appendChild(nvpair1)
    newdoc = impl.createDocument(None, "nvpair", None)
    nvpair2 = newdoc.documentElement
    nvpair2.setAttribute("id","clone-gfs-meta_attributes-target-role")
    nvpair2.setAttribute("name","target-role")
    nvpair2.setAttribute("value","Stopped")
    meta.appendChild(nvpair2)
    if gfs_num != '-1':
        newdoc = impl.createDocument(None, "nvpair", None)
        nvpair3 = newdoc.documentElement
        nvpair3.setAttribute("id","clone-gfs-meta_attributes-clone-max")
        nvpair3.setAttribute("name","clone-max")
        nvpair3.setAttribute("value",gfs_num)
        meta.appendChild(nvpair3)
    clonegfs.appendChild(meta)

    #######groupgfs########
    newdoc = impl.createDocument(None, "group", None)
    groupgfs = newdoc.documentElement
    groupgfs.setAttribute("id","gfs-group")

    ################### dlm controld #####################
    newdoc = impl.createDocument(None, "primitive", None)
    primitive = newdoc.documentElement
    primitive.setAttribute("class","ocf")
    primitive.setAttribute("id","dlm_controld")
    primitive.setAttribute("provider","pacemaker")
    primitive.setAttribute("type","controld")
    newdoc = impl.createDocument(None, "operations", None)
    operation = newdoc.documentElement
    newdoc = impl.createDocument(None, "op", None)
    op = newdoc.documentElement
    op.setAttribute("id","dlm_controld-op-monitor-10")
    op.setAttribute("interval","10")
    op.setAttribute("name","monitor")
    op.setAttribute("start-delay","0")
    op.setAttribute("timeout","20")
    operation.appendChild(op)
    primitive.appendChild(operation)
    groupgfs.appendChild(primitive)


    ################## gfs fs ################################
    newdoc = impl.createDocument(None, "primitive", None)
    primitive = newdoc.documentElement
    primitive.setAttribute("class","ocf")
    primitive.setAttribute("id","gfs")
    primitive.setAttribute("provider","heartbeat")  # from common to heartbeat added by jian.hou
    primitive.setAttribute("type","Filesystem")
    newdoc = impl.createDocument(None, "operations", None)
    operation = newdoc.documentElement
    newdoc = impl.createDocument(None, "op", None)
    op = newdoc.documentElement
    op.setAttribute("id","gfs-op-monitor-20")
    op.setAttribute("interval","20")
    op.setAttribute("name","monitor")
    op.setAttribute("timeout","40")
    op.setAttribute("timeout","20")
    operation.appendChild(op)
    newdoc = impl.createDocument(None, "instance_attributes", None)
    instance = newdoc.documentElement
    instance.setAttribute("id","gfs_instance")
    newdoc = impl.createDocument(None, "nvpair", None)
    nvpair1 = newdoc.documentElement
    nvpair1.setAttribute("id","gfs_instance_device")
    nvpair1.setAttribute("name","device")
    nvpair1.setAttribute("value",diskpath)    #diskpath
    newdoc = impl.createDocument(None, "nvpair", None)
    nvpair2 = newdoc.documentElement
    nvpair2.setAttribute("id","gfs_instance_directory")
    nvpair2.setAttribute("name","directory")
    nvpair2.setAttribute("value",directory)   #directory
    newdoc = impl.createDocument(None, "nvpair", None)
    nvpair3 = newdoc.documentElement
    nvpair3.setAttribute("id","gfs_instance_fstype")
    nvpair3.setAttribute("name","fstype")
    nvpair3.setAttribute("value","gfs2")
    instance.appendChild(nvpair1)
    instance.appendChild(nvpair2)
    instance.appendChild(nvpair3)
    primitive.appendChild(operation)
    primitive.appendChild(instance)
    groupgfs.appendChild(primitive)

    ####################################        
    clonegfs.appendChild(groupgfs)
    cmdxml = clonegfs.toxml().replace("\n","")
    manager.cib_do_cmd("cib_create\n%s\n%s"%(str("resources"),str(cmdxml)))
    if manager.failed_reason != "" :
        return {'action':False, 'error':_(manager.failed_reason)}
    else:
	status, output = commands.getstatusoutput("pcs resource update gfs options=noatime")
        if status != 0:
             return {'action':False, 'error': output}
        return {'action':True, 'info': _("Create gfs success")}

