#!/usr/bin/python
# -*-coding:utf-8-*-
# coding: iso-8859-15
from common_utils import update
from Manager import Manager
from common_utils import run_remote_commands
from common_utils import check_remote_root_pass, test_api_alive, send_remote_nodeaction_request 
import json
import os
import config
import commands
import time
from xml.dom.minidom import parseString

manager = Manager()


def get_all_node_status1():

    node_list_status = []
    all_nodes = manager.get_all_nodes()
    if len(all_nodes) > 0:
        for one_node in all_nodes:
            node_data = {}
            node_data['id'] = one_node
            node_data['status'] = get_node_status(one_node)

            node_list_status.append(node_data)
    return json.dumps({'action': True, 'data': node_list_status})


def get_node_status(node_id):
    if manager.get_nodetype(node_id) == 'ping':
        return False
    started = manager.get_crm_nodes()
    if manager.failed_reason != "":
        return False
    if started is not None and node_id not in started:
        if manager.get_nodetype(node_id) == "normal":
            return 'Not Running'
    active_nodes = manager.get_active_nodes()
    if node_id not in active_nodes:
        try:
            if manager.get_node_config(node_id).get("standby") == "True":
                return 'Not Running/Standby'
            else:
                return 'Not Running'
        except:
            return 'Not Running'
    dc = manager.get_dc()
    if dc is None or dc == []:
        return 'Running'
    if node_id in dc:
        if manager.get_node_config(node_id).get("standby") == "True":
            return 'Master/Standby'
        return 'Master'
    if manager.get_node_config(node_id).get("standby") == "True":
        return 'Standby'
    return 'Running'


def set_node_action(node, action):

    if node not in manager.get_all_nodes():
        return {'action': False, 'error': _("Cannot find the %s: %s") % (_("Node"), node)}
    if action == 'standby':
        manager.do_cmd("crm_attribute\nnodes\nset\nstandby\ntrue\n%s\n\n" % node)
    else:
        manager.do_cmd("crm_attribute\nnodes\nset\nstandby\nfalse\n%s\n\n" % node)

    failed_reason = manager.failed_reason
    update()
    if failed_reason != "":
        return {'action': False, 'error': _(failed_reason)}
    else:
        return {'action': True, 'info': _("Action on node success")}


def get_node_ip(nodeid):
    ips = []
    # 不获取磁盘心跳信息，只获取网络心跳信息
    get_diskhb = False
    data = config.get_hb_config_org(get_diskhb)
    hbs = data['data']
    for hb in hbs:
        if 'hbaddrs' in hb:
            hbaddrs = hb['hbaddrs']
            for hbaddr in hbaddrs:
                if hbaddr['nodeid'] == nodeid:
                    ips.append(hbaddr['ip'])
    data = {}
    data['ips'] = ips

    return {'action': True, 'data': data}


def node_local_action(action):
   status, output = commands.getstatusoutput("/usr/bin/neoha api-"  + action)
   if status != 0:
       return {'action': False, 'error': output}
   return {'action': True, 'info': _('Action on node success')}

def node_action(nodeid, action):
    # 若是本机，则执行本机操作
    status, output = commands.getstatusoutput("hostname")
    if status != 0:
        return {'action': False, 'error': output}
    localnodeid = str(output).strip()

    if localnodeid != nodeid:
	nodeip = None
        # 通过查找配置文件获取nodeid所在主机上的所有ip
        nodeips = get_node_ip(nodeid)
        if 'data' in nodeips and 'ips' in nodeips['data'] and nodeips['data']['ips'] != []:
            nodeip = nodeips['data']['ips'][0]
        else:
            return {'action': False, 'error': str(nodeid) + _(": Node needs to configure IP")}  
       
	ret = test_api_alive(nodeip)
	if 'action' not in ret or not ret['action']:
            return {'action': False, 'error': _('Action on node failed, please checkout network and ha service')}

	ret = json.loads(send_remote_nodeaction_request(nodeip, action))
	if 'action' not in ret or not ret['action']:
            return {'action': False, 'error': _('Action on node failed')}


    if localnodeid == nodeid:
        return node_local_action(action)
 
    # 休眠时间,防止状态不一致
    time.sleep(3)
    return {'action': True, 'info': _('Action on node success')}

def get_all_node_status():
    data = []
    status, output = commands.getstatusoutput("crm_mon -1 --as-xml")
    if status != 0:
        return {'action': False, 'error': output}

    new_node = parseString(output).documentElement
    for nodes in new_node.getElementsByTagName('nodes'):  	
         for node in nodes.getElementsByTagName('node'):
	     name = node.getAttribute('name')
	     online = node.getAttribute('online')
	     standby = node.getAttribute('standby')
	     is_dc = node.getAttribute('is_dc')
	     status = ""
	     if is_dc == "true":
		 if standby == "true":
		     if online == "true":
			 status = "Master/Standby"
		     else:
			 status = "Not Running"

		 else:
		     if online == "true":
                         status = "Master"
                     else:
                         status = "Not Running"
	     else:                
		 if standby == "true":
                     if online == "true":
                         status = "Standby"
                     else:
                         status = "Not Running"

                 else:
                     if online == "true":
                         status = "Running"
                     else:
                         status = "Not Running"
	     status_json = {}
	     status_json['id'] = name
	     status_json['status'] = status
             data.append(status_json)
    if data != []:         
        return {"action": True, "data": data} 	      	      	
    else:
	return {"action": False, "data": "Get node failed!"}


if __name__ == '__main__':
    # print get_crm_metadata("pengine")
    print node_action("ns176", "start")
    #print send_remote_nodeaction_request("10.1.110.175", "start")
    #print node_local_action("start")
    print get_all_node_status()
