#!/usr/bin/python
# -*-coding:utf-8-*-
# coding: iso-8859-15

from bottle import Bottle, run
from bottle import request, response
from bottle import error
from bottle import static_file
import platform
import sqlite3 as lite
import sys, os, string, socket, syslog, webbrowser, pickle, xml, gc, time, binascii, thread, tarfile, tempfile
import locale, gettext
from stat import *
import re
import sqlite3
import os
from xml.dom.minidom import parseString
from xml.dom.minidom import getDOMImplementation
from telnetlib import Telnet

import urllib, urllib2, cookielib, socket
import pdb
import xmltodict
import json
import sys
import time
import pytz
import datetime
import types

sys.path.append("/usr/share/heartbeat-gui")
sys.path.append("/usr/lib64/heartbeat-gui")

import commands
from common_utils import manager
from common_utils import add_rsc_json_format, add_group_rsc_json_format, clone_rsc_json_format, set_colocation_format, \
    set_order_format, set_rsc_json_format, set_rsc_json_format1, get_order_format, get_colocation_format
from common_utils import web_manager, update

from pymgmt import *
import ha_license
import rsc_thread

app_name = "ha-api"
DB_FILE = "/usr/share/heartbeat-gui/ha-api/host.db"
NOTIFYDB_FILE = "/usr/share/heartbeat-gui/ha-api/audit.db"
gettext.bindtextdomain(app_name)
gettext.textdomain(app_name)
gettext.install(app_name, "/usr/share/locale", unicode=1)
gettext.translation(app_name, "/usr/share/locale", languages=["zh_CN"]).install(True)


def data_int_bool_to_str(data):
    if 'meta_attributes' in data:
        meta_attributes = data['meta_attributes']
        if 'is-managed' in meta_attributes:
            is_managed = str(data['meta_attributes']['is-managed'])
            if is_managed == "True" or is_managed == "true":
                data['meta_attributes']['is-managed'] = "true"
            else:
                data['meta_attributes']['is-managed'] = "false"

        if 'allow-migrate' in meta_attributes:
            allow_migrate = str(data['meta_attributes']['allow-migrate'])
            if allow_migrate == "True" or allow_migrate == "true":
                data['meta_attributes']['allow-migrate'] = "true"
            else:
                data['meta_attributes']['allow-migrate'] = "false"

        if 'interleave' in meta_attributes:
            interleave = str(data['meta_attributes']['interleave'])
            if interleave == "True" or interleave == "true":
                data['meta_attributes']['interleave'] = "true"
            else:
                data['meta_attributes']['interleave'] = "false"


        if 'priority' in meta_attributes:
            data['meta_attributes']['priority'] = str(data['meta_attributes']['priority'])
        if 'resource-stickiness' in meta_attributes:
            data['meta_attributes']['resource-stickiness'] = str(data['meta_attributes']['resource-stickiness'])
        if 'migration-threshold' in meta_attributes:
            data['meta_attributes']['migration-threshold'] = str(data['meta_attributes']['migration-threshold'])
        if 'failure-timeout' in meta_attributes:
            data['meta_attributes']['failure-timeout'] = str(data['meta_attributes']['failure-timeout'])
	if 'clone-max' in meta_attributes:
            data['meta_attributes']['clone-max'] = str(data['meta_attributes']['clone-max'])


    # instance_attributes 数据必须是字符串
    if 'instance_attributes' in data:
	instance_attributes = data['instance_attributes']
        for key in instance_attributes.keys():
	   data['instance_attributes'][key] = str(instance_attributes[key])

    return data


def get_rsc_meta_attributes(category):
    retjson = {}

    retjson['target-role'] = {}
    retjson['target-role']['content'] = {}
    retjson['target-role']['name'] = 'target-role'
    retjson['target-role']['content']['values'] = ['Stopped', 'Started']
    retjson['target-role']['content']['default'] = 'Stopped'
    retjson['target-role']['content']['type'] = "enum"
    retjson['target-role']['content']['dec'] = "What state should the cluster attempt to keep this resource in?"

    retjson['priority'] = {}
    retjson['priority']['content'] = {}
    retjson['priority']['name'] = 'priority'
    retjson['priority']['content']['type'] = "integer"
    retjson['priority']['content'][
        'dec'] = "If not all resources can be active, the cluster will stop lower priority resources in order to keep higher priority ones active."

    retjson['is-managed'] = {}
    retjson['is-managed']['content'] = {}
    retjson['is-managed']['name'] = 'is-managed'
    # retjson['is-managed']['content']['values'] = ['true', 'false']
    retjson['is-managed']['content']['type'] = "boolean"
    retjson['is-managed']['content']['dec'] = "Is the cluster allowed to start and stop the resource?"

    if category == "group":
        return {'action': True, 'data': retjson}

    retjson['resource-stickiness'] = {}
    retjson['resource-stickiness']['content'] = {}
    retjson['resource-stickiness']['name'] = 'resource-stickiness'
    retjson['resource-stickiness']['content']['type'] = "integer"
    retjson['resource-stickiness']['content'][
        'dec'] = "How much does the resource prefer to stay where it is? Defaults to the value of \'default-resource-stickiness\'"

    retjson['migration-threshold'] = {}
    retjson['migration-threshold']['content'] = {}
    retjson['migration-threshold']['name'] = 'migration-threshold'
    retjson['migration-threshold']['content']['type'] = "integer"
    retjson['migration-threshold']['content'][
        'dec'] = "How many failures should occur for this resource on a node before making the node ineligible to host this resource. Default: \'none\'"

    retjson['multiple-active'] = {}
    retjson['multiple-active']['content'] = {}
    retjson['multiple-active']['name'] = 'multiple-active'
    retjson['multiple-active']['content']['values'] = ['stop_start', 'stop_only', 'block']
    retjson['multiple-active']['content']['type'] = "enum"
    retjson['multiple-active']['content'][
        'dec'] = "What should the cluster do if it ever finds the resource active on more than one node."

    retjson['failure-timeout'] = {}
    retjson['failure-timeout']['content'] = {}
    retjson['failure-timeout']['name'] = 'failure-timeout'
    retjson['failure-timeout']['content']['type'] = "integer"
    retjson['failure-timeout']['content'][
        'dec'] = "How many seconds to wait before acting as if the failure had not occurred (and potentially allowing the resource back to the node on which it failed. Default: \'never\'"

    retjson['allow-migrate'] = {}
    retjson['allow-migrate']['content'] = {}
    retjson['allow-migrate']['name'] = 'allow-migrate'
    # retjson['allow-migrate']['content']['values'] = ['true', 'false']
    retjson['allow-migrate']['content']['type'] = "boolean"
    retjson['allow-migrate']['content'][
        'dec'] = "Allow resource migration for resources which support migrate_to/migrate_from actions."

    if category == "primitive":
        return {'action': True, 'data': retjson}
  
    if category == "clone":
	retjson['interleave'] = {}
        retjson['interleave']['content'] = {}
        retjson['interleave']['name'] = 'interleave'
        retjson['interleave']['content']['type'] = "boolean"
        retjson['interleave']['content']['dec'] = "Changes the behavior of ordering constraints (between clones/masters) so that instances can start/stop as soon as their peer instance has (rather than waiting for every instance of the other clone has)."
        
	retjson['clone-max'] = {}
        retjson['clone-max']['content'] = {}
        retjson['clone-max']['name'] = 'clone-max'
        retjson['clone-max']['content']['type'] = "integer"
        retjson['clone-max']['content']['dec'] = "How many copies of the resource to start. Defaults to the number of nodes in the cluster."
        return {'action': True, 'data': retjson}



    return {'action': True, 'data': retjson}


def modify_group_node_org(rsc_id, data):
    node_id_sort = {}
    for rsc_node in data['group']['primitive']:
        node_id_sort[rsc_node['id']] = int(rsc_node['order'])

    dict_add_at(data)
    # 该函数为clone、group资源的操作，不许要对data的进行整型转字符串类型
    xml_node = xmltodict.unparse(data)
    new_cib_xml = xml_node.replace("\n", "")
    try:
        new_node = parseString(new_cib_xml).documentElement
    except xml.parsers.expat.ExpatError, msg:
        return {'action': False, 'error': _("Failed to parse the CIB") + _(": ") + str(msg)}

    selected_node = None
    nodes = manager.xml_nodes["cib"].getElementsByTagName('group')
    for node in nodes:
        if node.getAttribute("id") == rsc_id:
            selected_node = node
            break
    if selected_node is None:
        return {'action': False, 'error': _('Cannot find the %s %s') % (str("group"), str(rsc_id))}

    parent_node = selected_node.parentNode
    if parent_node.tagName == "clone":
        top_parent_node = parent_node.parentNode

    sub_rscs = manager.get_sub_rsc(rsc_id)
    real_sub_rscs = []
    for rsc_id in sub_rscs:
        real_rsc_id = manager.obj_real_id(rsc_id)
        real_sub_rscs.append(real_rsc_id)
    sub_rscs = real_sub_rscs

    for rsc_id in sub_rscs:
        if rsc_id not in node_id_sort.keys():
            node_clone = get_selected_node(rsc_id).cloneNode(True)
            if parent_node.tagName == "clone":
                top_parent_node.appendChild(node_clone)
            else:
                parent_node.appendChild(node_clone)

    del_rscs = []
    tmp_new_node = new_node.cloneNode(True)
    tmp_new_node_sort = {}
    for node in tmp_new_node.getElementsByTagName('primitive'):
        id = node.getAttribute('id')
        if id not in sub_rscs:
            del_rscs.append(id)
            if id not in manager.get_top_rsc():
                return {'action': False, 'error': _("Cannot find the %s: %s") % (str("primitive resources"), id)}

        new_node_clone = get_selected_node(id).cloneNode(True)
        sort_order = node_id_sort[id]
        tmp_new_node_sort[sort_order] = new_node_clone
        tmp_new_node.removeChild(node)

    key_rscs_order = tmp_new_node_sort.keys()
    key_rscs_order.sort()
    for key in key_rscs_order:
        tmp_new_node.appendChild(tmp_new_node_sort[key])
    new_node = tmp_new_node.cloneNode(True)

    if parent_node.tagName != "clone":
        for node in parent_node.getElementsByTagName('primitive'):
            if node.getAttribute('id') in del_rscs:
                parent_node.removeChild(node)
        parent_node.insertBefore(new_node, selected_node)
        parent_node.removeChild(selected_node)
        xml_str = parent_node.toxml().replace("\n", "")
        manager.cib_do_cmd("cib_replace\n%s\n%s" % (str(parent_node.tagName), str(xml_str)))
    else:
        for node in top_parent_node.getElementsByTagName('primitive'):
            if node.getAttribute('id') in del_rscs:
                top_parent_node.removeChild(node)
        parent_node.insertBefore(new_node, selected_node)
        parent_node.removeChild(selected_node)
        # top_parent_node.insertBefore(clone_parent_node, parent_node)
        # top_parent_node.removeChild(parent_node)
        xml_str = top_parent_node.toxml().replace("\n", "")
        manager.cib_do_cmd("cib_replace\n%s\n%s" % (str(top_parent_node.tagName), str(xml_str)))
    if manager.failed_reason != "":
        return {'action': False, 'error': _(manager.failed_reason)}
    else:
        return {'action': True, 'info': _('Modify group attribute success')}


def get_all_rsc_status_constraints():

    constraints = get_all_constraints()  # /get_all_constraints
    if not constraints['action']:
        return json.dumps(constraints)
    re_all_rsc_status = {}
    re_all_rsc_status['data'] = []

    for constraint in constraints['data']:
        rsc_id = str(constraint['id'])

        # 添加是否允许回迁操作
        migrate_rscs = get_all_migrate_rscs()
        if rsc_id in migrate_rscs:
            constraint['allow_unmigrate'] = True
        else:
            constraint['allow_unmigrate'] = False

        type = manager.get_rsc_type(rsc_id)
        status_message = rsc_thread.status_message
        one_rsc_status = get_sub_rsc_status1(rsc_id)
        # 添加资源status_message
        if 'status' in one_rsc_status and one_rsc_status['status'] not in ["Running", "running", "running (Master)",
                                            'running (Slave)'] and rsc_id in status_message:

            one_rsc_status['status_message'] = str(status_message[rsc_id]).replace("u'","'")

        else:
            one_rsc_status['status_message'] = ""

        location_new = []
        for location in constraint['location']:
            if location['level'] != 'No Run Node':
                location_new.append(location)

        constraint['location'] = location_new
        # print one_rsc_status
        if 'id' not in one_rsc_status.keys():
            continue
        one_rsc_status_copy = one_rsc_status.copy()
        one_rsc_status_copy.update(constraint)
        re_all_rsc_status['data'].append(one_rsc_status_copy)
        one_rsc_status = {}

    if manager.failed_reason != "":
        return {'action': False, 'error': _(manager.failed_reason)}
    re_all_rsc_status['action'] = True
    return json.dumps(re_all_rsc_status)


def rsc_primitive_format(data):
    data = data['primitive']
    data['category'] = 'primitive'
    if 'operations' in data and 'op' in data['operations']:
        ops = data['operations']['op']
        ops_new = []
        for op in ops:
            op.pop('id')
            ops_new.append(op)
        data['actions'] = ops_new
        data.pop("operations")

    if 'meta_attributes' in data:
        meta_attributes = {}
        if 'nvpair' in data['meta_attributes']:
            nvpairs = data['meta_attributes']['nvpair']
            for nvpair in nvpairs:
                name = nvpair['name']
                value = nvpair['value']
                meta_attributes[name] = value
        data['meta_attributes'] = meta_attributes

    if 'instance_attributes' in data:
        instance_attributes = {}
        if 'nvpair' in data['instance_attributes']:
            nvpairs = data['instance_attributes']['nvpair']
            for nvpair in nvpairs:
                name = nvpair['name']
                value = nvpair['value']
                instance_attributes[name] = value

        data['instance_attributes'] = instance_attributes

    return data


def rsc_group_format(data):
    data = data['group']
    data['category'] = 'group'
    if 'primitive' in data:
        primitives = data['primitive']
        ptype = type(primitives)
        primitive_new = []

        if ptype is types.ListType:
            for primitive in primitives:
                id = primitive['id']
                primitive_new.append(id)
        else:
            id = primitives['id']
            primitive_new.append(id)

        data['rscs'] = primitive_new
        data.pop('primitive')

    if 'meta_attributes' in data:
        meta_attributes = {}
        if 'nvpair' in data['meta_attributes']:
            nvpairs = data['meta_attributes']['nvpair']
            for nvpair in nvpairs:
                name = nvpair['name']
                value = nvpair['value']
                meta_attributes[name] = value
        data['meta_attributes'] = meta_attributes

    return data


def rsc_clone_format(data):
    data = data['clone']
    data['category'] = 'clone'
    if 'primitive' in data:
        primitive = data['primitive']
        data['rsc_id'] = primitive['id']
        data.pop('primitive')

    if 'meta_attributes' in data:
        meta_attributes = {}
        if 'nvpair' in data['meta_attributes']:
            nvpairs = data['meta_attributes']['nvpair']
            for nvpair in nvpairs:
                name = nvpair['name']
                value = nvpair['value']
                meta_attributes[name] = value

        data['meta_attributes'] = meta_attributes

    return data


def get_sub_rsc_status1(rsc_id, on_node=False):
    '''infos = {
          0:_('Running'),
          1:_('Not Running'),
          2:_('Unmanaged'),
          3:_('Failed'),
          4:_('Stop Failed'),
          5:_('running (Master)'),
          6:_('running (Slave)')}'''

    infos = {
        0: ('Running'),
        1: ('Not Running'),
        2: ('Unmanaged'),
        3: ('Failed'),
        4: ('Stop Failed'),
        5: ('running (Master)'),
        6: ('running (Slave)')}
    # manager.update()
    one_rsc_status = {}
    type = manager.get_rsc_type(rsc_id)
    one_rsc_status['type'] = type
    if type == "master" and on_node:
        one_rsc_status['type'] = "primitive"

    if type in ["group", "clone", "master"]:
        # if type in ["group","clone"]:
        one_rsc_status['id'] = rsc_id  # .split(":")[0]
        if not on_node:
            if type in ["group"]:
                one_rsc_status['status'] = "Running"
            else:
                one_rsc_status['status'] = "Not Running"
        else:
            one_rsc_status['run_node'] = []
            run_node_status = {}

        subrscs = manager.get_sub_rsc(rsc_id)
        one_rsc_status['subrscs'] = []
        for rsc in subrscs:
            sub_rsc_status = {}
            # real_rsc_id = rsc.split(":")[0]
            sub_rsc_status = get_sub_rsc_status1(rsc, on_node)
            if 'id' not in sub_rsc_status.keys():
                continue
            if not on_node:
                if type in ["group"]:
                    if sub_rsc_status['status'] not in ['running', 'Running', 'running (Master)']:
                        one_rsc_status['status'] = sub_rsc_status['status']
                else:
                    if sub_rsc_status['status'] in ['running', 'Running', 'running (Master)', 'running (Slave)']:
                        one_rsc_status['status'] = infos[0]
                    elif sub_rsc_status['status'] in ['failed', 'Failed']:
                        one_rsc_status['status'] = infos[3]
                    elif sub_rsc_status['status'] in ['stop failed', 'Stop Failed']:
                        one_rsc_status['status'] = infos[4]
                    elif sub_rsc_status['status'] in ['unmanaged', 'Unmanaged']:
                        one_rsc_status['status'] = infos[2]

            else:
                all_nodes = manager.get_all_nodes()
                if all_nodes is not None:
                    all_nodes.sort()
                if type in ["group"]:
                    for node in all_nodes:
                        if node not in run_node_status.keys():
                            run_node_status[node] = "Running"
                        for status in sub_rsc_status['run_node']:
                            if status['node'] == node:
                                if status['status'] not in ['running', 'Running', 'running (Master)',
                                                            'running (Slave)']:
                                    run_node_status[node] = status['status']
                else:
                    for node in all_nodes:
                        if node not in run_node_status.keys():
                            run_node_status[node] = "Not Running"
                        for status in sub_rsc_status['run_node']:
                            if status['node'] == node:
                                if status['status'] in ['running', 'Running', 'running (Master)', 'running (Slave)']:
                                    run_node_status[node] = infos[0]
                                elif status['status'] in ['failed', 'Failed']:
                                    run_node_status[node] = infos[3]
                                elif status['status'] in ['stop failed', 'Stop Failed']:
                                    run_node_status[node] = infos[4]
                                elif status['status'] in ['unmanaged', 'Unmanaged']:
                                    run_node_status[node] = infos[2]

	    status_message = rsc_thread.status_message
            # 为子资源添加message信息
            sub_rscid = sub_rsc_status['id']
            if sub_rsc_status['status'] not in ['running', 'Running', 'running (Master)',
                                                'running (Slave)'] and sub_rscid in status_message:
		    
                sub_rsc_status['status_message'] = str(status_message[sub_rscid]).replace("u'","'")
            else:
                sub_rsc_status['status_message'] = ""

            one_rsc_status['subrscs'].append(sub_rsc_status)
            # if not on_node and sub_rsc_status["rsc_status"] != "running":
            #    one_rsc_status['status'] = sub_rsc_status["rsc_status"]

        if not on_node:
            if one_rsc_status['status'] in ["running", "Running"]:
                one_rsc_status['running_node'] = manager.get_rsc_running_on(rsc_id)
            else:
                one_rsc_status['running_node'] = []
        else:
            for node in run_node_status.keys():
                run_node = {}
                run_node['node'] = node
                run_node['status'] = run_node_status[node]
                one_rsc_status['run_node'].append(run_node)


    elif type in ["primitive"]:
        real_rsc_id = rsc_id.split(":")[0]
        node_info = manager.get_rsc_info(real_rsc_id)
        if node_info is not None and len(node_info) > 0:
            one_rsc_status['id'] = rsc_id
            one_rsc_status['svc'] = node_info[1]
            if not on_node:
                # status = manager.get_rsc_status(rsc_id)[0]
                status = infos[judge_rsc_status_1(rsc_id)]
                if status in ["Running", "running", "running (Master)", 'running (Slave)']:
                    one_rsc_status['status'] = infos[0]
                    one_rsc_status['running_node'] = manager.get_rsc_running_on(rsc_id)
                elif status in ['Not Running', 'not running']:
                    one_rsc_status['status'] = infos[1]
                    one_rsc_status['running_node'] = []
                elif status in ['Failed', 'failed']:
                    one_rsc_status['status'] = infos[3]
                    one_rsc_status['running_node'] = []
                elif status in ['Stop Failed', 'stop failed']:
                    one_rsc_status['status'] = infos[4]
                    one_rsc_status['running_node'] = []
                else:
                    one_rsc_status['status'] = infos[2]
                    one_rsc_status['running_node'] = manager.get_rsc_running_on(rsc_id)
                    # one_rsc_status['running_node'] = []
            else:
                all_nodes = manager.get_all_nodes()
                if all_nodes is not None:
                    all_nodes.sort()
                one_rsc_status['run_node'] = {}
                for node in all_nodes:
                    # one_rsc_status['running_node'][node] = infos[judge_rsc_status(rsc_id,node, type)]
                    run_node = {}
                    run_node['node'] = node
                    run_node['status'] = judge_rsc_status(rsc_id, node, type)
                    one_rsc_status['run_node'].append(run_node)

    return one_rsc_status


def judge_rsc_status_1(rsc):
    goodnodes = manager.get_rsc_running_on(rsc)
    if goodnodes is None or goodnodes == []:
        return 1
    # 获取状态的位置
    status = None
    rsc_info = manager.get_rsc_status(rsc)
    if rsc_info is not None:
	status = rsc_info[0]
	
    if status == 'not running':
        return 1
    elif status == 'running':
        return 0
    elif status == 'failed':
        return 3
    elif status == 'stop failed':
        return 4
    elif status == 'running (Master)':
        return 5
    elif status == 'running (Slave)':
        return 6
    else:
        return 2
    return 1


def judge_rsc_status(rsc, node, type):
    if type in ["group", "clone", "master"]:
        if manager.get_sub_rsc(rsc) != []:
            for subrsc in manager.get_sub_rsc(rsc):
                type = manager.get_rsc_type(subrsc)
                if judge_rsc_status(subrsc, node, type) != 0:
                    return 1
        return 0
    goodnodes = manager.get_rsc_running_on(rsc)
    if goodnodes is None or goodnodes == []:
        return 1
    status = manager.get_rsc_status(rsc)[0]
    for goodnode in goodnodes:
        if node == goodnode:
            if status == 'not running':
                return 1
            elif status == 'running':
                return 0
            elif status == 'failed':
                return 3
            elif status == 'stop failed':
                return 4
            elif status == 'running (Master)':
                return 5
            elif status == 'running (Slave)':
                return 6
            else:
                return 2
    return 1


def get_all_constraints():

    data = {}
    for rsc_id in manager.get_top_rsc():
        rsc = rsc_id.split(":")[0]
        data[rsc] = {}
        data[rsc]["before_rscs"] = []
        data[rsc]["after_rscs"] = []
        data[rsc]["same_node"] = []
        data[rsc]["diff_node"] = []
        data[rsc]['location'] = []

    constraints = manager.xml_nodes["cib"].getElementsByTagName('constraints')[0]
    ############location############
    for location in constraints.getElementsByTagName('rsc_location'):
        if location.getAttribute('id').startswith('cli-prefer-'):
            continue
        node = location.getAttribute('node')
        rsc_id = location.getAttribute('rsc')
        score = location.getAttribute('score')
        location_single = {}
        location_single['node'] = node
        location_single['level'] = web_manager.turn_score_to_level(score)
        # location_list.append(location_single)
        if rsc_id in data.keys():
            data[rsc_id]["location"].append(location_single)

    ########order########
    for node in constraints.getElementsByTagName('rsc_order'):
        first_rsc_id = node.getAttribute("first")
        then_rsc_id = node.getAttribute('then')
        try:
            score = node.getAttribute('score')
            if score is None or len(score) == 0:
                score = 'infinity'
            if score not in ["INFINITY", "+INFINITY", "infinity", "+infinity"]:
                continue
        except:
            pass
        if first_rsc_id in data.keys():
            data[first_rsc_id]["after_rscs"].append({'id': then_rsc_id})

        if then_rsc_id in data.keys():
            data[then_rsc_id]["before_rscs"].append({'id': first_rsc_id})

    ##########colocation###############
    for node in constraints.getElementsByTagName('rsc_colocation'):
        first_rsc_id = node.getAttribute("rsc")
        with_rsc_id = node.getAttribute('with-rsc')
        try:
            score = node.getAttribute('score')
            if score in ["INFINITY", "+INFINITY", "infinity", "+infinity"]:
                rsc = {}
                rsc['rsc'] = first_rsc_id
                rsc['with_rsc'] = with_rsc_id
                data[first_rsc_id]["same_node"].append(rsc)
                data[with_rsc_id]["same_node"].append(rsc)
            elif score in ["-INFINITY", "-infinity"]:
                rsc = {}
                rsc['rsc'] = first_rsc_id
                rsc['with_rsc'] = with_rsc_id
                data[first_rsc_id]["diff_node"].append(rsc)
                data[with_rsc_id]["diff_node"].append(rsc)
        except:
            pass

    constraints = []
    for rsc_id in data.keys():
        constraint = {}
        constraint['id'] = rsc_id
        colocation = {}
        colocation['same_node'] = data[rsc_id]["same_node"]
        colocation['diff_node'] = data[rsc_id]["diff_node"]
        colocation['same_node_num'] = len(colocation['same_node'])
        colocation['diff_node_num'] = len(colocation['diff_node'])
        order = {}
        order['before_rscs'] = data[rsc_id]["before_rscs"]
        order['after_rscs'] = data[rsc_id]["after_rscs"]
        order['before_rscs_num'] = len(order['before_rscs'])
        order['after_rscs_num'] = len(order['after_rscs'])
        constraint['location'] = data[rsc_id]["location"]
        constraint['colocation'] = colocation
        constraint['order'] = order
        constraints.append(constraint)
    return {'action': True, 'data': constraints}


def get_rsc_error_info(rsc_id):
    #print "pcs status|grep " + str(rsc_id) + "_"
    status, output = commands.getstatusoutput("pcs status|grep * " + str(rsc_id) + "_")
    if status == 0:
        return output
    else:
        return ""


def get_all_rsc():
    constraints = get_all_constraints()  # /get_all_constraints
    re_all_rsc_status = []
    for constraint in constraints['data']:
        rsc_id = str(constraint['id'])
        type = manager.get_rsc_type(rsc_id)
        one_rsc_status = get_sub_rsc_status1(rsc_id)
        one_rsc_status_copy = one_rsc_status.copy()
        one_rsc_status_copy.update(constraint)
        re_all_rsc_status.append(one_rsc_status_copy)
    return re_all_rsc_status


def add_primitive_rsc(data, parent_type):
    rsc_id = data['id']
    rscs = manager.get_all_real_rsc()
    if rsc_id in rscs:
	return {'action': False, 'error': _("The resource name already exists")} 
    
    # Format json string
    # 添加默认值 
    if 'meta_attributes' in data:
        meta_attributes = data['meta_attributes']
        # 在添加资源时，发现没有target-role，就添加一个stopped
        if 'target-role' not in meta_attributes:
            data['meta_attributes']['target-role'] = 'Stopped'
    else:
	data['meta_attributes'] = {}
	data['meta_attributes']['target-role'] = 'Stopped'

    newdata = add_rsc_json_format(data)

    obj = dict_add_at(newdata)
    # obj={"group": {"primitive": {"operations": {"@id": "rnew-operations", "op": {"@timeout": "30", "@interval": "90", "@name": "monitor", "@id": "ddd-op-monitor-10"}}, "@class": "ocf", "@id": "new-ddd", "@type": "NKSync_plan", "@provider": "common"}, "@id": "ddd", "meta_attributes": {"@id": "ddd-meta_attributes", "nvpair": {"@name": "target-role", "@id": "ddd-meta_attributes-target-role", "@value": "Stopped"}}}}
    # obj = {"rsc_location": {"@score": "20000", "@node": "liuming", "@rsc": "dd", "@id": "dd-location-on-liuming"}}
    # 添加资源，可以过滤的数据 xml 不识别整形
    xml_node = xmltodict.unparse(obj)
    xml_str = xml_node.replace("\n", "")
    manager.cib_do_cmd("cib_create\n%s\n%s" % (str(parent_type), str(xml_str)))

    failed_reason = manager.failed_reason
    update()
    if failed_reason != "":
        return {'action': False, 'error': _(failed_reason)}
    else:
        return {'action': True, 'info': _('Add primitive resource success')}
    return {'action': True, 'info': _('Add primitive resource success')}


def rscs_to_group(data):

    rsc_id = data['id']
    rscs = manager.get_all_real_rsc()
    if rsc_id in rscs:
        return {'action': False, 'error': _("The resource name already exists")}

    # 创建组资源时，资源数目至少为1
    if 'rscs' in data:
        rscs = data['rscs']
        if len(rscs) < 1:
            return {'action': False, 'error': _('The number of group rscs must be >= 1')}

    # Format group resource
    item = add_group_rsc_json_format(data)
    for one_rsc in item['rscs']:
        if one_rsc['rsc_id'] not in manager.get_all_rsc():
            return {'action': False, 'error': _("Cannot find the %s: %s") % (_("resource"), one_rsc['rsc_id'])}

    data = {}
    for one_rsc in item['rscs']:
        data[one_rsc['order']] = one_rsc['rsc_id']
        # 删除原资源的限制条件
        del_rsc_constraints(one_rsc['rsc_id'])

    str_rscs = ""
    for key in data.keys():
        str_rscs = str_rscs + " " + data[key]

    m_group_id = item['id']
    cmd = "/usr/sbin/crm -F configure group" + " " + str(m_group_id) + " " + str_rscs

    if 'meta_attributes' in item.keys() and item['meta_attributes'] != []:
        cmd = cmd + " meta"
        for meta in item['meta_attributes']:
            cmd = cmd + " " + meta['name'] + "=" + meta['value']
    # manager.do_cmd("system\n%s"%(str(cmd)))
    os.popen(cmd)

    for one_rsc in item['rscs']:
        cmd = "/usr/sbin/crm -F resource meta " + one_rsc['rsc_id'] + " delete " + "is-managed"
        cmd = cmd + ";/usr/sbin/crm -F resource meta " + one_rsc['rsc_id'] + " delete " + "target-role"
        cmd = cmd + ";/usr/sbin/crm -F resource meta " + one_rsc['rsc_id'] + " delete " + "priority"
        os.popen(cmd)

    # failed_reason = manager.failed_reason
    cib_update()
    # if failed_reason != "" :
    #    return json.dumps({'action':False, 'error':_(failed_reason)})
    return {'action': True, 'info': _('Add group resource success')}


def rsc_to_clone(data):

    rsc_id = data['id']
    rscs = manager.get_all_real_rsc()
    if rsc_id in rscs:
        return {'action': False, 'error': _("The resource name already exists")}

    # Format clone data
    item = clone_rsc_json_format(data)

    if item['rsc_id'] not in manager.get_all_rsc():
        return {'action': False, 'error': _("Cannot find the %s: %s") % (_("resource"), item['rsc_id'])}

    # 删除原资源的限制条件
    del_rsc_constraints(item['rsc_id'])
    cmd = "/usr/sbin/crm -F configure  clone " + item['id'] + " " + item['rsc_id']
    if 'meta_attributes' in item.keys() and item['meta_attributes'] != []:
        cmd = cmd + " meta"
        for meta in item['meta_attributes']:
            cmd = cmd + " " + meta['name'] + "=" + meta['value']
    # manager.do_cmd("system\n%s"%(str(cmd)))
    os.popen(cmd)

    # cmd = "/usr/sbin/crm -F resource meta " + item['rsc_id']+ " delete " + "is-managed"
    # cmd = cmd + ";/usr/sbin/crm -F resource meta " + item['rsc_id']+ " delete " + "target-role"
    # cmd = cmd + ";/usr/sbin/crm -F resource meta " + item['rsc_id']+ " delete " + "priority"
    # os.popen(cmd)

    # failed_reason = manager.failed_reason
    cib_update()
    # if failed_reason != "" :
    #    return json.dumps({'action':False, 'error':_(failed_reason)})
    return {'action': True, 'info': _('Add clone resource success')}


def dict_add_at(data):
    for key in data.keys():
        if str(data[key]).startswith("{"):
            dict_add_at(data[key])
        elif str(data[key]).startswith("["):
            for item in data[key]:
                dict_add_at(item)
        else:
            new_key = "@" + key
            data[str(new_key)] = data.pop(key)

    return data


def del_rsc_constraints(rsc_id):
    rsc_locations = []
    for rsc_location in manager.xml_nodes["cib"].getElementsByTagName("rsc_location"):
        if rsc_location.getAttribute('rsc') == rsc_id:
            rsc_locations.append(rsc_location)

    rsc_colocations = []
    for rsc_colocation in manager.xml_nodes["cib"].getElementsByTagName("rsc_colocation"):
        if rsc_colocation.getAttribute('rsc') == rsc_id or rsc_colocation.getAttribute('with-rsc') == rsc_id:
            rsc_colocations.append(rsc_colocation)

    rsc_orders = []
    for rsc_order in manager.xml_nodes["cib"].getElementsByTagName("rsc_order"):
        if rsc_order.getAttribute('first') == rsc_id or rsc_order.getAttribute('then') == rsc_id:
            rsc_orders.append(rsc_order)

    for location in rsc_locations:
        xml_str = location.toxml().replace("\n", "")
        manager.cib_do_cmd("cib_delete\nconstraints\n%s" % (str(xml_str)))

    for colocation in rsc_colocations:
        xml_str = colocation.toxml().replace("\n", "")
        manager.cib_do_cmd("cib_delete\nconstraints\n%s" % (str(xml_str)))

    for order in rsc_orders:
        xml_str = order.toxml().replace("\n", "")
        manager.cib_do_cmd("cib_delete\nconstraints\n%s" % (str(xml_str)))

    rsc_constes = []
    for rsc_conste in manager.xml_nodes["cib"].getElementsByTagName("conste_resources"):
        if rsc_conste.getAttribute('rscid') == rsc_id:
            rsc_constes.append(rsc_conste)

    if len(manager.xml_nodes["cib"].getElementsByTagName("conste_resources")) == 2 and \
                    len(rsc_constes) == 1:
        for conste in manager.xml_nodes["cib"].getElementsByTagName("conste_resources"):
            xml_str = conste.toxml().replace("\n", "")
            manager.cib_do_cmd("cib_delete\nconstes\n%s" % (str(xml_str)))
    else:
        for conste in rsc_constes:
            xml_str = conste.toxml().replace("\n", "")
            manager.cib_do_cmd("cib_delete\nconstes\n%s" % (str(xml_str)))


def modify_node_org(type, id, data):
    if type == 'group':
        node_id_sort = {}
        for rsc_node in data['group']['primitive']:
            node_id_sort[rsc_node['id']] = rsc_node['order']
            del rsc_node['order']
    dict_add_at(data)
    # obj = {"rsc_location": {"@score": "30000", "@node": "liuming", "@rsc": "dd", "@id": "dd-location-on-liuming"}}
    # obj = {"node": {"@id": "HA_1", "@type": "normal", "@uname": "node-3"}}
    xml_node = xmltodict.unparse(data)
    new_cib_xml = xml_node.replace("\n", "")
    try:
        new_node = parseString(new_cib_xml).documentElement
    except xml.parsers.expat.ExpatError, msg:
        return {'action': False, 'error': _("Failed to parse the CIB") + _(": ") + str(msg)}

    if type == 'group':
        tmp_new_node = new_node.cloneNode(True)
        tmp_new_node_sort = {}
        for node in tmp_new_node.getElementsByTagName('primitive'):
            new_node_clone = node.cloneNode(True)
            sort_order = node_id_sort[node.getAttribute('id')]
            tmp_new_node_sort[sort_order] = new_node_clone
            tmp_new_node.removeChild(node)
        # tmp_new_node_sort = tmp_new_node_sort.sort()

        key_rscs_order = tmp_new_node_sort.keys()
        key_rscs_order.sort()
        for key in key_rscs_order:
            tmp_new_node.appendChild(tmp_new_node_sort[key])
        new_node = tmp_new_node.cloneNode(True)

    update()
    selected_node = None
    nodes = manager.xml_nodes["cib"].getElementsByTagName(type)
    for node in nodes:
        if type == 'node':
            if node.getAttribute("uname") == id:
                selected_node = node
                break
        else:
            if node.getAttribute("id") == id:
                selected_node = node
                break
    if selected_node is None:
        return {'action': False, 'error': _('Cannot find the %s %s') % (str(type), str(id))}

    parent_node = selected_node.parentNode
    parent_node.insertBefore(new_node, selected_node)
    parent_node.removeChild(selected_node)

    xml_str = parent_node.toxml().replace("\n", "")
    manager.cib_do_cmd("cib_replace\n%s\n%s" % (str(parent_node.tagName), str(xml_str)))
    if manager.failed_reason != "":
        return {'action': False, 'error': _(manager.failed_reason)}
    else:
        return {'action': True, 'info': "Modify " + str(type) + " success"}


def set_rsc_info(data, rsc_id):
    newrsc = []   
    category = data["category"] 

    if category == "group":
         # 判断资源数目是否大于1
        if 'rscs' in data:
	    rscs = data['rscs']
            if len(rscs) < 1:
                return {'action': False, 'error': _('The number of group rscs must be >= 1')}

            # 删除新加到组资源的限制条件,和元属性
	    info = single_rsc_get_info(rsc_id)
	    if 'data' in info:
	    	rsc_info = rsc_group_format(info['data'])
	        old_rscs = rsc_info['rscs']
	        for new_rsc_id in rscs:
	            if new_rsc_id not in old_rscs:
		        del_rsc_constraints(new_rsc_id)
                        newrsc.append(new_rsc_id)

    olddata = {}
    data["id"] = rsc_id
    # Run in group may kill mgmt while  run method get_rsc_info
    if category != "group":
        olddata = single_rsc_get_info(rsc_id)

    item = set_rsc_json_format1(category, data, olddata)

    real_rsc_id = rsc_id.split(":")[0]
    # category = manager.get_rsc_tye(rsc_id)
    if category in ["primitive", "clone", "master"]:  # /modify/primitive/dfdsgfdgf       /modify/clone/a
        ret = modify_node_org(category, real_rsc_id, item['rsc_info'])
    else:
        ret = modify_group_node_org(real_rsc_id, item['rsc_info'])  # /modify_group/group-1
    if not ret['action']:
        return ret
    # 组资源清理子资源元属性
    if category == "group":
        for rscid in newrsc:
            cmd = "/usr/sbin/crm -F resource meta " + str(rscid) + " delete " + "is-managed"
            cmd = cmd + ";/usr/sbin/crm -F resource meta " + str(rscid) + " delete " + "target-role"
            cmd = cmd + ";/usr/sbin/crm -F resource meta " + str(rscid) + " delete " + "priority"
            os.popen(cmd)
	    cib_update()



    if rsc_id not in manager.get_top_rsc():
        update()
        return {'action': True, 'info': _('Set rsc info success')}

    # ret = set_order_org(data['order'])  #/rsc/set_order
    # if not json.loads(ret)['action']:
    #    return ret
    # ret = set_colocation_org(data['colocation'])    #/rsc/set_colocation
    # if not json.loads(ret)['action']:
    #    return ret
    # ret = set_rsc_run_level_org(data['location'])    # /rsc/set_run_level
    # if not json.loads(ret)['action']:
    #    return ret

    update()
    return {'action': True, 'info': _('Set rsc info success')}


def cleanup_rsc(rsc_id):
    status, output = commands.getstatusoutput("pcs resource cleanup " + str(rsc_id))
    if status != 0:
        return {'action': False, 'error': output}
    return {'action': True, 'info': _('Clean up resource success')}


def delete_rsc(rsc_id):
    status, output = commands.getstatusoutput("pcs resource delete " + str(rsc_id) + " --force")
    if status != 0:
        return {'action': False, 'error': output}
    return {'action': True, 'info': _('Delete resource success')}


def migrate_rsc(item, rsc_id):
    # item = {"rsc_id":"ip","to_node":"new-wm-1","is_force":"true","period":"P4DT5M"}
    # item = {"rsc_id":"ip","to_node":"node-1","is_force":"true","special_time":"2013-06-07T16:00:00"}
    #       duration = "P4DT5M"
    #       move_time = "2013-06-05T16:00:00"

    #       duration_elems = ["yrs", "mths", "wks", "days", "hrs", "mins", "secs"]
    #       time_elems = ["year", "month", "day", "hour"]
    if rsc_id not in manager.get_all_rsc():
        return {'action': False, 'error': _("Cannot find the %s: %s") % (_("resource"), str(rsc_id))}

    dictinfo = item

    if str(dictinfo["to_node"]) in manager.get_rsc_running_on(str(rsc_id)):
        return {'action': False, 'error': _("The resource %s is running on node %s already!") % (
            str(rsc_id), dictinfo["to_node"])}

    duration = ""
    move_time = ""
    if 'period' in dictinfo.keys() and dictinfo['period'] != 'PYMDT0HMS':
        duration = dictinfo['period']
        duration = duration.replace('THMS', '').replace('MS', 'M').replace('HM', 'H').replace('TH', 'T')
        duration = duration.replace('PYMD', 'P').replace('MD', 'M').replace('YM', 'Y').replace('PY', 'P')
        # duration = duration.replace('PYWMD','P').replace('MD','M').replace('WM','W').replace('YW','Y').replace('PY','P')
    elif 'special_time' in dictinfo.keys():
        move_time = dictinfo['special_time']
    dictinfo["is_force"] = 'False'
    manager.do_cmd("migrate\n%s\n%s\n%s\n%s\n%s"
                   % (str(rsc_id), str(dictinfo["to_node"]), str(dictinfo["is_force"]), str(duration), str(move_time)))
    if manager.failed_reason != "":
        msg = manager.failed_reason.replace("This message can be disabled with -Q", "").replace \
            ("using the 'crm_resource -U' command or manually with cibadmin", "by \"Clear Migrate Constraints\"")
        msg = manager.failed_reason.replace(
            "Please refer to http://en.wikipedia.org/wiki/ISO_8601#Dates for examples of valid dates\nError performing operation: Invalid argument",
            "Please input again")
        replace_msgs = ["until the constraint is removed by \"Clear Migrate Constraints\"",
                        "is active on more than one node, returning the default value for", \
                        "Resource", "not found", "We can only process primitive resources, not", \
                        "Please supply a hostname with -H", "has no type!  Aborting...", "has no class!  Aborting...", \
                        "Invalid duration specified:", \
                        "Please refer to http://en.wikipedia.org/wiki/ISO_8601#Duration for examples of valid durations", \
                        "Invalid date specified:", \
                        "Please input again", \
                        "\tThis will prevent", "from running on", \
                        "until the constraint is removed using the 'crm_resource -U' command or manually with cibadmin\n", \
                        "\tThis will be the case even if", "is the last node in the cluster",
                        "Must supply a resource id with -r\n", \
                        "not moved:", "active on multiple nodes\n", "Please input again", \
                        "is not a known node\n", "is already active on",
                        "not-active and no preferred location specified.\n", \
                        "You need to specify a resource type with -t", "Unknown command:", "Try using -f\n", \
                        "Migration will take effect until:", "Migration will take effect at:"
                        ]
        m = re.search(
            "WARNING: Creating rsc_location constraint (.+) with a score of -INFINITY for resource (.*) on (.*)", msg)
        if m is not None:
            msg = msg.replace(m.group(), _(
                "WARNING: Creating rsc_location constraint '%s' with a score of -INFINITY for resource %s on %s.") \
                              % (m.groups()[0], m.groups()[1], m.groups()[2]))

        # for replace in replace_msgs :
        #        msg = msg.replace(replace, _(replace))
        update()
        if "Migration will take effect until" in msg and "Error performing operation: Update does not conform to the configured schema" not in msg:
            # 将迁移时间从英国时间切换到中国时间
            en_time = msg[-20:-1]
            tz = pytz.timezone('Asia/Shanghai')
            ret = time.mktime(time.strptime(en_time, '%Y-%m-%d %H:%M:%S')) + 8 * 60 * 60
            sh_time = (time.strftime("%Y-%m-%d %H:%M:%S", time.localtime(ret)))
            msg = msg[0:-20].strip()
            sh_time = str(sh_time)
            return {'action': True, 'info': _(msg) + sh_time}
        elif "Error performing operation: Update does not conform to the configured schema" in msg:
	    return {'action': False, 'error': _("The resource migrate failed, please unmigrate first!")}
        else:
            return {'action': False, 'error': _(msg)}
    else:
        update()
        return {'action': True, 'info': _('Migrate resource success')}


def unmigrate_rsc(rsc_id):

    # 保留标签
    is_all_rscs = False

    if rsc_id not in manager.get_all_rsc():
        return {'action': False, 'error': _("Cannot find the %s: %s") % (_("resource"), str(rsc_id))}

    rsc_locations = {}
    for rsc_location in manager.xml_nodes["cib"].getElementsByTagName("rsc_location"):
        id = str(rsc_location.getAttribute("id"))
        rsc_locations[id] = rsc_location
    migrate_ids = {}
    rsc_ids = []
    for id in rsc_locations:
        for prefix in ["cli-prefer-", "cli-standby-"]:
            if id.startswith(prefix):
                split_id = id.split(prefix)
                if len(split_id) > 1:
                    tmp_rsc_id = split_id[1]
                    if not tmp_rsc_id in migrate_ids:
                        migrate_ids[tmp_rsc_id] = []
                    migrate_ids[tmp_rsc_id].append(id)
    if is_all_rscs:
        for rsc_id in migrate_ids.keys():
            for id in migrate_ids[rsc_id]:
                xml_str = rsc_locations[id].toxml().replace("\n", "")
                manager.cib_do_cmd("cib_delete\nconstraints\n%s" % (str(xml_str)))
    else:
        if rsc_id not in migrate_ids.keys():
            return {'action': True, 'info': "Unmigrate resource success"}
        for id in migrate_ids[rsc_id]:
            xml_str = rsc_locations[id].toxml().replace("\n", "")
            manager.cib_do_cmd("cib_delete\nconstraints\n%s" % (str(xml_str)))

    failed_reason = manager.failed_reason
    update()
    if failed_reason != "":
        return {'action': False, 'error': _(failed_reason)}
    else:
        return {'action': True, 'info': _('Unmigrate resource success')}


def get_order(rsc_id):

    after_rscs = []
    first_rscs = []
    nodes = manager.xml_nodes["cib"].getElementsByTagName('rsc_order')
    if manager.failed_reason != "":
        return {'action': False, 'error': _(manager.failed_reason)}
    for node in nodes:
        first_rsc_id = node.getAttribute("first")
        then_rsc_id = node.getAttribute('then')
        try:
            score = node.getAttribute('score')
            if score is None or len(score) == 0:
                score = 'infinity'
            if score not in ["INFINITY", "+INFINITY", "infinity", "+infinity"]:
                continue
        except:
            pass

        if first_rsc_id == rsc_id:
            rsc = {}
            rsc['rsc_id'] = then_rsc_id
            after_rscs.append(rsc)
        elif then_rsc_id == rsc_id:
            rsc = {}
            rsc['rsc_id'] = first_rsc_id
            first_rscs.append(rsc)
    data = {}
    data['rsc_id'] = rsc_id
    data['before_rscs'] = first_rscs
    data['after_rscs'] = after_rscs
    newdata = get_order_format(data)
    return {'action': True, 'data': newdata}


def get_colocation(rsc_id):

    same_node = []
    diff_node = []
    nodes = manager.xml_nodes["cib"].getElementsByTagName('rsc_colocation')
    if manager.failed_reason != "":
        return {'action': False, 'error': _(manager.failed_reason)}
    for node in nodes:
        first_rsc_id = node.getAttribute("rsc")
        with_rsc_id = node.getAttribute('with-rsc')
        if first_rsc_id == rsc_id or with_rsc_id == rsc_id:
            try:
                score = node.getAttribute('score')
                if score in ["INFINITY", "+INFINITY", "infinity", "+infinity"]:
                    rsc = {}
                    rsc['rsc'] = first_rsc_id
                    rsc['with_rsc'] = with_rsc_id
                    same_node.append(rsc)
                elif score in ["-INFINITY", "-infinity"]:
                    rsc = {}
                    rsc['rsc'] = first_rsc_id
                    rsc['with_rsc'] = with_rsc_id
                    diff_node.append(rsc)
            except:
                pass
    data = {}
    data['rsc_id'] = rsc_id
    data['same_node'] = same_node
    data['diff_node'] = diff_node
    newdata = get_colocation_format(data)
    return {'action': True, 'data': newdata}


def get_run_level(rsc_id):

    xml_node = get_selected_node(rsc_id)
    if xml_node is None:
        return {'action': False, 'error': _("Cannot find the %s: %s") % (_("resource"), str(rsc_id))}

    mainnode = mainnode_level(xml_node)

    location_list = []
    for key in mainnode.location.keys():
        if mainnode.location[key] in ["infinity", "INFINITY", "+infinity", "+INFINITY"]:
            continue
        location_single = {}
        location_single['node'] = key
        location_single['level'] = web_manager.turn_score_to_level(mainnode.location[key])
        location_list.append(location_single)

    location_list_new = []
    for location in location_list:
        if location['level'] != 'No Run Node':
            location_list_new.append(location)

    return {'action': True, 'data': {'rsc_id': rsc_id, 'node_level': location_list_new}}


def action_on_rsc(rsc_id, action):

    if action == "start":
        target_role = "Started"
    if action == "stop":
        target_role = "Stopped"

    cur_type = manager.get_rsc_type(rsc_id);
    metaattr_name = "target-role"
    real_rsc_id = rsc_id.split(":")[0]

    rsc_xml = None
    for resources_node in manager.xml_nodes["cib"].cloneNode(True).getElementsByTagName("resources"):
        for rsc_node in resources_node.getElementsByTagName(cur_type):
            if rsc_node.getAttribute("id") == real_rsc_id:
                rsc_xml = rsc_node
                break

    if rsc_xml is None:  # Cannot find the real_rsc_id of cur_type
        return {'action': False, 'error': _("Cannot find the %s: %s") % (_("resource"), rsc_id)}
    supported_rsc_types = manager.get_supported_rsc_types()

    found_nv = False
    clear_all = False
    for nv_xml_node in rsc_xml.getElementsByTagName("nvpair"):
        if nv_xml_node.getAttribute("name") != metaattr_name:
            continue
        target_rsc = nv_xml_node
        while target_rsc.tagName not in supported_rsc_types:
            target_rsc = target_rsc.parentNode

        target_rsc_id = target_rsc.getAttribute("id")

        if target_rsc_id == real_rsc_id:
            found_nv = True
            nv_xml_node.setAttribute("value", target_role)
        elif not clear_all:
            nv_xml_node.parentNode.removeChild(nv_xml_node)
            clear_all = True
        else:
            nv_xml_node.parentNode.removeChild(nv_xml_node)

    if not found_nv:
        (parent_xml_node, add_obj_type, new_mid_elem) = manager.real_add_obj_type(rsc_xml, "meta_attributes", True)
        if parent_xml_node is None:  # XML processing error
            return {'action': False, 'error': _("Cannot find the %s: %s") % (_("resource"), rsc_id)}
        impl = getDOMImplementation()
        newdoc = impl.createDocument(None, "nvpair", None)
        nv = newdoc.documentElement
        parent_xml_node.appendChild(nv)
        attr_id = manager.auto_unique_id(nv, metaattr_name)
        nv.setAttribute("id", attr_id)
        nv.setAttribute("name", metaattr_name)
        nv.setAttribute("value", target_role)

    xml_str = rsc_xml.toxml().replace("\n", "")
    manager.cib_do_cmd("cib_replace\n%s\n%s" % (str(rsc_xml.tagName), str(xml_str)))
    failed_reason = manager.failed_reason
    update()
    # 休眠时间,防止状态不一致
    time.sleep(3)
    # 返回状态
    if failed_reason != "":
        return {'action': False, 'error': _(failed_reason)}
    else:
        return {'action': True, 'info': _('Action on resource success')}


def rsc_run_level(item, rsc_id):
    # item = {'rsc_id':'ip', 'node_level':[{'node':'liuming', 'level':'Master Node'},{'node':'nk-1', 'level':'Slave 1'}]}
    return set_rsc_run_level_org(item, rsc_id)


def set_rsc_run_level_org(item, rsc_id):
    location_new = {}
    node_level = item['node_level']

    xml_node = get_selected_node(rsc_id)
    if xml_node is None:
        return {'action': False, 'error': _("Cannot find the %s: %s") % (_("resource"), str(rsc_id))}

    mainnode = mainnode_level(xml_node)
    location_ids = mainnode.location_ids
    location = mainnode.location

    for node in node_level:
        location_new[node['node']] = web_manager.turn_level_to_score(node['level'])

    xml_constraints = manager.xml_nodes["cib"].getElementsByTagName("constraints")[0]
    # get old locations
    rsc_locations = {}
    rsc_location_rule = []
    for rsc_location in manager.xml_nodes["cib"].getElementsByTagName("rsc_location"):
        id = str(rsc_location.getAttribute("id"))
        if id in location_ids.keys():
            if location_ids[id] not in rsc_locations.keys():
                rsc_locations[location_ids[id]] = []
            rsc_locations[location_ids[id]].append(rsc_location)
        else:
            con_rule = False
            rsc_location_new = rsc_location.cloneNode(True)

            for rule in rsc_location.getElementsByTagName("rule"):
                id = str(rule.getAttribute("id"))
                if id in location_ids.keys():
                    if location_ids[id] not in rsc_locations.keys():
                        rsc_locations[location_ids[id]] = []
                    # if not con_rule :
                    rsc_locations[location_ids[id]].append(rsc_location)
                    con_rule = True

            if con_rule:
                for rule in rsc_location_new.getElementsByTagName("rule"):
                    id = str(rule.getAttribute("id"))
                    key = location_ids[rule.getAttribute("id")]
                    if key in location.keys() and key in location_new.keys():
                        if location[key] == location_new[key]:
                            continue
                        if location[key] in ['INFINITY', '+INFINITY', "infinity", "+infinity"]:
                            if location_new[key] in ['INFINITY', '+INFINITY', "infinity", "+infinity"]:
                                continue
                        if location[key] in ['-INFINITY', "-infinity"]:
                            if location_new[key] in ['-INFINITY', "-infinity"]:
                                continue
                    if id in location_ids.keys():
                        rsc_location_new.removeChild(rule)

                if len(rsc_location_new.getElementsByTagName("rule")) > 0:
                    rsc_location_rule.append(rsc_location_new)

    for key in mainnode.nodes:  # location.keys():
        if key in location.keys() and key in location_new.keys():
            if location[key] == location_new[key]:
                continue
            if location[key] in ['INFINITY', '+INFINITY', "infinity", "+infinity"]:
                if location_new[key] in ['INFINITY', '+INFINITY', "infinity", "+infinity"]:
                    continue

            if location[key] in ['-INFINITY', "-infinity"]:
                if location_new[key] in ['-INFINITY', "-infinity"]:
                    continue
        if key in rsc_locations.keys():
            for loc in rsc_locations[key]:
                if loc.getAttribute('id').startswith('cli-prefer-'):
                    continue
                try:
                    xml_constraints.removeChild(loc)
                except:
                    continue

        if key in location_new.keys():
            impl = getDOMImplementation()
            newdoc = impl.createDocument(None, "rsc_location", None)
            loc = newdoc.documentElement
            loc.setAttribute("id", str("%s-location-on-%s" % (rsc_id, key)))
            loc.setAttribute("node", str(key))
            loc.setAttribute("rsc", str(rsc_id))
            loc.setAttribute("score", str(location_new[key]))
            xml_constraints.appendChild(loc)

    for loc in rsc_location_rule:
        xml_constraints.appendChild(loc)

    xml_str = xml_constraints.toxml().replace("\n", "")
    manager.cib_do_cmd("cib_replace\n%s\n%s" % (str("constraints"), str(xml_str)))
    failed_reason = manager.failed_reason
    update()

    if failed_reason != "":
        return {'action': False, 'error': _(failed_reason)}

    return {'action': True, 'info': _('Set run level success')}


def set_colocation(data, rsc_id):

    item = set_colocation_format(data, rsc_id)
    return set_colocation_org(item, rsc_id)


def set_colocation_org(item, rsc_id):
    xml_constraints = manager.xml_nodes["cib"].getElementsByTagName("constraints")[0]
    nodes = manager.xml_nodes["cib"].getElementsByTagName('rsc_colocation')
    if manager.failed_reason != "":
        return {'action': False, 'error': _(manager.failed_reason)}
    for node in nodes:
        first_rsc_id = node.getAttribute("rsc")
        with_rsc_id = node.getAttribute('with-rsc')
        if first_rsc_id == rsc_id or with_rsc_id == rsc_id:
            xml_constraints.removeChild(node)

    for node in item['same_node']:
        impl = getDOMImplementation()
        newdoc = impl.createDocument(None, "rsc_colocation", None)
        colocation = newdoc.documentElement
        colocation.setAttribute("id", str("colocation-%s-with-%s" % (node['rsc'], node['with_rsc'])))
        colocation.setAttribute("rsc", str(node['rsc']))
        colocation.setAttribute("with-rsc", str(node['with_rsc']))
        colocation.setAttribute('score', str('INFINITY'))
        xml_constraints.appendChild(colocation)

    for node in item['diff_node']:
        impl = getDOMImplementation()
        newdoc = impl.createDocument(None, "rsc_colocation", None)
        colocation = newdoc.documentElement
        colocation.setAttribute("id", str("colocation-%s-with-%s" % (node['rsc'], node['with_rsc'])))
        colocation.setAttribute("rsc", str(node['rsc']))
        colocation.setAttribute("with-rsc", str(node['with_rsc']))
        colocation.setAttribute('score', str('-INFINITY'))
        xml_constraints.appendChild(colocation)

    xml_str = xml_constraints.toxml().replace("\n", "")
    manager.cib_do_cmd("cib_replace\n%s\n%s" % (str("constraints"), str(xml_str)))
    failed_reason = manager.failed_reason
    update()

    if failed_reason != "":
        return {'action': False, 'error': _(failed_reason)}
    else:
        return {'action': True, 'info': _('Set colocation success')}


def set_order(data, rsc_id):
    item = set_order_format(data, rsc_id)
    ret = set_order_org(item, rsc_id)
    return ret


def set_order_org(item, rsc_id):
    xml_constraints = manager.xml_nodes["cib"].getElementsByTagName("constraints")[0]
    nodes = manager.xml_nodes["cib"].getElementsByTagName('rsc_order')
    if manager.failed_reason != "":
        return {'action': False, 'error': _(manager.failed_reason)}
    for node in nodes:
        first_rsc_id = node.getAttribute("first")
        then_rsc_id = node.getAttribute('then')
        if first_rsc_id == rsc_id or then_rsc_id == rsc_id:
            xml_constraints.removeChild(node)

    for node in item['before_rscs']:
        impl = getDOMImplementation()
        newdoc = impl.createDocument(None, "rsc_order", None)
        order = newdoc.documentElement
        order.setAttribute("id", str("order-%s-after-%s" % (node['rsc_id'], rsc_id)))
        order.setAttribute("first", str(node['rsc_id']))
        order.setAttribute("then", str(rsc_id))
        xml_constraints.appendChild(order)

    for node in item['after_rscs']:
        impl = getDOMImplementation()
        newdoc = impl.createDocument(None, "rsc_order", None)
        order = newdoc.documentElement
        order.setAttribute("id", str("order-%s-after-%s" % (rsc_id, node['rsc_id'])))
        order.setAttribute("then", str(node['rsc_id']))
        order.setAttribute("first", str(rsc_id))
        xml_constraints.appendChild(order)

    xml_str = xml_constraints.toxml().replace("\n", "")
    manager.cib_do_cmd("cib_replace\n%s\n%s" % (str("constraints"), str(xml_str)))
    failed_reason = manager.failed_reason
    update()

    if failed_reason != "":
        return {'action': False, 'error': _(failed_reason)}
    else:
        return {'action': True, 'info': _('Set order success')}


def get_all_rsc_avail():

    ret_class = {}
    classes = manager.get_rsc_classes()
    for cl in classes:
        ra_list = manager.get_rsc_types(cl)
        if ra_list is not None:
            ra_list.sort()
        provider_list = []
        if cl == "ocf" and ra_list is not None:
            ret_provider = {}
            for ra in ra_list:
                provider_list = manager.get_rsc_providers(cl, ra)
                if provider_list is None:
                    break
                for provider in provider_list:
                    if provider in ret_provider.keys():
                        ret_provider[provider].append(ra)
                    else:
                        ret_provider[provider] = []
                        ret_provider[provider].append(ra)
            ret_class['ocf'] = ret_provider
        elif cl == 'heartbeat':
            continue
        else:
            ret_class[cl] = ra_list

    return {'action': True, 'data': ret_class}


def dict_del_at(data):
    s = str(data).replace("\"@", "\"")
    data = eval(s)
    s = str(data).replace("'@", "'")
    data = eval(s)
    s = re.sub(r"'op': {(.*?)}}", lambda m: "'op':[{" + m.group(1) + "}]}", str(data))
    data = eval(s)
    s = re.sub(r"'nvpair': {(.*?)}}", lambda m: "'nvpair':[{" + m.group(1) + "}]}", str(data))
    data = eval(s)
    return data


def get_selected_node(rsc_id):
    for type in ['primitive', 'group', 'clone', 'master']:
        xml_node = manager.xml_nodes["cib"].getElementsByTagName(type)
        for node in xml_node:
            if node.getAttribute('id') == rsc_id:
                return node
    return None


def single_rsc_get_info(rsc_id):

    xml_node = get_selected_node(rsc_id)
    if xml_node is None:
        return {'action': False, 'error': _("Cannot find the %s: %s") % (_("resource"), str(rsc_id))}
    '''
    if xml_node.tagName == "group":
        order = 1
        for node in xml_node.getElementsByTagName('primitive'):
            node.setAttribute('order', str(order))
            order = order + 1
        if order <= 2:
            return {'action': False, 'error': _('cannot edit resource %s') % (rsc_id)}
    '''
    data = dict_del_at(json.dumps(xmltodict.parse(xml_node.toxml())))
    # data = re.sub(r"'primitive': {(.*?)}}",lambda m: "'primitive':[{" + m.group(1) + "}]}",str(data))
    return {'action': True, 'data': data}


def get_meta_attributes_options():
    common_options = [("priority", [], _(
        "If not all resources can be active, the cluster will stop lower priority resources in order to keep higher priority ones active.")),
                      ("target-role", [["Stopped", _("[ default ]")], ["Started", ""]],
                       _("What state should the cluster attempt to keep this resource in?")), (
                          "is-managed", [["true", _("[ default ]")], ["false", ""]],
                          _("Is the cluster allowed to start and stop the resource?"))]

    primitive_options = [("resource-stickiness", [], _(
        "How much does the resource prefer to stay where it is? Defaults to the value of \"default-resource-stickiness\"")),
                         ("migration-threshold", [], _(
                             "How many failures should occur for this resource on a node before making the node ineligible to host this resource. Default: \"none\"")),
                         ("multiple-active", [["stop_start", _("[ default ]")], ["stop_only", ""],
                                              ["block", _("(mark the resource as unmanaged)")]],
                          _("What should the cluster do if it ever finds the resource active on more than one node.")),
                         ("failure-timeout", [], _(
                             "How many seconds to wait before acting as if the failure had not occurred (and potentially allowing the resource back to the node on which it failed. Default: \"never\"")),
                         ("allow-migrate", [["false", _("[ default ]")], ["true", ""]],
                          _("Allow resource migration for resources which support migrate_to/migrate_from actions"))]
    clone_basic_options = [("clone-max", [], _(
        "How many copies of the resource to start. Defaults to the number of nodes in the cluster.")), (
                               "clone-node-max", [["1", _("[ default ]")]],
                               _("How many copies of the resource can be started on a single node.")), ]
    clone_other_options = [("notify", [["false", _("[ default ]")], ["true", ""]], _(
        "When stopping or starting a copy of the clone, tell all the other copies beforehand and when the action was successful.")),
                           ("globally-unique", [["false", _("[ default ]")], ["true", ""]],
                            _("Does each copy of the clone perform a different function?")), (
                               "ordered", [["false", _("[ default ]")], ["true", ""]],
                               _("Should the copies be started in series (instead of in parallel)")), (
                               "interleave", [["false", _("[ default ]")], ["true", ""]], _(
                                   "Changes the behavior of ordering constraints (between clones/masters) so that instances can start/stop as soon as their peer instance has (rather than waiting for every instance of the other clone has)."))]

    master_basic_options = [("master-max", [["1", _("[ default ]")]],
                             _("How many copies of the resource can be promoted to master status.")), (
                                "master-node-max", [["1", _("[ default ]")]],
                                _(
                                    "How many copies of the resource can be promoted to master status on a single node."))]

    # neoshineha add
    master_other_options = [("notify", [["1", _("[ default ]")], ["true", ""]], _(
        "When stopping or starting a copy of the clone, tell all the other copies beforehand and when the action was successful.")),
                            ("globally-unique", [["false", _("[ default ]")], ["true", ""]],
                             _("Does each copy of the clone perform a different function?")), (
                                "ordered", [["false", _("[ default ]")], ["true", ""]],
                                _("Should the copies be started in series (instead of in parallel)")), (
                                "interleave", [["false", _("[ default ]")], ["true", ""]], _(
                                    "Changes the behavior of ordering constraints (between clones/masters) so that instances can start/stop as soon as their peer instance has (rather than waiting for every instance of the other clone has)."))]
    # neoshineha
    meta_attributes_options = {"primitive": common_options + primitive_options,
                               "template": common_options + primitive_options, "group": common_options,
                               "clone": common_options + clone_basic_options + clone_other_options,
                               "master": common_options + clone_basic_options + master_basic_options + master_other_options,
                               "rsc_defaults": common_options + primitive_options, }
    meta_attributes = []
    for key in meta_attributes_options.keys():
        single_type_attr = {}
        single_type_attr['type'] = key
        single_type_attr['options'] = []
        for option in meta_attributes_options.get(key, []):
            op = {}
            op["name"] = option[0]
            op["values"] = []
            op["desc"] = option[2]
            values = option[1]
            for v in values:
                if v[1] == _("[ default ]"):
                    op["values"].append({"value": v[0], "is_default": True})
                else:
                    op["values"].append({"value": v[0], "is_default": False})
            single_type_attr["options"].append(op)
        meta_attributes.append(single_type_attr)
    return {'action': True, 'data': meta_attributes}


def get_single_rsc_status(rsc_id):

    if rsc_id not in manager.get_all_rsc():
        return {'action': False, 'error': _("Cannot find the %s: %s") % (_("resource"), rsc_id)}
    return {'action': True, 'data': get_sub_rsc_status(rsc_id)}


def get_sub_rsc_status(rsc_id, on_node=False):
    '''infos = {
          0:_('Running'),
          1:_('Not Running'),
          2:_('Unmanaged'),
          3:_('Failed'),
          4:_('Stop Failed'),
          5:_('running (Master)'),
          6:_('running (Slave)')}'''

    infos = {
        0: ('Running'),
        1: ('Not Running'),
        2: ('Unmanaged'),
        3: ('Failed'),
        4: ('Stop Failed'),
        5: ('running (Master)'),
        6: ('running (Slave)')}
    # manager.update()
    one_rsc_status = {}
    type = manager.get_rsc_type(rsc_id)
    one_rsc_status['style'] = type
    if type == "master" and on_node:
        one_rsc_status['style'] = "primitive"

    if type in ["group", "clone", "master"]:
        # if type in ["group","clone"]:
        one_rsc_status['rsc_id'] = rsc_id  # .split(":")[0]
        if not on_node:
            if type in ["group"]:
                one_rsc_status['rsc_status'] = "Running"
            else:
                one_rsc_status['rsc_status'] = "Not Running"
        else:
            one_rsc_status['run_node'] = []
            run_node_status = {}

        subrscs = manager.get_sub_rsc(rsc_id)
        one_rsc_status['subrscs'] = []
        for rsc in subrscs:
            sub_rsc_status = {}
            # real_rsc_id = rsc.split(":")[0]
            sub_rsc_status = get_sub_rsc_status(rsc, on_node)
            if 'rsc_id' not in sub_rsc_status.keys():
                continue
            if not on_node:
                if type in ["group"]:
                    if sub_rsc_status['rsc_status'] not in ['running', 'Running', 'running (Master)']:
                        one_rsc_status['rsc_status'] = sub_rsc_status['rsc_status']
                else:
                    if sub_rsc_status['rsc_status'] in ['running', 'Running', 'running (Master)', 'running (Slave)']:
                        one_rsc_status['rsc_status'] = "Running"
                    elif sub_rsc_status['rsc_status'] in ['failed', 'Failed']:
                        one_rsc_status['rsc_status'] = infos[3]
                    elif sub_rsc_status['rsc_status'] in ['stop failed', 'Stop Failed']:
                        one_rsc_status['rsc_status'] = infos[4]
                    elif sub_rsc_status['rsc_status'] in ['unmanaged', 'Unmanaged']:
                        one_rsc_status['rsc_status'] = infos[2]

            else:
                all_nodes = manager.get_all_nodes()
                if all_nodes is not None:
                    all_nodes.sort()
                if type in ["group"]:
                    for node in all_nodes:
                        if node not in run_node_status.keys():
                            run_node_status[node] = "Running"
                        for status in sub_rsc_status['run_node']:
                            if status['node'] == node:
                                if status['status'] not in ['running', 'Running', 'running (Master)',
                                                            'running (Slave)']:
                                    run_node_status[node] = status['status']
                else:
                    for node in all_nodes:
                        if node not in run_node_status.keys():
                            run_node_status[node] = "Not Running"
                        for status in sub_rsc_status['run_node']:
                            if status['node'] == node:
                                if status['status'] in ['running', 'Running', 'running (Master)', 'running (Slave)']:
                                    run_node_status[node] = "Running"
                                elif status['status'] in ['failed', 'Failed']:
                                    run_node_status[node] = infos[3]
                                elif status['status'] in ['stop failed', 'Stop Failed']:
                                    run_node_status[node] = infos[4]
                                elif status['status'] in ['unmanaged', 'Unmanaged']:
                                    run_node_status[node] = infos[2]

            one_rsc_status['subrscs'].append(sub_rsc_status)
            # if not on_node and sub_rsc_status["rsc_status"] != "running":
            #    one_rsc_status['rsc_status'] = sub_rsc_status["rsc_status"]

        if not on_node:
            if one_rsc_status['rsc_status'] in ["running", "Running"]:
                one_rsc_status['running_node'] = manager.get_rsc_running_on(rsc_id)
            else:
                one_rsc_status['running_node'] = []
        else:
            for node in run_node_status.keys():
                run_node = {}
                run_node['node'] = node
                run_node['status'] = run_node_status[node]
                one_rsc_status['run_node'].append(run_node)


    elif type in ["primitive"]:
        real_rsc_id = rsc_id.split(":")[0]
        node_info = manager.get_rsc_info(real_rsc_id)
        if node_info is not None and len(node_info) > 0:
            one_rsc_status['rsc_id'] = rsc_id
            one_rsc_status['rsc_type'] = node_info[1]
            if not on_node:
                # status = manager.get_rsc_status(rsc_id)[0]
                status = infos[judge_rsc_status_1(rsc_id)]
                if status in ["Running", "running", "running (Master)", 'running (Slave)']:
                    one_rsc_status['rsc_status'] = infos[0]
                    one_rsc_status['running_node'] = manager.get_rsc_running_on(rsc_id)
                elif status in ['Not Running', 'not running']:
                    one_rsc_status['rsc_status'] = infos[1]
                    one_rsc_status['running_node'] = []
                elif status in ['Failed', 'failed']:
                    one_rsc_status['rsc_status'] = infos[3]
                    one_rsc_status['running_node'] = []
                elif status in ['Stop Failed', 'stop failed']:
                    one_rsc_status['rsc_status'] = infos[4]
                    one_rsc_status['running_node'] = []
                else:
                    one_rsc_status['rsc_status'] = infos[2]
                    one_rsc_status['running_node'] = manager.get_rsc_running_on(rsc_id)
                    # one_rsc_status['running_node'] = []
            else:
                all_nodes = manager.get_all_nodes()
                if all_nodes is not None:
                    all_nodes.sort()
                one_rsc_status['run_node'] = {}
                for node in all_nodes:
                    # one_rsc_status['running_node'][node] = infos[judge_rsc_status(rsc_id,node, type)]
                    run_node = {}
                    run_node['node'] = node
                    run_node['status'] = infos[judge_rsc_status(rsc_id, node, type)]
                    one_rsc_status['run_node'].append(run_node)

    return one_rsc_status


def get_rsc_info(rsc_id):

    real_rsc_id = rsc_id.split(":")[0]
    # all_rsc_status = get_all_rsc_status()
    all_rsc_status = get_single_rsc_status(real_rsc_id)
    if not json.loads(all_rsc_status)['action']:
        return all_rsc_status
    meta_attributes_options = get_meta_attributes_options()
    if not json.loads(meta_attributes_options)['action']:
        return meta_attributes_options
    rsc_info = single_rsc_get_info(real_rsc_id)  # get_rsc_info/a
    if not json.loads(rsc_info)['action']:
        return rsc_info

    # order = get_order(real_rsc_id)
    # if not json.loads(order)['action']:
    #    return order
    # colocation = get_colocation(real_rsc_id)
    # if not json.loads(colocation)['action']:
    #    return colocation
    # location = rsc_get_run_level(real_rsc_id) #get_run_level/a
    # if not json.loads(location)['action']:
    #    return location

    if manager.get_rsc_type(real_rsc_id) in ["primitive"]:
        all_avail = get_all_rsc_avail()  # /rsc/all_avail
        if not json.loads(all_avail)['action']:
            return all_avail
        else:
            # return json.dumps({'action':True,'data':{'all_rsc_status':json.loads(all_rsc_status)['data'], 'meta_attributes_options':json.loads(meta_attributes_options)['data'], 'rsc_info':json.loads(rsc_info)['data'], 'order':json.loads(order)['data'], 'colocation':json.loads(colocation)['data'], 'location':json.loads(location)['data'], 'all_avail':json.loads(all_avail)['data']}})
            return {'action': True, 'data': {'all_rsc_status': json.loads(all_rsc_status)['data'],
                                             'meta_attributes_options': json.loads(meta_attributes_options)[
                                                 'data'], 'rsc_info': json.loads(rsc_info)['data'],
                                             'all_avail': json.loads(all_avail)['data']}}

    return {'action': True, 'data': {'all_rsc_status': json.loads(all_rsc_status)['data'],
                                     'meta_attributes_options': json.loads(meta_attributes_options)['data'],
                                     'order': json.loads(order)['data'],
                                     'colocation': json.loads(colocation)['data'],
                                     'location': json.loads(location)['data'],
                                     'rsc_info': json.loads(rsc_info)['data']}}


def cib_update():
    manager.process_event("evt:cib_changed")
    manager.update()


def get_all_migrate_rscs():

    rsc_locations = {}
    for rsc_location in manager.xml_nodes["cib"].getElementsByTagName("rsc_location"):
        id = str(rsc_location.getAttribute("id"))
        rsc_locations[id] = rsc_location
    migrate_ids = {}
    rsc_ids = []
    for id in rsc_locations:
        for prefix in ["cli-prefer-", "cli-standby-"]:
            if id.startswith(prefix):
                split_id = id.split(prefix)
                if len(split_id) > 1:
                    rsc_id = split_id[1]
                    if not rsc_id in migrate_ids:
                        migrate_ids[rsc_id] = []
                    migrate_ids[rsc_id].append(id)
    rsc_list = []
    rsc_list = migrate_ids.keys()[:]
    return rsc_list


class mainnode_level:
    def judge_node_status(self, node):
        if manager.get_nodetype(node) == 'ping':
            return -1

        started = manager.get_crm_nodes()
        if node not in started:
            if manager.get_nodetype(node) == "normal":
                return 3

        active_nodes = manager.get_active_nodes()
        if node not in active_nodes:
            try:
                if manager.get_node_config(node).get("standby") == "True":
                    return 5
                else:
                    return 3
            except:
                return 3

        dc = manager.get_dc()
        if dc is None or dc == []:
            return 1
        if node in dc:
            if manager.get_node_config(node).get("standby") == "True":
                return 4
            return 0
        if manager.get_node_config(node).get("standby") == "True":
            return 2

        return 1

    def level_init(self):
        self.level_score_new = []  # list(self.level_score)
        max = len(self.nodes) - 1
        for i in range(max):
            self.level_score_new.append(str(16000 - 1000 * i))

        self.save_level()
        return

    def data_init(self, rsc):
        self.level_score = []
        self.xml_level = manager.xml_nodes["cib"].getElementsByTagName("heartbeatlevel")
        if self.xml_level != []:
            for level in self.xml_level[0].getElementsByTagName('nvpair'):
                if level.nodeType != xml.dom.Node.ELEMENT_NODE:
                    continue
                self.level_score.append(level.getAttribute('value'))

        if len(self.level_score) < len(self.nodes) - 1:
            self.level_init()

        self.level_score.sort()
        self.level_score.reverse()

        '''self.is_callback = True
        self.xml_callback = None
        for meta_attributes_node in self.xml_node.getElementsByTagName("meta_attributes") :
                for nv_xml_node in meta_attributes_node.getElementsByTagName("nvpair") :
                        if nv_xml_node.getAttribute("name") == "resource-stickiness":
                                self.xml_callback = nv_xml_node
                                if nv_xml_node.getAttribute("value") in ["INFINITY", "+INFINITY", "infinity", "+infinity"]:
                                        self.is_callback = False
                                break
        self.is_callback_new = self.is_callback

        self.is_monitor = False
        self.xml_monitor = None
        for meta_attributes_node in self.xml_node.getElementsByTagName("operations") :
                for nv_xml_node in meta_attributes_node.getElementsByTagName("op") :
                        if nv_xml_node.getAttribute("name") == "monitor":
                                self.is_monitor = True
                                self.xml_monitor = nv_xml_node
                                if nv_xml_node.getAttribute("enabled") == "false" :
                                        self.is_monitor = False
                                break
        self.is_monitor_new = self.is_monitor'''

        location = {}
        colocation = {}
        self.location_ids = {}
        self.colocation_ids = {}

        constraints = manager.xml_nodes["cib"].getElementsByTagName('constraints')[0]
        ############location############
        for loc in constraints.getElementsByTagName('rsc_location'):
            if loc.getAttribute('id').startswith('cli-prefer-'):
                continue
            node = loc.getAttribute('node')
            rsc_id = loc.getAttribute('rsc')
            if rsc_id != rsc:
                continue
            score = loc.getAttribute('score')
            if node in location.keys():
                location[node] = web_manager.add_score(score, location[node])
            else:
                location[node] = str(score)
            self.location_ids[loc.getAttribute('id')] = str(node)

        '''constraints = manager.do_cmd("get_rsc_constraints\n%s"%(rsc))
        while constraints is None:
                constraints = manager.do_cmd("get_rsc_constraints\n%s"%(rsc))

        for cons in constraints :
                #m = re.match('^.*\'(.*)\':(.*)=(.*)$', cons)
                m = re.match('^\s*:\sNode\s(.*)\s*\(score=(.*)\,\sid=(.*)\)', cons)
                if m is not None : #location
                        node = m.groups()[0].strip()
                        score = m.groups()[1].strip()
                        if score in ["INFINITY", "+INFINITY", "infinity", "+infinity"]:
                                continue
                        if node in location.keys():
                                location[node] = web_manager.add_score(score, location[node])
                        else:
                                location[node] = str(score)
                        self.location_ids[str(m.groups()[2].strip())] = str(node)
                else : #colocation
                        m = re.match('^(.*)\s*\(score=(.*)\,\sid=(.*)\)', cons)
                        if m is None:
                                continue
                        rsc = m.groups()[0].strip()
                        score = m.groups()[1].strip()
                        if rsc in colocation.keys():
                                colocation[rsc] = web_manager.add_score(score, colocation[rsc])
                        else:
                                colocation[rsc] = str(score)
                        self.colocation_ids[str(m.groups()[2].strip())] = str(rsc)'''

        self.back_node_list = {}
        self.no_run_node_list = []
        self.main_node = ""
        self.same_node_rsc_list = []
        self.other_rsc_list = []
        self.location = {}
        self.colocation = {}

        # colocation
        '''for rsc in self.resources:
                self.other_rsc_list.append(rsc)

        for key in colocation.keys() :
                self.colocation[key] = colocation[key]
                if colocation[key] in ["INFINITY", "+INFINITY", "infinity", "+infinity"]:
                        self.same_node_rsc_list.append(key)
                        if key in self.other_rsc_list:
                                self.other_rsc_list.remove(key)'''

        # location
        for node in self.nodes:
            self.no_run_node_list.append(node)

        for key in location.keys():
            self.no_run_node_list.remove(key)
            self.back_node_list[key] = location[key]
            self.location[key] = location[key]
        # if "false" not in manager.do_cmd("system\n%s"%("crm_attribute -G -n symmetric-cluster -Q")) :
        #        self.widget_other_node_label.set_text(_("This is Symmetric Cluster. The resources can also run on other nodes are not configured:"))
        # else:
        #        self.widget_other_node_label.set_text(_("This is Non-symmetric Cluster. The resources can not run on other nodes are not configured:"))

        self.main_node_new = self.main_node
        self.no_run_node_list_new = list(self.no_run_node_list)

    def save_level(self):
        if self.level_score == self.level_score_new:
            return
        impl = getDOMImplementation()
        if self.level_score == []:
            newdoc = impl.createDocument(None, "heartbeatlevel", None)
            xml_node = newdoc.documentElement
            newdoc = impl.createDocument(None, "meta_attributes", None)
            meta_attribute = newdoc.documentElement
            meta_attribute.setAttribute('id', "heartbeatlevel-options")
            xml_node.appendChild(meta_attribute)
        else:
            xml_node = self.xml_level[0]
            meta_attribute = xml_node.getElementsByTagName("meta_attributes")[0]
            for child in meta_attribute.childNodes:
                if child.nodeType != xml.dom.Node.ELEMENT_NODE:
                    continue
                meta_attribute.removeChild(child)

        level = 1
        for score in self.level_score_new:
            newdoc = impl.createDocument(None, "nvpair", None)
            nv = newdoc.documentElement
            meta_attribute.appendChild(nv)
            nv.setAttribute("id", str("heartbeatlevel-options-level%d" % (level)))
            nv.setAttribute("name", str("level%d" % (level)))
            nv.setAttribute("value", score)
            level = level + 1
        if self.level_score == []:
            xml_str = xml_node.toxml().replace("\n", "")
            manager.cib_do_cmd("cib_create\n%s\n%s" % (str("configuration"), str(xml_str)))
        elif self.level_score_new == []:
            xml_str = self.xml_level[0].toxml().replace("\n", "")
            manager.cib_do_cmd("cib_delete\n%s\n%s" % ("", str(xml_str)))
        else:
            xml_str = xml_node.toxml().replace("\n", "")
            manager.cib_do_cmd("cib_replace\n%s\n%s" % (str("heartbeatlevel"), str(xml_str)))

        if manager.failed_reason != "":
            syslog.syslog(manager.failed_reason)
            return

        self.level_score = self.level_score_new

    def __init__(self, xml_node):
        self.xml_node = xml_node
        self.rsc = str(xml_node.getAttribute('id'))

        nodes_normal = manager.get_normal_nodes()
        if nodes_normal is not None:
            nodes_normal.sort()

        self.nodes = []
        for node in nodes_normal:
            # status = self.judge_node_status(node)
            # if status == -1:
            #    continue
            if manager.get_nodetype(node) == 'ping':
                continue
            self.nodes.append(node)

        self.resources = []
        for r in manager.get_top_rsc():
            if manager.get_rsc_type(r) == "master":
                continue
            if r != self.rsc:
                self.resources.append(r)
        self.data_init(self.rsc)


if __name__ == '__main__':
    #get_all_rsc_status_constraints()
    #supported_rsc_types = manager.get_supported_rsc_types()
    get_meta_attributes_options()
    #print get_all_node_status()
